﻿using Grayscale.P003_Log________.L___500_Struct;
using System;
using System.Collections.Generic;

namespace Grayscale.P003_Log________.L500____Struct
{


    /// <summary>
    /// ************************************************************************************************************************
    /// オワタ大臣
    /// ************************************************************************************************************************
    /// 
    /// エラー・ハンドラーを集中管理します。
    /// 
    /// partial … ロガー定数を拡張できるクラスとして開放。
    /// </summary>
    public partial class OwataMinister
    {
        //public static readonly KwErrorHandler OWATA_SASITE_SEISEI_ROUTINE = new ErrorHandlerImpl(true,new LarabeLoggerImpl("../../Logs/_log_指し手生成ルーチン", ".txt", true, false));
        public static readonly KwErrorHandler BY_GUI = new ErrorHandlerImpl( new KwLoggerImpl("../../Logs/_log_将棋GUI_棋譜読取", ".txt", true, false));
        public static readonly KwErrorHandler BY_SERVER = new ErrorHandlerImpl(new KwLoggerImpl("../../Logs/_log_将棋Server_棋譜読取", ".txt", true, false));
        //public static readonly KwErrorHandler OWATA_BY_LARABE_STANDALONE = new ErrorHandlerImpl(true,new LarabeLoggerImpl("../../Logs/_log_ララベProgram", ".txt", true, false));
        //public static readonly KwErrorHandler OWATA_LINKED_LIST = new ErrorHandlerImpl(true, new LarabeLoggerImpl("../../Logs/_log_リンクトリスト", ".txt", false, false));
        public static readonly KwErrorHandler ERROR = new ErrorHandlerImpl( new KwLoggerImpl("../../Logs/_log_エラー", ".txt", true, false));
        // きふならべ
        public static readonly KwErrorHandler NARABE_PAINT = new ErrorHandlerImpl(new KwLoggerImpl("../../Logs/_log_将棋GUI_ﾍﾟｲﾝﾄ", ".txt", true, false));
        public static readonly KwErrorHandler NARABE_NETWORK = new ErrorHandlerImpl(new KwLoggerImpl("../../Logs/_log_将棋GUI_ﾈｯﾄﾜｰｸ", ".txt", true, false));

        /// <summary>
        /// 棋譜学習ソフト用。
        /// </summary>
        public static readonly KwErrorHandler LEARNER = new ErrorHandlerImpl(new KwLoggerImpl("../../Logs/_log_棋譜学習ソフト用", ".txt", true, false));

        /// <summary>
        /// ログ。将棋エンジンきふわらべで汎用に使います。
        /// </summary>
        public static readonly KwErrorHandler WARABE_ENGINE = new ErrorHandlerImpl( new KwLoggerImpl("../../Logs/_log_将棋ｴﾝｼﾞﾝ_汎用", ".txt", true, false));

        /// <summary>
        /// ログ。送受信内容の記録専用です。
        /// </summary>
        public static readonly KwErrorHandler WARABE_CLIENT = new ErrorHandlerImpl(new KwLoggerImpl("../../Logs/_log_将棋ｴﾝｼﾞﾝ_ｸﾗｲｱﾝﾄ", ".txt", true, false));

        /// <summary>
        /// ログ。思考ルーチン専用です。
        /// </summary>
        public static readonly KwErrorHandler WARABE_MOUSOU_RIREKI = new ErrorHandlerImpl(new KwLoggerImpl("../../Logs/_log_将棋ｴﾝｼﾞﾝ_妄想履歴", ".txt", true, false));


        /// <summary>
        /// デフォルトのロガーリスト。
        /// </summary>
        /// <returns></returns>
        public static OwataMinister GetDefaultList()
        {
            if (null == OwataMinister.defaultList)
            {
                OwataMinister.defaultList = new OwataMinister(
                    "../../Logs/_log_default_false_(" + System.Diagnostics.Process.GetCurrentProcess() + ")",
                    ".txt",
                    false,
                    false
                    );
            }

            return OwataMinister.defaultList;
        }
        private static OwataMinister defaultList;






        /// <summary>
        /// デフォルト・ログ・ファイル
        /// </summary>
        public KwLogger DefaultFile { get { return this.defaultFile; } }
        private KwLogger defaultFile;


        /// <summary>
        /// タグの登録。リムーブに使用。
        /// </summary>
        private List<KwLogger> loggerList;


        /// <summary>
        /// コンストラクター
        /// </summary>
        /// <param name="fileNameWoe">拡張子抜きのファイル名。(with out extension)</param>
        /// <param name="extensionWd">ドット付き拡張子。(with dot)</param>
        /// <param name="enable">ログ出力のON/OFF</param>
        /// <param name="print_TimeStamp">タイムスタンプ出力のON/OFF</param>
        public OwataMinister(string defaultLogFileNameWoe, string extensionWd, bool enable, bool print_TimeStamp)
        {
            this.defaultFile = new KwLoggerImpl(defaultLogFileNameWoe, extensionWd, enable, print_TimeStamp);

            this.loggerList = new List<KwLogger>();
        }


        public void AddLogFile(KwLogger tag)
        {
            this.loggerList.Add(tag);
        }


        /// <summary>
        /// ************************************************************************************************************************
        /// ログファイルを削除します。(連番がなければ)
        /// ************************************************************************************************************************
        /// </summary>
        public void RemoveFile()
        {
            try
            {
                System.IO.File.Delete(this.defaultFile.FileName);

                foreach (KwLogger tag in this.loggerList)
                {
                    System.IO.File.Delete(tag.FileNameWoe+tag.Extension);
                }
            }
            catch (Exception ex) { OwataMinister.ERROR.DonimoNaranAkirameta(ex, "ﾛｸﾞﾌｧｲﾙ削除中☆"); throw ex; }

        }


    }
}
