﻿
namespace Grayscale.P153_KifuSfen___.L___125_Struct
{

    /// <summary>
    /// テーブル形式の局面データ。
    /// </summary>
    public interface RO_Kyokumen1
    {

        /// <summary>
        /// 将棋盤上の駒。[suji][dan]。
        /// sujiは1～9。danは1～9。0は空欄。つまり 100要素ある。
        /// 「K」「+p」といった形式で書く。(SFEN形式)
        /// </summary>
        string[][] Ban { get; set; }

        /// <summary>
        /// 先手の持ち駒の数。[0]から、飛,角,金,銀,桂,香,歩 の順。
        /// </summary>
        int[] MotiP1 { get; set; }

        /// <summary>
        /// 後手の持ち駒の数。[0]から、飛,角,金,銀,桂,香,歩 の順。
        /// </summary>
        int[] MotiP2 { get; set; }

        /// <summary>
        /// 手目済み。初期局面を 0手目済み、初手を指した後の局面を 1手目済みとカウントします。
        /// </summary>
        int Temezumi { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="white">「w」なら真、「b」なら偽。</param>
        /// <returns></returns>
        string ToSfenstring(bool white);

    }
}
