﻿using Grayscale.P153_KifuSfen___.L___125_Struct;
using Grayscale.P153_KifuSfen___.L___250_Report;
using Grayscale.P153_KifuSfen___.L___500_Write;
using Grayscale.P156_ConvSfen___.L500____Converter;
using Grayscale.P157_SfenReport_.L500____Struct;
using Grayscale.P158_LogKyokuPng.L250____Paint;
using System.Drawing;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Grayscale.P158_LogKyokuPng.L500____Util
{

    /// <summary>
    /// 局面.pngを書き出します。
    /// </summary>
    public abstract class Util_KyokumenPng_Writer
    {

        /// <summary>
        /// SFEN文字列と、出力ファイル名を指定することで、局面の画像ログを出力します。
        /// </summary>
        /// <param name="sfenstring"></param>
        /// <param name="outFile"></param>
        /// <param name="reportEnvironment"></param>
        /// <returns></returns>
        public static bool Write2(
            string sfenstring,
            string relFolder,
            string outFile,
            ReportEnvironment reportEnvironment
            )
        {
            bool successful = true;


            //System.Windows.Forms.MessageBox.Show(sfenstring + "\n" + outFile, "局面PNG書き出し");

            //
            // SFEN → RO_SfenStartpos
            //
            RO_Kyokumen2 ro_SfenStartpos;
            string rest;
            if (!Conv_SfenFullString.ReadString(sfenstring, out rest, out ro_SfenStartpos))
            {
                //System.Windows.Forms.MessageBox.Show(sfenstring,"sfenstringパース失敗");
                successful = false;
                goto gt_EndMethod;
            }

            Util_KyokumenPng_Writer.Write1(
                ro_SfenStartpos.ToKyokumen1(),
                relFolder,
                outFile,
                reportEnvironment
                );

        gt_EndMethod:
            return successful;
        }

        /// <summary>
        /// 局面データと、出力ファイル名を指定することで、局面の画像ログを出力します。
        /// </summary>
        /// <param name="ro_Kyokumen1"></param>
        /// <param name="appendFilepath"></param>
        /// <param name="outFile"></param>
        /// <param name="reportEnvironment"></param>
        /// <returns></returns>
        public static bool Write1(
            RO_Kyokumen1 ro_Kyokumen1,
            string appendFilepath,
            string outFile,
            ReportEnvironment reportEnvironment
            )
        {
            bool successful = true;

            //----------------------------------------
            // ファイルに使える文字に変換
            //----------------------------------------
            appendFilepath = appendFilepath.Replace('*', '＊');
            outFile = outFile.Replace('*', '＊');

            ReportArgs args = new ReportArgsImpl(
                ro_Kyokumen1,
                outFile,
                reportEnvironment
                );

            // 局面画像を描きだします。
            Bitmap bmp = new Bitmap(
                2 * (args.Env.KmW + 2 * args.Env.SjW) + KyokumenPngPainterImpl.BN_SUJIS * args.Env.KmW + KyokumenPngPainterImpl.BN_BRD_R_W,
                KyokumenPngPainterImpl.BN_DANS * args.Env.KmH + KyokumenPngPainterImpl.BN_BRD_B_W
                );


            KyokumenPngWriter repWriter = new KyokumenPngPainterImpl();
            repWriter.Paint(Graphics.FromImage(bmp), args);


            //System.Windows.Forms.MessageBox.Show(args.Env.OutFolder + args.OutFile, "bmp.Save");
            string filepath = args.Env.OutFolder + appendFilepath + args.OutFile;
            // フォルダーが無ければ、作る必要があります。
            {
                DirectoryInfo dirInfo = Directory.GetParent(filepath);
                if (!Directory.Exists(dirInfo.FullName))
                {
                    Directory.CreateDirectory(dirInfo.FullName);
                }
            }

            try
            {
                bmp.Save(filepath);
            }
            catch (ExternalException ex)
            {
                MessageBox.Show(ex.GetType().Name + "：" + ex.Message + "\n filepath：" + filepath);
                throw ex;
            }

            return successful;
        }

    }
}
