﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P013_Collection_.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P213_Komasyurui_.L500____Util;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P234_Komahaiyaku.L250____Word;
using Grayscale.P234_Komahaiyaku.L500____Util;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P250_KomahaiyaEx.L500____Util;
using System;
using System.Diagnostics;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P258_UtilSky258_.L500____UtilSky
{
    public static class Util_Sky258A
    {

        public static readonly Starbeamable NULL_OBJECT_SASITE = new RO_Starbeam(
            new RO_Star(Playerside.Empty, Masu_Honshogi.Error, Komasyurui14.H00_Null___),
            new RO_Star(Playerside.Empty, Masu_Honshogi.Error, Komasyurui14.H00_Null___),
            null
            );





        /// <summary>
        /// ************************************************************************************************************************
        /// 含まれるか判定。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="masus"></param>
        /// <returns></returns>
        public static bool ExistsIn(Starlight sl, SySet<SyElement> masus, SkyConst src_Sky, KwErrorHandler errH)
        {
            bool matched = false;

            foreach (SyElement masu in masus.Elements)
            {
                RO_Star koma = Util_Koma.AsKoma(sl.Now);


                Finger finger = Util_Sky_FingerQuery.InShogibanMasuNow(src_Sky, koma.Pside, masu, errH);

                if (
                    finger != Fingers.Error_1  //2014-07-21 先後も見るように追記。
                    && koma.Masu == masu
                    )
                {
                    matched = true;
                    break;
                }

            }

            return matched;
        }

        /// <summary>
        /// 成ケース
        /// </summary>
        /// <returns></returns>
        public static Komasyurui14 ToNariCase(RO_Starlight ms)
        {
            Komasyurui14 result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = Util_Komasyurui14.NariCaseHandle[(int)Util_Komahaiyaku184.Syurui(koma.Haiyaku)];

            return result;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 相手陣に入っていれば真。
        /// ************************************************************************************************************************
        /// 
        ///         後手は 7,8,9 段。
        ///         先手は 1,2,3 段。
        /// </summary>
        /// <returns></returns>
        public static bool InAitejin(Starlight ms)
        {
            bool result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            int dan;
            Util_MasuNum.TryMasuToDan(koma.Masu, out dan);

            result = (Util_Sky258A.IsGote(ms) && 7 <= dan) || (Util_Sky258A.IsSente(ms) && dan <= 3);

            return result;
        }

        /// <summary>
        /// 成り
        /// </summary>
        public static bool IsNari(Starlight ms)
        {
            bool result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = Util_Komasyurui14.FlagNari[(int)Util_Komahaiyaku184.Syurui(koma.Haiyaku)];

            return result;
        }

        /// <summary>
        /// 不成
        /// </summary>
        public static bool IsFunari(RO_Starlight ms)
        {
            bool result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = !Util_Komasyurui14.FlagNari[(int)Util_Komahaiyaku184.Syurui(koma.Haiyaku)];

            return result;
        }

        public static bool IsNareruKoma(Starlight ms)
        {
            bool result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = Util_Komasyurui14.FlagNareruKoma[(int)Util_Komahaiyaku184.Syurui(koma.Haiyaku)];


            return result;
        }

        /// <summary>
        /// 外字を利用した、デバッグ用の駒の名前１文字だぜ☆
        /// </summary>
        /// <returns></returns>
        public static char ToGaiji(RO_Starlight ms)
        {
            char result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = Util_Komasyurui14.ToGaiji(Util_Komahaiyaku184.Syurui(koma.Haiyaku), koma.Pside);

            return result;
        }

        /// <summary>
        /// 不一致判定：　先後、駒種類  が、自分と同じものが　＜ひとつもない＞
        /// </summary>
        /// <returns></returns>
        public static bool NeverOnaji(Starlight ms, SkyConst src_Sky, params Fingers[] komaGroupArgs)
        {
            bool unmatched = true;

            foreach (Fingers komaGroup in komaGroupArgs)
            {
                foreach (Finger figKoma in komaGroup.Items)
                {
                    RO_Star koma1 = Util_Koma.AsKoma(ms.Now);
                    RO_Star koma2 = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);



                    if (
                            koma1.Pside == koma2.Pside // 誰のものか
                        && Util_Komahaiyaku184.Syurui(koma1.Haiyaku) == Util_Komahaiyaku184.Syurui(koma2.Haiyaku) // 駒の種類は
                        )
                    {
                        // １つでも一致するものがあれば、終了します。
                        unmatched = false;
                        goto gt_EndLoop;
                    }
                }

            }
        gt_EndLoop:

            return unmatched;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 駒台の上にあれば真。
        /// ************************************************************************************************************************
        /// </summary>
        /// <returns></returns>
        public static bool OnKomadai(RO_Starlight ms)
        {
            bool result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = (Okiba.Sente_Komadai | Okiba.Gote_Komadai).HasFlag(
                Util_Masu10.Masu_ToOkiba(koma.Masu));

            return result;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 先後一致判定。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="ms2"></param>
        /// <returns></returns>
        public static bool MatchPside(RO_Starlight ms1, RO_Starlight ms2)
        {
            bool result;

            RO_Star koma1 = Util_Koma.AsKoma(ms1.Now);
            RO_Star koma2 = Util_Koma.AsKoma(ms2.Now);


            result = koma1.Pside == koma2.Pside;

            return result;
        }

        /// <summary>
        /// 先手
        /// </summary>
        /// <returns></returns>
        public static bool IsSente(Starlight ms)
        {
            bool result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = Playerside.P1 == koma.Pside;

            return result;
        }

        /// <summary>
        /// 後手
        /// </summary>
        /// <returns></returns>
        public static bool IsGote(Starlight ms)
        {
            bool result;

            RO_Star koma = Util_Koma.AsKoma(ms.Now);

            result = Playerside.P2 == koma.Pside;

            return result;
        }



        /// <summary>
        /// “打” ＜アクション時＞
        /// </summary>
        /// <returns></returns>
        public static bool IsDaAction(Starbeamable sasite)
        {
            Debug.Assert(null!=sasite,"指し手がヌルでした。");
            bool result;

            try
            {
                RO_Star srcKoma = Util_Koma.AsKoma(sasite.LongTimeAgo);
                result = Okiba.ShogiBan != Util_Masu10.GetOkiba(srcKoma.Masu)//駒台（駒袋）から打ったとき。
                    && Okiba.Empty != Util_Masu10.GetOkiba(srcKoma.Masu);//初期配置から移動しても、打にはしません。
            }
            catch (Exception ex)
            {
                OwataMinister.ERROR.DonimoNaranAkirameta(ex, "IsDaAction:");// exceptionArea=" + exceptionArea
                throw ex;
            }

            return result;
        }



        public static bool isEnableSfen(Starbeamable sasite)
        {
            bool enable = true;

            RO_Star srcKoma = Util_Koma.AsKoma(sasite.LongTimeAgo);
            RO_Star dstKoma = Util_Koma.AsKoma(sasite.Now);


            int srcDan;
            if (!Util_MasuNum.TryMasuToDan(srcKoma.Masu, out srcDan))
            {
                enable = false;
            }

            int dan;
            if (!Util_MasuNum.TryMasuToDan(dstKoma.Masu, out dan))
            {
                enable = false;
            }

            return enable;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 元位置。
        /// ************************************************************************************************************************
        /// </summary>
        /// <returns></returns>
        public static Starbeamable Src(Starbeamable sasite)
        {
            RO_Starbeam result;


            RO_Star srcKoma = Util_Koma.AsKoma(sasite.LongTimeAgo);
            RO_Star dstKoma = Util_Koma.AsKoma(sasite.Now);


            result = new RO_Starbeam(

                new RO_Star(
                    dstKoma.Pside,
                    Masu_Honshogi.Error, // ソースのソースは未定義。
                    Komasyurui14.H00_Null___
                ),

                // ソースの目的地はソース
                new RO_Star(
                    dstKoma.Pside,
                    srcKoma.Masu,
                    srcKoma.Komasyurui
                ),

                Komasyurui14.H00_Null___
            );

            return result;
        }

        public static RO_Starbeam BuildSasite(
            Starlightable longTimeAgo,
            Starlightable now,
            Komasyurui14 tottaKomaSyurui
        )
        {
            return new RO_Starbeam(longTimeAgo, now, tottaKomaSyurui);
        }

        /// <summary>
        /// 成った
        /// </summary>
        /// <returns></returns>
        public static bool IsNatta_Sasite(Starbeamable sasite)
        {
            // 元種類が不成、現種類が成　の場合のみ真。
            bool natta = true;


            RO_Star srcKoma = Util_Koma.AsKoma(sasite.LongTimeAgo);
            RO_Star dstKoma = Util_Koma.AsKoma(sasite.Now);


            // 成立しない条件を１つでも満たしていれば、偽　確定。
            if (
                Komahaiyaku185.n000_未設定 == srcKoma.Haiyaku
                //Ks14.H00_Null == Haiyaku184Array.Syurui[(int)this.SrcHaiyaku]
                ||
                Komahaiyaku185.n000_未設定 == dstKoma.Haiyaku
                //Ks14.H15_ErrorKoma == Haiyaku184Array.Syurui[(int)this.Haiyaku]
                ||
                Util_Komasyurui14.FlagNari[(int)Util_Komahaiyaku184.Syurui(srcKoma.Haiyaku)]
                ||
                !Util_Komasyurui14.FlagNari[(int)Util_Komahaiyaku184.Syurui(dstKoma.Haiyaku)]
                )
            {
                natta = false;
            }

            return natta;
        }

        /// <summary>
        /// 移動前と、移動後の場所が異なっていれば真。
        /// </summary>
        /// <returns></returns>
        public static bool DoneMove(RO_Starbeam ss)
        {
            bool result;

            RO_Star koma1 = Util_Koma.AsKoma(ss.Now);
            RO_Star koma2 = Util_Koma.AsKoma(Util_Sky258A.Src(ss).Now);

            result = Util_Masu10.AsMasuNumber(koma1.Masu) != Util_Masu10.AsMasuNumber(koma2.Masu);

            return result;
        }

        public static void Assert_Honshogi(SkyConst src_Sky)
        {
            Debug.Assert(src_Sky.Count == 40, "siteiSky.Starlights.Count=[" + src_Sky.Count + "]");//将棋の駒の数

            ////デバッグ
            //{
            //    StringBuilder sb = new StringBuilder();

            //    for (int i = 0; i < 40; i++)
            //    {
            //        sb.Append("駒" + i + ".種類=[" + ((RO_Star_KomaKs)siteiSky.StarlightIndexOf(i).Now).Syurui + "]\n");
            //    }

            //    MessageBox.Show(sb.ToString());
            //}


            // 王
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(0).Now).Komasyurui == Komasyurui14.H06_Oh_____, "駒0.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(0).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(1).Now).Komasyurui == Komasyurui14.H06_Oh_____, "駒1.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(1).Now).Komasyurui + "]");

            // 飛車
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(2).Now).Komasyurui == Komasyurui14.H07_Hisya__ || ((RO_Star)src_Sky.StarlightIndexOf(2).Now).Komasyurui == Komasyurui14.H09_Ryu____, "駒2.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(2).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(3).Now).Komasyurui == Komasyurui14.H07_Hisya__ || ((RO_Star)src_Sky.StarlightIndexOf(3).Now).Komasyurui == Komasyurui14.H09_Ryu____, "駒3.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(3).Now).Komasyurui + "]");

            // 角
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(4).Now).Komasyurui == Komasyurui14.H08_Kaku___ || ((RO_Star)src_Sky.StarlightIndexOf(4).Now).Komasyurui == Komasyurui14.H10_Uma____, "駒4.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(4).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(5).Now).Komasyurui == Komasyurui14.H08_Kaku___ || ((RO_Star)src_Sky.StarlightIndexOf(5).Now).Komasyurui == Komasyurui14.H10_Uma____, "駒5.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(5).Now).Komasyurui + "]");

            // 金
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(6).Now).Komasyurui == Komasyurui14.H05_Kin____, "駒6.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(6).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(7).Now).Komasyurui == Komasyurui14.H05_Kin____, "駒7.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(7).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(8).Now).Komasyurui == Komasyurui14.H05_Kin____, "駒8.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(8).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(9).Now).Komasyurui == Komasyurui14.H05_Kin____, "駒9.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(9).Now).Komasyurui + "]");

            // 銀
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(10).Now).Komasyurui == Komasyurui14.H04_Gin____ || ((RO_Star)src_Sky.StarlightIndexOf(10).Now).Komasyurui == Komasyurui14.H14_NariGin, "駒10.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(10).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(11).Now).Komasyurui == Komasyurui14.H04_Gin____ || ((RO_Star)src_Sky.StarlightIndexOf(11).Now).Komasyurui == Komasyurui14.H14_NariGin, "駒11.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(11).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(12).Now).Komasyurui == Komasyurui14.H04_Gin____ || ((RO_Star)src_Sky.StarlightIndexOf(12).Now).Komasyurui == Komasyurui14.H14_NariGin, "駒12.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(12).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(13).Now).Komasyurui == Komasyurui14.H04_Gin____ || ((RO_Star)src_Sky.StarlightIndexOf(13).Now).Komasyurui == Komasyurui14.H14_NariGin, "駒13.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(13).Now).Komasyurui + "]");

            // 桂
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(14).Now).Komasyurui == Komasyurui14.H03_Kei____ || ((RO_Star)src_Sky.StarlightIndexOf(14).Now).Komasyurui == Komasyurui14.H13_NariKei, "駒14.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(14).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(15).Now).Komasyurui == Komasyurui14.H03_Kei____ || ((RO_Star)src_Sky.StarlightIndexOf(15).Now).Komasyurui == Komasyurui14.H13_NariKei, "駒15.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(15).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(16).Now).Komasyurui == Komasyurui14.H03_Kei____ || ((RO_Star)src_Sky.StarlightIndexOf(16).Now).Komasyurui == Komasyurui14.H13_NariKei, "駒16.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(16).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(17).Now).Komasyurui == Komasyurui14.H03_Kei____ || ((RO_Star)src_Sky.StarlightIndexOf(17).Now).Komasyurui == Komasyurui14.H13_NariKei, "駒17.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(17).Now).Komasyurui + "]");

            // 香
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(18).Now).Komasyurui == Komasyurui14.H02_Kyo____ || ((RO_Star)src_Sky.StarlightIndexOf(18).Now).Komasyurui == Komasyurui14.H12_NariKyo, "駒18.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(18).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(19).Now).Komasyurui == Komasyurui14.H02_Kyo____ || ((RO_Star)src_Sky.StarlightIndexOf(19).Now).Komasyurui == Komasyurui14.H12_NariKyo, "駒19.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(19).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(20).Now).Komasyurui == Komasyurui14.H02_Kyo____ || ((RO_Star)src_Sky.StarlightIndexOf(20).Now).Komasyurui == Komasyurui14.H12_NariKyo, "駒20.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(20).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(21).Now).Komasyurui == Komasyurui14.H02_Kyo____ || ((RO_Star)src_Sky.StarlightIndexOf(21).Now).Komasyurui == Komasyurui14.H12_NariKyo, "駒21.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(21).Now).Komasyurui + "]");

            // 歩
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(22).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(22).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒22.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(22).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(23).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(23).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒23.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(23).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(24).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(24).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒24.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(24).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(25).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(25).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒25.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(25).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(26).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(26).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒26.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(26).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(27).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(27).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒27.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(27).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(28).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(28).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒28.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(28).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(29).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(29).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒29.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(29).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(30).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(30).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒30.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(30).Now).Komasyurui + "]");

            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(31).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(31).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒31.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(31).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(32).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(32).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒32.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(32).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(33).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(33).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒33.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(33).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(34).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(34).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒34.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(34).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(35).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(35).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒35.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(35).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(36).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(36).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒36.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(36).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(37).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(37).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒37.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(37).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(38).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(38).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒38.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(38).Now).Komasyurui + "]");
            Debug.Assert(((RO_Star)src_Sky.StarlightIndexOf(39).Now).Komasyurui == Komasyurui14.H01_Fu_____ || ((RO_Star)src_Sky.StarlightIndexOf(39).Now).Komasyurui == Komasyurui14.H11_Tokin__, "駒39.種類=[" + ((RO_Star)src_Sky.StarlightIndexOf(39).Now).Komasyurui + "]");



            for (int i = 0; i < 40; i++)
            {
                RO_Star koma = (RO_Star)src_Sky.StarlightIndexOf(0).Now;
                Komahaiyaku185 haiyaku = koma.Haiyaku;

                if (Okiba.ShogiBan == Util_Masu10.Masu_ToOkiba(koma.Masu))
                {
                    Debug.Assert(!Util_KomahaiyakuEx184.IsKomabukuro(haiyaku), "将棋盤の上に、配役：駒袋　があるのはおかしい。");
                }


                //if(
                //    haiyaku==Kh185.n164_歩打
                //    )
                //{
                //}
                //koma.Syurui
                //Debug.Assert((.Syurui == Ks14.H06_Oh, "駒0.種類=[" + ((RO_Star_Koma)siteiSky.StarlightIndexOf(0).Now).Syurui + "]");
                //sb.Append("駒" + i + ".種類=[" + ((RO_Star_KomaKs)siteiSky.StarlightIndexOf(i).Now).Syurui + "]\n");
            }


        }

        //public static Playerside GetReverseTebanside(Playerside tebanside1)
        //{
        //    Playerside side2;
        //    switch (tebanside1)
        //    {
        //        case Playerside.P1: side2 = Playerside.P2; break;
        //        case Playerside.P2: side2 = Playerside.P1; break;
        //        case Playerside.Empty: side2 = Playerside.Empty; break;
        //        default: throw new Exception("未定義のプレイヤーサイド [" + tebanside1 + "]");
        //    }

        //    return side2;
        //}



        /// <summary>
        /// 無ければ追加、あれば上書き。
        /// </summary>
        /// <param name="hKoma"></param>
        /// <param name="masus"></param>
        public static void AddOverwrite(
            Maps_OneAndOne<Finger, SySet<SyElement>> komabetuMasus,
            Finger finger, SySet<SyElement> masus)
        {
            if (komabetuMasus.Items.ContainsKey(finger))
            {
                komabetuMasus.Items[finger].AddSupersets(masus);//追加します。
            }
            else
            {
                // 無かったので、新しく追加します。
                komabetuMasus.Items.Add(finger, masus);
            }
        }

    }
}
