﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P013_Collection_.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P258_UtilSky258_.L250____UtilFingers;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

#if DEBUG
using System.Diagnostics;
#endif

namespace Grayscale.P259_Play_______.L500____Calc
{


    public abstract class Play
    {

        /// <summary>
        /// 指定した駒全てについて、基本的な駒の動きを返します。（金は「前、ななめ前、横、下に進める」のような）
        /// </summary>
        /// <param name="src_Sky"></param>
        /// <param name="fingers"></param>
        /// <param name="logTag"></param>
        /// <returns></returns>
        public static Maps_OneAndOne<Finger, SySet<SyElement>> Get_PotentialMoves_Ikusa(
            SkyConst src_Sky,
            Fingers fingers,
            KwErrorHandler errH_orNull
            )
        {
            Maps_OneAndOne<Finger, SySet<SyElement>> kiki_fMs = new Maps_OneAndOne<Finger, SySet<SyElement>>();// 「どの駒を、どこに進める」の一覧

            foreach (Finger finger in fingers.Items)
            {
                // ポテンシャル・ムーブを調べます。
                SySet<SyElement> move = Util_Sky_SyugoQuery.KomaKidou_Potential(finger, src_Sky);//←ポテンシャル・ムーブ取得関数を選択。歩とか。

                if (!move.IsEmptySet())
                {
                    // 移動可能升があるなら
                    Util_Sky258A.AddOverwrite(kiki_fMs, finger, move);
                }
            }

            return kiki_fMs;
        }

        /// <summary>
        /// 指定した持ち駒全てについて、基本的な駒の動きを返します。（金は「前、ななめ前、横、下に進める」のような）
        /// 
        /// TODO: 打ち歩詰めﾁｪｯｸ
        /// 
        /// １局面につき、１回実行される。
        /// </summary>
        /// <param name="src_Sky"></param>
        /// <param name="figMotis"></param>
        /// <param name="motiOkenaiMasus">持ち駒を置けないマス（味方駒、敵駒が置いてあるマス）</param>
        /// <param name="errH_orNull"></param>
        /// <returns></returns>
        public static List_OneAndMulti<Finger, SySet<SyElement>> Translate_Motikoma_ToPotentialMove(
            SkyConst src_Sky,
            Fingers figMotis,
            SySet<SyElement> motiOkenaiMasus,
            KwErrorHandler errH_orNull
            )
        {
            // 駒種類別、置こうとする升
            SySet<SyElement>[] aMasus = new SySet<SyElement>[Array_Komasyurui.Items_All.Length];
            // 駒種類別、置こうとする駒（持駒の代表）
            RO_Star[] aDaihyo = new RO_Star[Array_Komasyurui.Items_All.Length];
            // 駒種類別、置こうとする駒番号
            Finger[] aFigKoma = new Finger[Array_Komasyurui.Items_All.Length];


            Finger[] daihyoArray;// 持駒。駒の種類代表１個
            Util_Fingers_KomasyuruiQuery.Translate_Fingers_ToKomasyuruiBETUFirst(
                src_Sky,
                figMotis,
                out daihyoArray
                );
            foreach (Finger figDaihyo in daihyoArray)
            {
                if (Fingers.Error_1 != figDaihyo)
                {
                    RO_Star daihyo = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figDaihyo).Now);
#if DEBUG
                    Debug.Assert(daihyo != null, "持ち駒の代表がヌル");
#endif
                    // 駒種類別、置こうとする駒
                    aDaihyo[(int)daihyo.Komasyurui] = daihyo;
                    // 駒種類別、置こうとする升
                    aMasus[(int)daihyo.Komasyurui] = Util_Sky_SyugoQuery.KomaKidou_Potential(figDaihyo, src_Sky);
                    // 駒種類別、置こうとする駒番号
                    aFigKoma[(int)daihyo.Komasyurui] = figDaihyo;
                }
            }


            if (aDaihyo[(int)Komasyurui14.H01_Fu_____] != null)// 攻め手が、歩を持っているなら
            {
                //----------------------------------------
                // 二歩チェック
                //----------------------------------------
                //
                // 打てない筋の升を除外します。
                //
                if (true)
                {
#if DEBUG
                    //System.Console.WriteLine("----------------------------------------");
                    //System.Console.WriteLine("歩を置きたかった升＝" + Util_SySet.Dump_Elements( aMasus[(int)Komasyurui14.H01_Fu_____]));
                    //System.Console.WriteLine("----------------------------------------");
                    //System.Console.WriteLine("歩の置けない筋チェック（二歩チェック）開始");
#endif
                    // 将棋盤上の自歩一覧。
                    Fingers banjoJiFus = Util_Sky_FingersQuery.InOkibaPsideKomasyuruiNow(
                        src_Sky,//指定局面
                        Okiba.ShogiBan,//将棋盤上の
                        aDaihyo[(int)Komasyurui14.H01_Fu_____].Pside,//持駒を持っているプレイヤー側の
                        Komasyurui14.H01_Fu_____//歩
                        );
                    
#if DEBUG
                    //System.Console.WriteLine("banjoJiFus.Count=["+banjoJiFus.Count+"]");
                    //foreach (Finger figKoma in banjoJiFus.Items)
                    //{
                    //    System.Console.WriteLine("figKoma=[" + (int)figKoma + "]");
                    //}
                    //System.Console.WriteLine("----------------------------------------");
#endif

                    // 筋別、歩のあるなしチェック
                    bool[] existsFu_sujibetu = new bool[10];
                    foreach (Finger figBanjoJiFu in banjoJiFus.Items)
                    {
                        RO_Star banjoJiFu = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figBanjoJiFu).Now);
                        int suji;//1～9
                        Util_MasuNum.TryMasuToSuji(banjoJiFu.Masu, out suji);
                        existsFu_sujibetu[suji] = true;
                    }

                    // 9筋 確認します。
                    for (int suji = 1; suji < 10; suji++)
                    {
                        if (existsFu_sujibetu[suji])
                        {
                            // 二歩になる筋番号の発見☆
#if DEBUG
                            //System.Console.WriteLine("二歩チェック： " + suji + "筋は二歩。");
#endif

                            // 筋一列を引きます。

                            // 駒種類別、置こうとする升
                            aMasus[(int)Komasyurui14.H01_Fu_____] = aMasus[(int)Komasyurui14.H01_Fu_____].Minus_Closed(Masu_Honshogi.BAN_SUJIS[suji]);
                        }
                    }
#if DEBUG
                    //System.Console.WriteLine("歩の置けない筋チェック（二歩チェック）終了");
                    //System.Console.WriteLine("----------------------------------------");
                    //System.Console.WriteLine("歩の置ける升＝" + Util_SySet.Dump_Elements(aMasus[(int)Komasyurui14.H01_Fu_____]));
                    //System.Console.WriteLine("----------------------------------------");
#endif
                }


                //----------------------------------------
                // TODO:打ち歩詰めチェック
                //----------------------------------------

            }

            //----------------------------------------
            // 集計
            //----------------------------------------
            // 「どの持ち駒を」「どこに置ける」のコレクション。
            List_OneAndMulti<Finger, SySet<SyElement>> result = new List_OneAndMulti<Finger, SySet<SyElement>>();
            foreach (Komasyurui14 ks in Array_Komasyurui.MotiKoma7Syurui)
            {
                // 置こうとする駒があれば
                if (null != aDaihyo[(int)ks])
                {
                    // 置けない升を引きます。
                    aMasus[(int)ks] = aMasus[(int)ks].Minus_Closed(motiOkenaiMasus);

                    if (!aMasus[(int)ks].IsEmptySet())
                    {
                        // 置ける升があれば登録
                        result.AddNew(
                            aFigKoma[(int)ks],//置こうとする持駒番号
                            aMasus[(int)ks]//置ける升
                            );
                    }
                }
            }
            return result;
        }

    }


}
