﻿using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using System.Collections.Generic;

namespace Grayscale.P321_KyokumHyoka.L250____Struct
{
    /// <summary>
    /// 局面を切り取ったときの、スコアの明細
    /// </summary>
    public class KyHyokaImpl : KyHyoka
    {

        /// <summary>
        /// 全項目。
        /// </summary>
        public Dictionary<string, KyHyokaMeisai_Koumoku> Items { get { return this.items; } }
        private Dictionary<string, KyHyokaMeisai_Koumoku> items;

        public KyHyokaImpl()
        {
            this.items = new Dictionary<string, KyHyokaMeisai_Koumoku>();
        }

        /// <summary>
        /// 枝専用。
        /// </summary>
        /// <param name="kyHyokaItem"></param>
        public KyHyokaImpl(double branchScore)
        {
            this.items = new Dictionary<string, KyHyokaMeisai_Koumoku>();
            this.items.Add("枝", new KyHyokaMeisai_KoumokuImpl(branchScore, "枝", KyJisinClass.UNKNOWN));
        }

        public double Total()
        {
            double total = 0.0d;

            foreach (KyHyokaMeisai_Koumoku kyHyoka in this.Items.Values)
            {
                total += kyHyoka.Score;
            }

            return total;
        }

        public void Clear()
        {
            this.Items.Clear();
        }

        public void Add(string name, KyHyokaMeisai_Koumoku item)
        {
            if (this.Items.ContainsKey(name))
            {
                this.Items[name] = item;
            }
            else
            {
                this.Items.Add(name, item);
            }
        }

        public KyHyokaMeisai_Koumoku Get(string name)
        {
            KyHyokaMeisai_Koumoku kyHyoka;

            if (this.Items.ContainsKey(name))
            {
                kyHyoka = this.Items[name];
            }
            else
            {
                //
                // TODO: 状況別スコア倍率
                //
                kyHyoka = new KyHyokaMeisai_KoumokuImpl(
                    Util_KyHyoka.Keisan(0.0d, KyHyokaSaido.Hyaku_bunnoichi, 1.0d),
                    "ヌル",
                    KyJisinClass.UNKNOWN
                    );
            }

            return kyHyoka;
        }
    }
}
