﻿using Grayscale.P321_KyokumHyoka.L___250_Struct;

namespace Grayscale.P321_KyokumHyoka.L500____Util
{
    public abstract class Conv_JisinTen
    {
        /// <summary>
        /// 自信点を、自信クラスに変換。
        /// +M,+A,+B1,+B2,+C1,+C2～0～-C2,-C1,-B2,-B1,-A,-M。
        /// </summary>
        /// <param name="jisinTen"></param>
        /// <param name="saido"></param>
        /// <returns></returns>
        public static KyJisinClass ToJisinClass(double jisinTen)
        {
            KyJisinClass result;

            double limitAbs = 1.0d;

            double m_ = limitAbs - limitAbs / 131.0d * 1.0d;
            double a_ = limitAbs - limitAbs / 131.0d * 11.0d;
            double b1 = limitAbs - limitAbs / 131.0d * 24.0d;
            double b2 = limitAbs - limitAbs / 131.0d * 50.0d;
            double c1 = limitAbs - limitAbs / 131.0d * 84.0d;
            double c2 = limitAbs - limitAbs / 131.0d * 131.0d;

            //
            // 正の数の方向
            //
            if (m_ <= jisinTen) { result = KyJisinClass.M_; }
            else if (a_ <= jisinTen) { result = KyJisinClass.A_; }
            else if (b1 <= jisinTen) { result = KyJisinClass.B1; }
            else if (b2 <= jisinTen) { result = KyJisinClass.B2; }
            else if (c1 <= jisinTen) { result = KyJisinClass.C1; }
            //
            // 正の数～０～負の数
            //
            else if (-c1 < jisinTen) { result = KyJisinClass.C2; }
            //
            // 負の数
            //
            else if (-b2 <= jisinTen) { result = KyJisinClass.C1; }
            else if (-b1 <= jisinTen) { result = KyJisinClass.B2; }
            else if (-a_ <= jisinTen) { result = KyJisinClass.B1; }
            else if (-m_ <= jisinTen) { result = KyJisinClass.A_; }
            //
            // 負の数 下限方向
            //
            else { result = KyJisinClass.M_; }

            return result;
        }

    }
}
