﻿using Grayscale.P321_KyokumHyoka.L___250_Struct;

namespace Grayscale.P321_KyokumHyoka.L500____Util
{
    public abstract class Conv_Saido
    {

        /// <summary>
        /// 細度のサイズを数値で表します。
        /// </summary>
        /// <param name="saido"></param>
        /// <param name="limitAbs">細度の上限の絶対値。</param>
        /// <param name="?">小数点以下の有効桁。指定がなければ 0。</param>
        /// <returns></returns>
        public  static void ToSyosuKeta(KyHyokaSaido saido, out int syosu_keta)
        {
            switch (saido)
            {
                case KyHyokaSaido.Saigoni_Total: syosu_keta = 0; break;
                case KyHyokaSaido.Hyaku_bunnoichi: syosu_keta = 2; break;
                case KyHyokaSaido.Sen_bunnoichi: syosu_keta = 3; break;
                case KyHyokaSaido.Man_bunnoichi: syosu_keta = 4; break;
                case KyHyokaSaido.Jyuman_bunnoichi: syosu_keta = 5; break;
                case KyHyokaSaido.Hyakuman_bunnoichi: syosu_keta = 6; break;
                default: syosu_keta = 0; break;
            }
        }

    }
}
