﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P013_Collection_.L500____Struct;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P226_Tree_______.L500____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using System.Text;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P322_KifuTree___.L250____Struct
{
    public class KifuNodeImpl : NodeImpl<Starbeamable, KyokumenWrapper>, KifuNode
    {


        /// <summary>
        /// TODO:この局面データを、読み込めないようにします。（使っていないことを確認するため用）
        /// </summary>
        public void Lock_Kyokumendata()
        {
            this.Value = null;
        }

        public bool IsLeaf { get { return 0 == this.Count_ChildNodes; } }


        public KyHyoka KyHyoka { get { return this.kyHyoka; } }
        /// <summary>
        /// 枝専用。
        /// </summary>
        /// <param name="branchKyHyoka"></param>
        public void SetBranchKyHyoka(KyHyoka branchKyHyoka)
        {
            this.kyHyoka = branchKyHyoka;
        }
        private KyHyoka kyHyoka;


        /// <summary>
        /// コンストラクター。
        /// </summary>
        /// <param name="shootingStarlightable"></param>
        /// <param name="kyokumenWrapper"></param>
        public KifuNodeImpl(Starbeamable shootingStarlightable, KyokumenWrapper kyokumenWrapper)
            : base(shootingStarlightable, kyokumenWrapper)
        {
            this.kyHyoka = new KyHyokaImpl();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="hubNode">追加したいノードの一覧を入れたリスト。</param>
        public void PutAppdendNextNodes(
            Node<Starbeamable, KyokumenWrapper> hubNode,
            KifuNode to_parentNode//親となる予定のノード
            //KifuTree kifu_forAssert
            )
        {

            hubNode.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> node, ref bool toBreak) =>
            {
                if (!this.ContainsKey_ChildNodes(key))
                {
                    this.PutAdd_ChildNode(key, node);
                    //kifu_forAssert.AssertChildPside(to_parentNode.Value.ToKyokumenConst.KaisiPside, ((KifuNode)node).Value.ToKyokumenConst.KaisiPside);
                }
            });
        }

        public bool HasTuginoitte(
            string sasiteStr
            )
        {
            return this.ContainsKey_ChildNodes(sasiteStr);
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 棋譜に　次の一手　を追加します。
        /// ************************************************************************************************************************
        /// 
        /// KifuIO を通して使ってください。
        /// 
        /// ①コマ送り用。
        /// ②「成り」フラグの更新用。
        /// ③マウス操作用
        /// 
        /// カレントノードは変更しません。
        /// </summary>
        public void PutTuginoitte_New(
            Node<Starbeamable, KyokumenWrapper> newNode
            )
        {
            // 同じ指し手があれば追加してはいけない？
#if DEBUG
            string sasiteStr = Conv_Sasite307.ToSfenFugo(newNode.Key);

            System.Diagnostics.Debug.Assert(
                !this.HasTuginoitte(sasiteStr),
                "指し手[" + sasiteStr + "]は既に指されていました。"
                );
#endif
            // SFENをキーに、次ノードを増やします。
            this.PutAdd_ChildNode(Conv_Sasite307.ToSfenFugo(newNode.Key), newNode);
            //手番はここでは変更できない。((KifuNode)newNode).Tebanside = Util_Playerside.Reverse(this.Tebanside);//親の先後を逆にして子に追加。

            newNode.SetParentNode( this);
        }
        /// <summary>
        /// 既存の子要素を上書きします。
        /// </summary>
        /// <param name="existsNode"></param>
        public void PutTuginoitte_Override(
            Node<Starbeamable, KyokumenWrapper> existsNode
            )
        {
            // SFENをキーに、次ノードを増やします。
            this.NextNodes[Conv_Sasite307.ToSfenFugo(existsNode.Key)] = existsNode;
            existsNode.SetParentNode( this);
        }

        /// <summary>
        /// 指し手一覧を、駒毎に分けます。
        /// </summary>
        /// <param name="hubNode">指し手一覧</param>
        /// <param name="errH"></param>
        /// <returns>駒毎の、全指し手</returns>
        public Maps_OneAndMulti<Finger, Starbeamable> SplitSasite_ByStar(Node<Starbeamable, KyokumenWrapper> hubNode, KwErrorHandler errH)
        {
            SkyConst src_Sky = this.Value.ToKyokumenConst;


            Maps_OneAndMulti<Finger, Starbeamable> enable_teMap = new Maps_OneAndMulti<Finger, Starbeamable>();


            hubNode.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> nextNode, ref bool toBreak) =>
            {
                Starbeamable nextSasite = nextNode.Key;

                Finger figKoma = Util_Sky_FingersQuery.InMasuNow(src_Sky, Util_Koma.AsKoma(nextSasite.LongTimeAgo).Masu).ToFirst();

                enable_teMap.Put_NewOrOverwrite(figKoma, nextSasite);
            });

            return enable_teMap;
        }

        public string Json_NextNodes_MultiSky(
            string memo,
            string hint,
            int temezumi_yomiGenTeban_forLog,//読み進めている現在の手目済
            KwErrorHandler errH)
        {
            StringBuilder sb = new StringBuilder();

            this.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> node, ref bool toBreak) =>
            {
                sb.AppendLine(Util_Sky307.Json_1Sky(
                    node.Value.ToKyokumenConst,
                    memo + "：" + key,
                    hint + "_SF解1",
                    temezumi_yomiGenTeban_forLog
                    ));// 局面をテキストで作成
            });

            return sb.ToString();
        }



    }
}
