﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P226_Tree_______.L500____Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using System;
#if DEBUG
using Grayscale.P234_Komahaiyaku.L500____Util;
using Grayscale.P322_KifuTree___.L500____Util;
using System.Diagnostics;
#endif

namespace Grayscale.P322_KifuTree___.L250____Struct
{




    public class KifuTreeImpl : TreeImpl<Starbeamable, KyokumenWrapper>, KifuTree
    {

        //public Tree<ShootingStarlightable, KyokumenWrapper> Tree { get { return this.tree; } }
        //private Tree<ShootingStarlightable, KyokumenWrapper> tree;

        public KifuTreeImpl(Node<Starbeamable, KyokumenWrapper> root)
            : base(root)//Tree<ShootingStarlightable, KyokumenWrapper> tree
        {
            //this.tree = tree;
        }

        public void AssertPside(Node<Starbeamable, KyokumenWrapper> node, string hint, KwErrorHandler errH)
        {
#if DEBUG
            Playerside test = ((KifuNode)node).Value.ToKyokumenConst.KaisiPside;

            int temezumi = node.Value.ToKyokumenConst.Temezumi;
            if(temezumi==0)
            {
                // 初期化前は動かない。
                string sasiteStr1;
                string sasiteStr2;
                if (Util_Komahaiyaku184.IsActive())
                {
                    sasiteStr1 = Conv_Node322.ToSasite(this.GetRoot(), this.GetRoot().Value, errH);
                    sasiteStr2 = Conv_Node322.ToSasite(node, node.Value, errH);
                }
                else
                {
                    sasiteStr1 = "初期化前";
                    sasiteStr2 = "初期化前";
                }

                // 手済みが0なら、ルートノードのはず。
                Debug.Assert(this.GetRoot() == node, "手済みが0なら、ルートノードのはずですが、ルートノードではありませんでした。\n"+
                "ルート＝" + sasiteStr1 + "\n" +
                "指定ノード＝" + sasiteStr2 + "\n"
                );
            }
            Playerside result = this.CountPside(temezumi);

            Playerside firstPside = this.GetRoot().Value.ToKyokumenConst.KaisiPside;// (Playerside)this.GetProperty(Word_KifuTree.PropName_FirstPside);

            Debug.Assert(test == result, "手番、先後の数え方に不一致がありました。\n カウント[" + result + "]（temezumi=[" + temezumi + "]）　<> KaisiPside[" + test + "]\n firstPside=[" + firstPside + "] \n もし追加されていないノードなら、正しく診断できません。\n ヒント＝" + hint);
#endif
        }

        /// <summary>
        /// これから追加する予定のノードの先後を診断します。
        /// </summary>
        /// <param name="node"></param>
        public void AssertChildPside(Playerside parentPside, Playerside childPside)
        {
#if DEBUG
            Debug.Assert(
                (parentPside==Playerside.P1 && childPside==Playerside.P2)
                ||
                (parentPside==Playerside.P2 && childPside==Playerside.P1)
                , "親子の先後に、異順序がありました。現手番[" + parentPside + "]　<> 次手番[" + childPside + "]");
#endif
        }

        public Playerside CountPside(Node<Starbeamable, KyokumenWrapper> node, KwErrorHandler errH)
        {
            this.AssertPside(node, "CountPside",errH);
            return this.CountPside(node.Value.ToKyokumenConst.Temezumi);
        }

        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 現在の先後
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 
        /// 初期局面（ルート・ノード）は、手済み＝０　としてカウントします。
        /// ルートノードは、『先手番』とします。
        /// 
        /// </summary>
        private Playerside CountPside(int temezumi)
        {
            Playerside result;

            switch (this.GetRoot().Value.ToKyokumenConst.KaisiPside)//(Playerside)this.GetProperty(Word_KifuTree.PropName_FirstPside)
            {
                case Playerside.P1:
                    if (temezumi % 2 == 0)
                    {
                        // 手目が偶数なら先手
                        result = Playerside.P1;
                    }
                    else
                    {
                        result = Playerside.P2;
                    }
                    break;

                case Playerside.P2:
                    if (temezumi % 2 == 0)
                    {
                        // 手目が偶数なら後手
                        result = Playerside.P2;
                    }
                    else
                    {
                        result = Playerside.P1;
                    }
                    break;

                default:
                    string message = "先後エラー";
                    //LarabeLogger.GetInstance().WriteLineError(LarabeLoggerList.ERROR, message);
                    throw new Exception(message);
            }

#if DEBUG
            if(temezumi==0)
            {
                Debug.Assert(result == Playerside.P1, "開始局面ですが、後手番を返してしまいました。正しくは先手番です。\n result=[" + result + "]");
            }
#endif

            return result;
        }
    }


}
