﻿using Grayscale.P153_KifuSfen___.L___250_Report;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Grayscale.P322_KifuTree___.L250____Struct
{
    public abstract class KyHyokaListWriterImpl
    {

        public static void Write(
            string id,
            KifuNode node,
            string relFolder,
            ReportEnvironment env
            )
        {

            StringBuilder sb = new StringBuilder();

            // 見出し
            sb.Append(id);
            sb.Append("    ");
            sb.Append(((int)node.KyHyoka.Total()).ToString());
            sb.Append("    ");
            switch(((KifuNode)node).Value.ToKyokumenConst.KaisiPside)
            {
                case Playerside.P1: sb.Append("P2が指し終えた局面。手番P1"); break;
                case Playerside.P2: sb.Append("P1が指し終えた局面。手番P2"); break;
                case Playerside.Empty: sb.Append("手番Empty"); break;
            }
            sb.AppendLine();

            foreach (KeyValuePair<string, KyHyokaMeisai_Koumoku> entry in node.KyHyoka.Items)
            {
                KyHyokaMeisai_Koumoku koumoku = ((KyHyokaMeisai_Koumoku)entry.Value);

                sb.Append("    ");

                switch (koumoku.Utiwake_jisinClass)//内訳：自信クラス
                {
                    case KyJisinClass.M_: sb.Append("M_ "); break;
                    case KyJisinClass.A_: sb.Append("A_ "); break;
                    case KyJisinClass.B1: sb.Append("B1 "); break;
                    case KyJisinClass.B2: sb.Append("B2 "); break;
                    case KyJisinClass.C1: sb.Append("C1 "); break;
                    case KyJisinClass.C2: sb.Append("C2 "); break;
                    default: sb.Append("-- "); break;
                }

                sb.Append(entry.Key);//項目名
                sb.Append("  ");
                sb.Append(koumoku.Score);//評価値
                sb.Append("  ");
                
                sb.Append(koumoku.Utiwake);//内訳
                sb.AppendLine();
            }
            sb.AppendLine();

            File.AppendAllText(env.OutFolder+relFolder+"/_log_評価明細.txt", sb.ToString());
        }

    }
}
