﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L250____Struct;
using System.Collections.Generic;
using System.Diagnostics;

namespace Grayscale.P322_KifuTree___.L500____Util
{

    /// <summary>
    /// 棋譜ツリーのユーティリティー。
    /// </summary>
    public abstract class Util_KifuTree282
    {

        /// <summary>
        /// 『以前の変化カッター』
        /// 
        /// 本譜を残して、カレントノードより以前の変化は　ツリーから削除します。
        /// </summary>
        public static void IzennoHenkaCutter(
            KifuTree kifu_mutable,
            KwErrorHandler errH
            )
        {
            //----------------------------------------
            // 本譜以外の変化を削除します。
            //----------------------------------------

            if (kifu_mutable.CurNode.IsRoot())
            {
                //----------------------------------------
                // ルートノードでは何もできません。
                //----------------------------------------
                goto gt_EndMethod;
            }

            //----------------------------------------
            // 本譜の手
            //----------------------------------------
            string sasiteStr = Conv_Node322.ToSasite(
                kifu_mutable.CurNode,
                kifu_mutable.CurNode.Value,
                errH
                );


            //----------------------------------------
            // １手前の分岐点
            //----------------------------------------
            Node<Starbeamable, KyokumenWrapper> parentNode = kifu_mutable.CurNode.GetParentNode();

            //----------------------------------------
            // 選ばなかった変化を、ここに入れます。
            //----------------------------------------
            List<string> removeeList = new List<string>();

            //----------------------------------------
            // 選んだ変化と、選ばなかった変化の一覧
            //----------------------------------------
            parentNode.Foreach_ChildNodes((string key1, Node<Starbeamable, KyokumenWrapper> nextNode1, ref bool toBreak1) =>
            {
                if (key1==sasiteStr)
                {
                    //----------------------------------------
                    // 本譜の手はスキップ
                    //----------------------------------------
                    goto gt_Next1;
                }

                //----------------------------------------
                // 選ばなかった変化をピックアップ
                //----------------------------------------
                removeeList.Add(key1);

            gt_Next1:
                ;
            });


            //----------------------------------------
            // どんどん削除
            //----------------------------------------
            foreach (string key in removeeList)
            {
                parentNode.RemoveChild(key);
            }

        gt_EndMethod:
            ;
        }


        /// <summary>
        /// 新しいノードを、次ノードとして追加します。
        /// そして、追加した新しいノードを、カレント・ノードとします。
        /// </summary>
        /// <param name="nextNode_and_nextCurrent"></param>
        public static void AppendChild_And_ChangeCurrentToChild(
            KifuTree kifuRef282,
            Node<Starbeamable, KyokumenWrapper> nextNode_and_nextCurrent,
            KwErrorHandler errH
            )
        {
            string sasiteStr = Conv_Sasite307.ToSfenFugo(nextNode_and_nextCurrent.Key);

            if (!((KifuNode)kifuRef282.CurNode).HasTuginoitte(sasiteStr))
            {
                ((KifuNode)kifuRef282.CurNode).PutTuginoitte_New(nextNode_and_nextCurrent);//次ノートを追加します。
                kifuRef282.AssertPside(nextNode_and_nextCurrent, "sasiteStr="+sasiteStr,errH);
            }

            kifuRef282.SetCurNode( nextNode_and_nextCurrent);//次ノードを、これからのカレントとします。
            Debug.Assert(kifuRef282.CurNode != null, "カレントノードがヌル。");
        }

        /*
        /// <summary>
        /// 取った駒を差替えます。
        /// 
        /// 棋譜読取時用です。マウス操作時は、流れが異なるので使えません。
        /// </summary>
        public static void AppendChildB_Swap(
            Komasyurui14 tottaSyurui,
            SkyConst src_Sky,
            KifuTree kifu282,
            out Node<ShootingStarlightable, KyokumenWrapper> out_swapedNode,
            string hint,
            KwErrorHandler errH
            )
        {
            out_swapedNode = null;

            if (kifu282.CurNode.IsRoot())
            {
                // ルート・ノードなら
                goto gt_EndMethod;
                // 子要素をスワップするためには親要素が必要だが、ルートには親ノードがないので、このあとの操作はできません。
            }

            if (null == src_Sky)
            {
                string message = "ノードを追加しようとしましたが、指定されたnewSkyがヌルです。";
                Exception ex = new Exception(message);
                OwataMinister.ERROR.DonimoNaranAkirameta(ex, "取った駒を差替え中☆"); throw ex;
            }

            // 現手番
            Playerside genTebanside = ((KifuNode)kifu282.CurNode).Tebanside;
            // 現ノード削除。元のキーは退避。
            ShootingStarlightable motoKey = (ShootingStarlightable)kifu282.PopCurrentNode().Key;

            // 元のキーの、取った駒の種類だけを差替えます。
            RO_ShootingStarlight swapedSasite = Util_Sky258A.BuildSasite(motoKey.LongTimeAgo, motoKey.Now, tottaSyurui);

            // キーを差替えたノード
            out_swapedNode = new KifuNodeImpl(swapedSasite, new KyokumenWrapper(src_Sky), genTebanside);

            System.Diagnostics.Debug.Assert(!kifu282.CurNode.ContainsKey_ChildNodes(Util_Sky278.TranslateSasite_StarlightToText(out_swapedNode.Key)));


            // さきほど　カレントノードを削除したので、
            // 今、カレントノードは、１つ前のノードになっています。
            // ここに、差替えたノードを追加します。
            kifu282.CurNode.Add_ChildNode(Util_Sky278.TranslateSasite_StarlightToText(out_swapedNode.Key), out_swapedNode);
            out_swapedNode.ParentNode = kifu282.CurNode;

            errH.Logger.WriteLine_AddMemo("リンクトリストの、最終ノードは差し替えられた hint=[" + hint + "] item=[" + Util_Sky278.TranslateSasite_StarlightToText(swapedSasite) + "]");
        // memberName=[" + memberName + "] sourceFilePath=[" + sourceFilePath + "] sourceLineNumber=[" + sourceLineNumber + "]

        gt_EndMethod:
            ;
        }
        */

        /// <summary>
        /// ************************************************************************************************************************
        /// [ここから採譜]機能
        /// ************************************************************************************************************************
        /// </summary>
        public static void SetStartpos_KokokaraSaifu(KifuTree kifu, Playerside pside, KwErrorHandler errH)
        {

            //------------------------------------------------------------
            // 棋譜を空に
            //------------------------------------------------------------
            kifu.Clear();
            kifu.SetProperty(Word_KifuTree.PropName_Startpos, Conv_KifuNode.ToSfenstring((KifuNode)kifu.CurNode, pside, errH));
        }

    }
}
