﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P213_Komasyurui_.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P269_Util_Sasu__.L500____Util;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L250____Struct;
using Grayscale.P341_Ittesasu___.L510____OperationB;
using System;
using System.Collections.Generic;
using System.Text;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P354_Util_SasuEx.L500____Util
{

    /// <summary>
    /// ************************************************************************************************************************
    /// あるデータを、別のデータに変換します。
    /// ************************************************************************************************************************
    /// </summary>
    public abstract class Util_SasuEx
    {

        /// <summary>
        /// これが通称【水際のいんちきプログラム】なんだぜ☆
        /// 必要により、【成り】の指し手を追加します。
        /// </summary>
        public static void AddNariSasite(
            KifuNode to_parentNode,// 親となる予定のノード。
            KifuNode hubNode,// 根元のノードということは、１個前のノード。
            //KifuTree kifu_forAssert,
            KwErrorHandler errH
            )
        {
            try
            {
                Dictionary<string, Starbeamable> newSasiteList = new Dictionary<string, Starbeamable>();

                hubNode.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> nextNode, ref bool toBreak) =>
                {
                    RO_Star srcKoma = Util_Koma.AsKoma(nextNode.Key.LongTimeAgo);
                    RO_Star dstKoma = Util_Koma.AsKoma(nextNode.Key.Now);

                    // 成りができる動きなら真。
                    bool isPromotionable;
                    if (!Util_Sasu269.IsPromotionable(out isPromotionable, srcKoma, dstKoma))
                    {
                        // ｴﾗｰ
                        goto gt_Next1;
                    }

                    if (isPromotionable)
                    {
                        Starbeamable sasite = new RO_Starbeam(
                            srcKoma,// 移動元
                            new RO_Star(
                                dstKoma.Pside,
                                dstKoma.Masu,
                                Util_Komasyurui14.ToNariCase(dstKoma.Komasyurui)//強制的に【成り】に駒の種類を変更
                            ),// 移動先
                            Komasyurui14.H00_Null___//取った駒不明
                        );

                        // TODO: 一段目の香車のように、既に駒は成っている場合があります。無い指し手だけ追加するようにします。
                        string sasiteStr = Conv_Sasite307.ToSfenFugo(sasite);//重複防止用のキー
                        if (!newSasiteList.ContainsKey(sasiteStr))
                        {
                            newSasiteList.Add(sasiteStr, sasite);
                        }
                    }

                gt_Next1:
                    ;
                });


                // 新しく作った【成り】の指し手を追加します。
                foreach (Starbeamable newSasite in newSasiteList.Values)
                {
                    // 指す前の駒
                    RO_Star sasumaenoKoma = Util_Koma.AsKoma(newSasite.LongTimeAgo);

                    // 指した駒
                    RO_Star sasitaKoma = Util_Koma.AsKoma(newSasite.Now);

                    // 指す前の駒を、盤上のマス目で指定
                    Finger figSasumaenoKoma = Util_Sky_FingersQuery.InMasuNow(to_parentNode.Value.ToKyokumenConst, sasumaenoKoma.Masu).ToFirst();

                    try
                    {
                        string sasiteStr = Conv_Sasite307.ToSfenFugo(newSasite);

                        if (!hubNode.ContainsKey_ChildNodes(sasiteStr))
                        {
                            // 指し手が既存でない局面だけを追加します。

                            //kifu_forAssert.AssertChildPside(to_parentNode.Value.ToKyokumenConst.KaisiPside, newChild.Value.ToKyokumenConst.KaisiPside);

                            hubNode.PutAdd_ChildNode(sasiteStr, new KifuNodeImpl(newSasite, new KyokumenWrapper(
                                Util_Sasu341.Sasu(
                                    to_parentNode.Value.ToKyokumenConst,//指定局面
                                    figSasumaenoKoma,//指す駒
                                    sasitaKoma.Masu,//移動先升
                                    true,//成ります。
                                    errH
                            ))));
                        }

                    }
                    catch (Exception ex)
                    {
                        // 既存の指し手
                        StringBuilder sb = new StringBuilder();
                        {
                            hubNode.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> nextNode, ref bool toBreak) =>
                            {
                                sb.Append("「");
                                sb.Append(Conv_Sasite307.ToSfenFugo(nextNode.Key));
                                sb.Append("」");
                            });
                        }

                        //>>>>> エラーが起こりました。
                        errH.DonimoNaranAkirameta(ex, "新しく作った「成りの指し手」を既存ノードに追加していた時です。：追加したい指し手=「" + Conv_Sasite307.ToSfenFugo(newSasite) + "」既存の手=" + sb.ToString());
                        throw ex;
                    }

                }

            }
            catch (Exception ex)
            {
                throw new Exception("Convert04.cs#AddNariSasiteでｴﾗｰ。:" + ex.GetType().Name + ":" + ex.Message);
            }
        }





    }
}
