﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P276_SeizaStartp.L500____Struct;
using Grayscale.P324_ShogiGuiBas.L___500_Struct;
using Grayscale.P355_KifuParserA.L___500_Parser;
using System;
using System.Runtime.CompilerServices;

namespace Grayscale.P355_KifuParserA.L500____Parser
{


    /// <summary>
    /// 変化なし
    /// </summary>
    public class KifuParserA_Impl : KifuParserA
    {

        public KifuParserA_State State { get; set; }


        public DELEGATE_ChangeSky_Im_Srv Delegate_OnChangeSky_Im_Srv { get; set; }


        public KifuParserA_Impl()
        {
            // 初期状態＝ドキュメント
            this.State = KifuParserA_StateA0_Document.GetInstance();

            this.Delegate_OnChangeSky_Im_Srv = this.Empty_OnChangeSky_Im_Srv;
        }


        private void Empty_OnChangeSky_Im_Srv(
            object obj_shogiGui,
            StartposImporter startposImporter,
            KifuParserA_Genjo genjo,
            KwErrorHandler errH
            )
        {
        }

        /// <summary>
        /// １ステップずつ実行します。
        /// </summary>
        /// <param name="inputLine"></param>
        /// <param name="kifu"></param>
        /// <param name="larabeLogger"></param>
        /// <returns></returns>
        public string Execute_Step(
            ref KifuParserA_Result result,
            ShogiGui_Base shogiGui_Base,
            KifuParserA_Genjo genjo,
            KwErrorHandler errH
            ,
            [CallerMemberName] string memberName = "",
            [CallerFilePath] string sourceFilePath = "",
            [CallerLineNumber] int sourceLineNumber = 0
            )
        {
            shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode, "Execute_Step",errH);

            try
            {
                errH.Logger.WriteLine_AddMemo("┏━━━━━┓");
                errH.Logger.WriteLine_AddMemo("わたしは　" + this.State.GetType().Name + "　の　Execute_Step　だぜ☆　：　呼出箇所＝" + memberName + "." + sourceFilePath + "." + sourceLineNumber);

                KifuParserA_State nextState;
                shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode, "Execute_Step",errH);
                genjo.InputLine = this.State.Execute(
                    ref result,
                    shogiGui_Base,
                    out nextState, this,
                    genjo, errH);
                this.State = nextState;

            }
            catch (Exception ex) { OwataMinister.ERROR.DonimoNaranAkirameta(ex, "棋譜解析中☆"); throw ex; }

            return genjo.InputLine;
        }

        /// <summary>
        /// 最初から最後まで実行します。（きふわらべCOMP用）
        /// </summary>
        /// <param name="inputLine"></param>
        /// <param name="kifu"></param>
        /// <param name="larabeLogger"></param>
        public void Execute_All(
            ref KifuParserA_Result result,
            ShogiGui_Base shogiGui_Base,
            KifuParserA_Genjo genjo,
            KwErrorHandler errH
            ,
            [CallerMemberName] string memberName = "",
            [CallerFilePath] string sourceFilePath = "",
            [CallerLineNumber] int sourceLineNumber = 0
            )
        {
            shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode, "Execute_All",errH);

            try
            {
                errH.Logger.WriteLine_AddMemo("┏━━━━━━━━━━┓");
                errH.Logger.WriteLine_AddMemo("わたしは　" + this.State.GetType().Name + "　の　Execute_All　だぜ☆　：　呼出箇所＝" + memberName + "." + sourceFilePath + "." + sourceLineNumber);

                KifuParserA_State nextState = this.State;

                while (!genjo.ToBreak)
                {
                    shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode, "Execute_All",errH);
                    genjo.InputLine = this.State.Execute(
                        ref result,
                        shogiGui_Base,
                        out nextState, this,
                        genjo, errH);
                    this.State = nextState;
                }
            }
            catch (Exception ex) { OwataMinister.ERROR.DonimoNaranAkirameta(ex, "棋譜解析中☆"); throw ex; }


        }

    }
}
