﻿using Grayscale.P007_Csv________.L500____Util;
using Grayscale.P011_Random_____.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P021_ConstShogi_.L250____Const;
using Grayscale.P031_ConvText___.L500____Converter;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P505_Atama_Unou_.L___250_Unou;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Windows.Forms;

#if DEBUG
#endif

namespace Grayscale.P505_Atama_Unou_.L250____Unou
{

    public class FeatureVectorImpl : FeatureVector
    {

        /// <summary>
        /// Ｐの１２２４種類の調査項目☆
        ///                         （内訳
        ///                                 ※まず、先手の駒
        ///                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
        ///                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※自分の持ち駒
        ///                                 
        ///                                 ※次に、後手の駒
        ///                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
        ///                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※相手の持ち駒
        ///                         ）
        /// </summary>
        public const int CHOSA_KOMOKU_P = 1224;
        public const int CHOSA_KOMOKU_ENEMY = 612;
        // 変域の見易さを考慮して、逆順で定義。
        public const int CHOSA_KOMOKU_MOTIKAKU___ = CHOSA_KOMOKU_ENEMY - 3;
        public const int CHOSA_KOMOKU_MOTIHISYA__ = CHOSA_KOMOKU_MOTIKAKU___ - 3;
        public const int CHOSA_KOMOKU_MOTIKIN____ = CHOSA_KOMOKU_MOTIHISYA__ - 5;
        public const int CHOSA_KOMOKU_MOTIGIN____ = CHOSA_KOMOKU_MOTIKIN____ - 5;
        public const int CHOSA_KOMOKU_MOTIKEI____ = CHOSA_KOMOKU_MOTIGIN____ - 5;
        public const int CHOSA_KOMOKU_MOTIKYO____ = CHOSA_KOMOKU_MOTIKEI____ - 5;
        public const int CHOSA_KOMOKU_MOTIFU_____ = CHOSA_KOMOKU_MOTIKYO____ - 19;
        public const int CHOSA_KOMOKU_____KAKU___ = CHOSA_KOMOKU_MOTIFU_____ - 81;
        public const int CHOSA_KOMOKU_____HISYA__ = CHOSA_KOMOKU_____KAKU___ - 81;
        public const int CHOSA_KOMOKU_____KIN____ = CHOSA_KOMOKU_____HISYA__ - 81;
        public const int CHOSA_KOMOKU_____GIN____ = CHOSA_KOMOKU_____KIN____ - 81;
        public const int CHOSA_KOMOKU_____KEI____ = CHOSA_KOMOKU_____GIN____ - 81;
        public const int CHOSA_KOMOKU_____KYO____ = CHOSA_KOMOKU_____KEI____ - 81;
        public const int CHOSA_KOMOKU_____FU_____ = CHOSA_KOMOKU_____KYO____ - 81;
        // エラー用、項目該当無し用。
        public const int CHOSA_KOMOKU_ERROR = -1;


        /// <summary>
        /// 駒割の価値。
        /// </summary>
        public double[] Komawari { get; set; }

        /// <summary>
        /// 二駒関係ＫＫ☆
        /// 
        /// 自玉の位置８１マス　×　相手玉の位置８１マス
        /// </summary>
        public double[,] NikomaKankei_KK { get; set; }

        /// <summary>
        /// 二駒関係ＫＰ
        /// 
        /// 自玉の位置８１マス　×　１２２４種類の調査項目
        /// </summary>
        public double[,] NikomaKankei_KP { get; set; }

        /// <summary>
        /// 二駒関係ＰＰ☆
        /// 
        /// １２２４種類の調査項目　×　１２２４種類の調査項目
        /// </summary>
        public double[,] NikomaKankei_PP { get; set; }

        public FeatureVectorImpl()
        {
            this.Komawari = new double[Array_Komasyurui.Items_All.Length];
            this.NikomaKankei_KK = new double[ConstShogi.BAN_SIZE, ConstShogi.BAN_SIZE];
            this.NikomaKankei_KP = new double[ConstShogi.BAN_SIZE, FeatureVectorImpl.CHOSA_KOMOKU_P];
            this.NikomaKankei_PP = new double[FeatureVectorImpl.CHOSA_KOMOKU_P, FeatureVectorImpl.CHOSA_KOMOKU_P];
            //this.Make_Random();
        }

        /// <summary>
        /// 増減の確認用。
        /// </summary>
        /// <returns></returns>
        public double GetTotal_KK()
        {
            double result = 0.0d;

            for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
            {
                for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
                {
                    result += this.NikomaKankei_KK[k1,k2];
                }
            }

            return result;
        }

        /// <summary>
        /// 増減の確認用。
        /// </summary>
        /// <returns></returns>
        public double GetTotal_KP()
        {
            double result = 0.0d;

            for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
            {
                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                {
                    result += this.NikomaKankei_KP[k1, p2];
                }
            }

            return result;
        }

        /// <summary>
        /// 増減の確認用。
        /// </summary>
        /// <returns></returns>
        public double GetTotal_PP()
        {
            double result = 0.0d;

            for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)
            {
                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                {
                    result += this.NikomaKankei_PP[p1, p2];
                }
            }

            return result;
        }


        /// <summary>
        /// ファイルから読み込みます。
        /// </summary>
        /// <param name="filepath"></param>
        public bool Make_FromFile(string filepath)
        {
            bool successful = false;

            if (!File.Exists(filepath))
            {
                MessageBox.Show("ファイルがありません。\npath=[" + filepath + "]", "情報");
                goto gt_EndMethod;
            }

            List<List<string>> table = Util_Csv.ReadCsv(filepath);

            int rowVersion = 0;
            int rowKomawari = 0;
            //int rowKk = 0;
            int rowKp = 0;
            int rowPp = 0;

            foreach(List<string> row in table)
            {
                if(row.Count<1)//空行
                {
                    goto gt_Next;
                }

                string col0 = row[0].Trim();

                if (col0.StartsWith("#"))//コメント行
                {
                    goto gt_Next;
                }
                
                switch(col0)
                {
                    case "Version":
                        rowVersion++;
                        break;
                    case "Komawari":

                        if (row.Count < 2)//エラー
                        {
                            rowKomawari++;
                            goto gt_Next;
                        }
                        else
                        {
                            int col2;
                            int.TryParse( row[2], out col2);

                            switch(rowKomawari)
                            {
                                case 0: this.Komawari[(int)Komasyurui14.H01_Fu_____] = col2; break;
                                case 1: this.Komawari[(int)Komasyurui14.H02_Kyo____] = col2; break;
                                case 2: this.Komawari[(int)Komasyurui14.H03_Kei____] = col2; break;
                                case 3: this.Komawari[(int)Komasyurui14.H04_Gin____] = col2; break;
                                case 4: this.Komawari[(int)Komasyurui14.H05_Kin____] = col2; break;
                                case 5: this.Komawari[(int)Komasyurui14.H06_Oh_____] = col2; break;
                                case 6: this.Komawari[(int)Komasyurui14.H07_Hisya__] = col2; break;
                                case 7: this.Komawari[(int)Komasyurui14.H08_Kaku___] = col2; break;
                                case 8: this.Komawari[(int)Komasyurui14.H11_Tokin__] = col2; break;
                                case 9: this.Komawari[(int)Komasyurui14.H12_NariKyo] = col2; break;
                                case 10: this.Komawari[(int)Komasyurui14.H13_NariKei] = col2; break;
                                case 11: this.Komawari[(int)Komasyurui14.H14_NariGin] = col2; break;
                                case 12: this.Komawari[(int)Komasyurui14.H09_Ryu____] = col2; break;
                                case 13: this.Komawari[(int)Komasyurui14.H10_Uma____] = col2; break;
                                default: break;
                            }
                        }
                        rowKomawari++;
                        break;

                    //case "KK":
                    //    if (row.Count < 2+ConstShogi.BAN_SIZE)//エラー
                    //    {
                    //        rowKk++;
                    //        goto gt_Next;
                    //    }
                    //    else
                    //    {
                            
                    //        for (int k2 = 0; k2 < ConstShogi.BAN_SIZE;k2++ )
                    //        {
                    //            int col;
                    //            int.TryParse(row[2+k2], out col);

                    //            this.NikomaKankei_KK[rowKk, k2] = col;
                    //        }
                    //    }
                    //    rowKk++;
                    //    break;

                    case "KP":
                        if (row.Count < 2 + FeatureVectorImpl.CHOSA_KOMOKU_P)//エラー
                        {
                            rowKp++;
                            goto gt_Next;
                        }
                        else
                        {
                            for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                            {
                                int col;
                                int.TryParse(row[2 + p2], out col);

                                this.NikomaKankei_KP[rowKp, p2] = col;
                            }
                        }
                        rowKp++;
                        break;
                    case "PP":
                        if (row.Count < 2 + FeatureVectorImpl.CHOSA_KOMOKU_P)//エラー
                        {
                            rowPp++;
                            goto gt_Next;
                        }
                        else
                        {
                            for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                            {
                                int col;
                                int.TryParse(row[2 + p2], out col);

                                this.NikomaKankei_PP[rowPp, p2] = col;
                            }
                        }
                        rowPp++;
                        break;
                    default:
                        break;
                }


            gt_Next:
                ;
            }

#if DEBUG
            MessageBox.Show(
                "rowVersion=[" + rowVersion + "]\n"+
                    "rowKomawari=[" + rowKomawari + "]\n" +
                        //"rowKk=[" + rowKk + "]\n" +
                            "rowKp=[" + rowKp + "]\n" +
                                "rowPp=[" + rowPp + "]\n"
            , "デバッグ");
#endif
            successful = true;
        gt_EndMethod:
            return successful;
        }

        /// <summary>
        /// ファイルから読み込みます。
        /// </summary>
        /// <param name="filepath"></param>
        public bool Make_FromFile_KK(string filepath)
        {
            bool successful = false;

#if DEBUG
            System.Console.WriteLine("----------------------------------------");
            System.Console.WriteLine("FV 総合点（読込前）");
            System.Console.WriteLine("    KK =" + this.GetTotal_KK());
            System.Console.WriteLine("    KP =" + this.GetTotal_KP());
            System.Console.WriteLine("    PP =" + this.GetTotal_PP());
            System.Console.WriteLine("----------------------------------------");
#endif

            if (!File.Exists(filepath))
            {
                MessageBox.Show("ファイルがありません。\npath=[" + filepath + "]", "情報");
                goto gt_EndMethod;
            }

            List<List<string>> table = Util_Csv.ReadCsv(filepath);

            int rowVersion = 0;
            int rowKk = 0;

            foreach (List<string> row in table)
            {
                if (row.Count < 1)//空行はスキップ。
                {
                    goto gt_Next;
                }

                string col0 = row[0].Trim();

                if (col0.StartsWith("#"))//コメント行はスキップ。
                {
                    goto gt_Next;
                }

                switch (col0)
                {
                    case "Version":
                        rowVersion++;
                        break;

                    default:
                        if (row.Count < ConstShogi.SUJI_SIZE * ConstShogi.SUJI_SIZE)//エラー行は進む。
                        {
                            rowKk++;
                            goto gt_Next;
                        }
                        else
                        {
                            int k1dan = (int)(rowKk / 9)+1;
                            int k2dan = (int)(rowKk % 9)+1;

                            for (int col = 0; col < ConstShogi.SUJI_SIZE * ConstShogi.SUJI_SIZE; col++)
                            {
                                int k1suji = 9-(int)(col / 9);
                                int k2suji = 9-(int)(col % 9);

                                int value;
                                int.TryParse(row[col], out value);

                                int k1masu = Util_Masu10.Handle_OkibaSujiDanToMasu(Okiba.ShogiBan, k1suji, k1dan);
                                int k2masu = Util_Masu10.Handle_OkibaSujiDanToMasu(Okiba.ShogiBan, k2suji, k2dan);
                                this.NikomaKankei_KK[k1masu, k2masu] = value;
                            }
                        }
                        rowKk++;
                        break;
                }


            gt_Next:
                ;
            }

#if DEBUG
            System.Console.WriteLine("----------------------------------------");
            System.Console.WriteLine("FV 総合点（読込後）");
            System.Console.WriteLine("    KK =" + this.GetTotal_KK());
            System.Console.WriteLine("    KP =" + this.GetTotal_KP());
            System.Console.WriteLine("    PP =" + this.GetTotal_PP());
            System.Console.WriteLine("----------------------------------------");

            MessageBox.Show(
                "rowVersion=[" + rowVersion + "]\n"+
                        "rowKk=[" + rowKk + "]\n"
            , "デバッグ");
#endif
            successful = true;
        gt_EndMethod:
            return successful;
        }

        /// <summary>
        /// 適当に数字を埋めます☆
        /// </summary>
        public void Make_Random()
        {
            //
            // 駒割は固定。
            // コーディングの利便上、エラー駒やヌル駒にもランダム値を入れておく。
            //
            foreach(Komasyurui14 komaSyurui in Array_Komasyurui.Items_All)//
            {
                this.Komawari[(int)komaSyurui] = LarabeRandom.Random.Next(0,999);
            }
            //
            // 
            //
            this.Komawari[(int)Komasyurui14.H00_Null___] = 0;
            this.Komawari[(int)Komasyurui14.H01_Fu_____] = 100;
            this.Komawari[(int)Komasyurui14.H02_Kyo____] = 800;
            this.Komawari[(int)Komasyurui14.H03_Kei____] = 200;
            this.Komawari[(int)Komasyurui14.H04_Gin____] = 500;
            this.Komawari[(int)Komasyurui14.H05_Kin____] = 600;
            // 玉はあとで。
            this.Komawari[(int)Komasyurui14.H07_Hisya__] = 1600;
            this.Komawari[(int)Komasyurui14.H08_Kaku___] = 1600;
            this.Komawari[(int)Komasyurui14.H09_Ryu____] = 2000;
            this.Komawari[(int)Komasyurui14.H10_Uma____] = 2000;
            this.Komawari[(int)Komasyurui14.H11_Tokin__] = 600;
            this.Komawari[(int)Komasyurui14.H12_NariKyo] = 600;
            this.Komawari[(int)Komasyurui14.H13_NariKei] = 600;
            this.Komawari[(int)Komasyurui14.H14_NariGin] = 600;
            //
            // 玉の駒割は計算で求める。 歩100×18 ＋ 香800×4 ＋ 桂200×4 ＋ 銀500×4 ＋ 金600×4 ＋ 飛1600×2 ＋ 角1600×2。
            this.Komawari[(int)Komasyurui14.H06_Oh_____] =
                this.Komawari[(int)Komasyurui14.H01_Fu_____] * 18 +
                this.Komawari[(int)Komasyurui14.H02_Kyo____] * 4 +
                this.Komawari[(int)Komasyurui14.H03_Kei____] * 4 +
                this.Komawari[(int)Komasyurui14.H04_Gin____] * 4 +
                this.Komawari[(int)Komasyurui14.H05_Kin____] * 4 +
                this.Komawari[(int)Komasyurui14.H07_Hisya__] * 2 +
                this.Komawari[(int)Komasyurui14.H08_Kaku___] * 2 +
                0; //

            //
            // KK
            //
            for (int iJigyoku = 0; iJigyoku < ConstShogi.BAN_SIZE; iJigyoku++)//自玉
            {
                for (int iAitegyoku = 0; iAitegyoku < ConstShogi.BAN_SIZE; iAitegyoku++)//相手玉
                {
                    // 0.0～1.0
                    this.NikomaKankei_KK[iJigyoku, iAitegyoku] = LarabeRandom.Random.Next(0,999);
                }
            }

            //
            // KP
            //
            for (int iJigyoku = 0; iJigyoku < ConstShogi.BAN_SIZE; iJigyoku++)//自玉
            {
                for (int iChosaKomoku = 0; iChosaKomoku < FeatureVectorImpl.CHOSA_KOMOKU_P; iChosaKomoku++)//調査項目Ｐ
                {
                    // 0.0～1.0
                    this.NikomaKankei_KP[iJigyoku, iChosaKomoku] = LarabeRandom.Random.Next(0,999);
                }
            }

            //
            // PP
            //
            for (int iChosaKomoku1 = 0; iChosaKomoku1 < FeatureVectorImpl.CHOSA_KOMOKU_P; iChosaKomoku1++)//調査項目Ｐ
            {
                for (int iChosaKomoku2 = 0; iChosaKomoku2 < FeatureVectorImpl.CHOSA_KOMOKU_P; iChosaKomoku2++)//調査項目Ｐ
                {
                    // 0.0～1.0
                    this.NikomaKankei_PP[iChosaKomoku1, iChosaKomoku2] = LarabeRandom.Random.Next(0,999);
                }
            }
        }

        /// <summary>
        /// 「0」→「１一」。
        /// </summary>
        /// <param name="hMasu"></param>
        /// <returns></returns>
        public static string Handle_To_Label(int hMasu)
        {
            string result;

            if (0 <= hMasu && hMasu < ConstShogi.BAN_SIZE)
            {
                SyElement masu = Util_Masu10.HandleToMasu(hMasu);
                int suji;
                Util_MasuNum.TryMasuToSuji(masu, out suji);
                int dan;
                Util_MasuNum.TryMasuToDan(masu, out dan);

                StringBuilder sb = new StringBuilder();
                sb.Append(Conv_Int.ToArabiaSuji(suji));
                sb.Append(Conv_Int.ToKanSuji(dan));
                result = sb.ToString();
            }
            else
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("エラー");
                sb.Append("(");
                sb.Append(hMasu);
                sb.Append(")");
                result = sb.ToString();
            }

            return result;
        }

        /// <summary>
        /// 項目Ｋの番号を、項目名に翻訳。
        /// </summary>
        /// <param name="k"></param>
        /// <returns></returns>
        public static string K_To_Label(int k)
        {
            StringBuilder sb = new StringBuilder();

            if (0 <= k && k < ConstShogi.BAN_SIZE)
            {
                sb.Append("(");
                sb.Append(k);
                sb.Append(")");
                sb.Append(FeatureVectorImpl.Handle_To_Label(k));
            }
            else//エラー
            {
                sb.Append("エラー_k=[");
                sb.Append(k);
                sb.Append("]");
            }

            return sb.ToString();
        }


        /// <summary>
        /// 項目Pの番号を、項目名に翻訳。
        /// </summary>
        /// <param name="p"></param>
        /// <returns></returns>
        public static string P_To_Label(int p)
        {
            StringBuilder sb = new StringBuilder();

            if (0 <= p && p < FeatureVectorImpl.CHOSA_KOMOKU_P)
            {
                sb.Append("(");
                sb.Append(p);
                sb.Append(")");

                /// Ｐの１２２４種類の調査項目☆
                ///                         （内訳
                ///                                 ※まず、先手の駒
                ///                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
                ///                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※自分の持ち駒
                ///                                 
                ///                                 ※次に、後手の駒
                ///                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
                ///                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※相手の持ち駒
                ///                         ）

                // 逆順に並べているので注意
                if ((int)NikomaKankeiP_ChosaKomoku.AiteMotiKaku <= p)//角0～2
                {
                    sb.Append("敵持角");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.AiteMotiKaku);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteMotiHi__ <= p)//飛0～2
                {
                    sb.Append("敵持飛");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.AiteMotiHi__);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteMotiKin_ <= p)//金0～4
                {
                    sb.Append("敵持金");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.AiteMotiKin_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteMotiGin_ <= p)//銀0～4
                {
                    sb.Append("敵持銀");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.AiteMotiGin_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteMotiKei_ <= p)//桂0～4
                {
                    sb.Append("敵持桂");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.AiteMotiKei_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteMotiKyo_ <= p)//香0～4
                {
                    sb.Append("敵持香");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.AiteMotiKyo_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteMotiFu__ <= p)//歩0～18
                {
                    sb.Append("敵持歩");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.AiteMotiFu__);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteBan_Kaku <= p)//角1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kaku));
                    sb.Append("敵角");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteBan_Hi__ <= p)//飛1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.AiteBan_Hi__));
                    sb.Append("敵飛");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteBan_Kin_ <= p)//金1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kin_));
                    sb.Append("敵金");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteBan_Gin_ <= p)//銀1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.AiteBan_Gin_));
                    sb.Append("敵銀");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteBan_Kei_ <= p)//桂1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kei_));
                    sb.Append("敵桂");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteBan_Kyo_ <= p)//香1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kyo_));
                    sb.Append("敵香");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.AiteBan_Fu__ <= p)//歩1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.AiteBan_Fu__));
                    sb.Append("敵歩");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__MotiKaku <= p)//角0～2
                {
                    sb.Append("自持角");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKaku);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__MotiHi__ <= p)//飛0～2
                {
                    sb.Append("自持飛");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.Ji__MotiHi__);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__MotiKin_ <= p)//金0～4
                {
                    sb.Append("自持金");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKin_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__MotiGin_ <= p)//銀0～4
                {
                    sb.Append("自持銀");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.Ji__MotiGin_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__MotiKei_ <= p)//桂0～4
                {
                    sb.Append("自持桂");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKei_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__MotiKyo_ <= p)//香0～4
                {
                    sb.Append("自持香");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKyo_);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__MotiFu__ <= p)//歩0～18
                {
                    sb.Append("自持歩");
                    sb.Append(p - (int)NikomaKankeiP_ChosaKomoku.Ji__MotiFu__);
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kaku <= p)//角1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kaku));
                    sb.Append("自角");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Hi__ <= p)//飛1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Hi__));
                    sb.Append("自飛");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kin_ <= p)//金1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kin_));
                    sb.Append("自金");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Gin_ <= p)//銀1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Gin_));
                    sb.Append("自銀");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kei_ <= p)//桂1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kei_));
                    sb.Append("自桂");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kyo_ <= p)//香1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kyo_));
                    sb.Append("自香");
                }
                else if ((int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Fu__ <= p)//歩1～81
                {
                    sb.Append(FeatureVectorImpl.Handle_To_Label(p - (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Fu__));
                    sb.Append("自歩");
                }
                else// エラー
                {                    
                    sb.Append("エラー_p=[");
                    sb.Append(p);
                    sb.Append("]");
                }
            }
            else// エラー
            {
                sb.Append("エラー_p=[");
                sb.Append(p);
                sb.Append("]");
            }

            return sb.ToString();
        }

    }

}
