﻿using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //フィンガー番号
using Grayscale.P505_Atama_Unou_.L250____Unou;

namespace Grayscale.P505_Atama_Unou_.L500____Util
{

    /// <summary>
    /// フィーチャーベクターの項目番号を算出します。
    /// </summary>
    public abstract class Conv_FvKoumoku
    {
        /// <summary>
        /// ２駒関係[ＫＫ]用。
        /// フィーチャーベクターの調査項目インデックス。該当なければ-1。
        /// </summary>
        /// <param name="pside">プレイヤーサイド</param>
        /// <param name="komasyurui">盤上の種類</param>
        /// <param name="masu">盤上の駒の升</param>
        /// <returns></returns>
        public static int ToKIndex_From_PsideBanjoKomasyuruiMasu(SkyConst src_Sky, Playerside pside)
        {
            // 調査項目番号（Ｋ１、Ｋ２等）
            int result;

            SyElement masu;
            {
                Finger figK1 = Util_Sky_FingersQuery.InOkibaPsideKomasyuruiNow(src_Sky, Okiba.ShogiBan, pside, Komasyurui14.H06_Oh_____).ToFirst();
                RO_Star komaK1 = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figK1).Now);
                masu = komaK1.Masu;
            }

            if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(masu))
            {
                // 盤上でなければ。
                result = -1;
                goto gt_EndMethod;
            }

            result = Util_Masu10.AsMasuNumber(masu);

        gt_EndMethod:
            ;
            return result;
        }


        /// <summary>
        /// ２駒関係[ＰＰ]用。
        /// フィーチャーベクターの調査項目インデックス。該当なければ-1。
        /// </summary>
        /// <param name="pside">プレイヤーサイド</param>
        /// <param name="komasyurui">盤上の種類</param>
        /// <param name="masu">盤上の駒の升</param>
        /// <returns></returns>
        public static int ToPIndex_From_PsideBanjoKomasyuruiMasu(Playerside pside, Komasyurui14 komasyurui, SyElement masu)
        {
            int result = 0;

            if (Okiba.ShogiBan!=Util_Masu10.Masu_ToOkiba(masu))
            {
                // 盤上でなければ。
                result = -1;
                goto gt_EndMethod;
            }

            switch (pside)
            {
                case Playerside.P1: break;
                case Playerside.P2: result+=FeatureVectorImpl.CHOSA_KOMOKU_ENEMY; break;
                default: break;
            }

            switch (komasyurui)
            {
                case Komasyurui14.H11_Tokin__: //thru
                case Komasyurui14.H01_Fu_____: result += FeatureVectorImpl.CHOSA_KOMOKU_____FU_____; break;
                case Komasyurui14.H12_NariKyo: //thru
                case Komasyurui14.H02_Kyo____: result += FeatureVectorImpl.CHOSA_KOMOKU_____KYO____; break;
                case Komasyurui14.H13_NariKei: //thru
                case Komasyurui14.H03_Kei____: result += FeatureVectorImpl.CHOSA_KOMOKU_____KEI____; break;
                case Komasyurui14.H14_NariGin: //thru
                case Komasyurui14.H04_Gin____: result += FeatureVectorImpl.CHOSA_KOMOKU_____GIN____; break;
                case Komasyurui14.H05_Kin____: result += FeatureVectorImpl.CHOSA_KOMOKU_____KIN____; break;
                //case Ks14.H06_Oh_____: // ２駒関係に王はない。
                case Komasyurui14.H09_Ryu____: //thru
                case Komasyurui14.H07_Hisya__: result += FeatureVectorImpl.CHOSA_KOMOKU_____HISYA__; break;
                case Komasyurui14.H10_Uma____: //thru
                case Komasyurui14.H08_Kaku___: result += FeatureVectorImpl.CHOSA_KOMOKU_____KAKU___; break;
                default: result = -1; goto gt_EndMethod;
            }

            result += Util_Masu10.AsMasuNumber(masu);

        gt_EndMethod:
            ;
            return result;
        }

        /// <summary>
        /// ２駒関係[ＰＰ]用。
        /// フィーチャーベクターの調査項目インデックス。該当なければ-1。
        /// </summary>
        /// <param name="pside">プレイヤーサイド</param>
        /// <param name="komasyurui">持駒の種類</param>
        /// <param name="count">その持駒の種類の、持っている個数</param>
        /// <returns></returns>
        public static int ToPIndex_From_PsideMotiKomasyuruiKosu(Playerside pside, Komasyurui14 komasyurui, int count)
        {
            int result = 0;

            switch (pside)
            {
                case Playerside.P1: break;
                case Playerside.P2: result += FeatureVectorImpl.CHOSA_KOMOKU_ENEMY; break;
                default: break;
            }

            switch (komasyurui)
            {
                //case Ks14.H11_Tokin__: //駒台にない。
                case Komasyurui14.H01_Fu_____: result += FeatureVectorImpl.CHOSA_KOMOKU_MOTIFU_____; break;
                //case Ks14.H12_NariKyo: //駒台にない。
                case Komasyurui14.H02_Kyo____: result += FeatureVectorImpl.CHOSA_KOMOKU_MOTIKYO____; break;
                //case Ks14.H13_NariKei: //駒台にない。
                case Komasyurui14.H03_Kei____: result += FeatureVectorImpl.CHOSA_KOMOKU_MOTIKEI____; break;
                //case Ks14.H14_NariGin: //駒台にない。
                case Komasyurui14.H04_Gin____: result += FeatureVectorImpl.CHOSA_KOMOKU_MOTIGIN____; break;
                case Komasyurui14.H05_Kin____: result += FeatureVectorImpl.CHOSA_KOMOKU_MOTIKIN____; break;
                //case Ks14.H06_Oh_____: // 駒台にない。
                //case Ks14.H09_Ryu____: //駒台にない。
                case Komasyurui14.H07_Hisya__: result += FeatureVectorImpl.CHOSA_KOMOKU_MOTIHISYA__; break;
                //case Ks14.H10_Uma____: //駒台にない。
                case Komasyurui14.H08_Kaku___: result += FeatureVectorImpl.CHOSA_KOMOKU_MOTIKAKU___; break;
                default: result = -1; goto gt_EndMethod;
            }

            result += count;//持ち駒の数

        gt_EndMethod:
            ;
            return result;
        }

    }


}
