﻿using Grayscale.P021_ConstShogi_.L250____Const;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P505_Atama_Unou_.L___250_Unou;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using System.Text;

namespace Grayscale.P505_Atama_Unou_.L510____UtilFvFormat
{
    public abstract class Util_TiredVectorFormat
    {

        /// <summary>
        /// テキストを作ります。
        /// </summary>
        /// <param name="tv"></param>
        /// <returns></returns>
        public static string Format_Text(TiredVector tv)
        {
            StringBuilder sb = new StringBuilder();

            //
            // コメント
            //
            sb.AppendLine("\"#紹介文\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#タイアド・ベクター。\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#２駒関係のパラメーターの、更新回数の累計。\",");
            sb.AppendLine("\"#よく更新が頻発する箇所は、飽きてくる☆　学習効果が下がる。\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#0から始まり、数字はえんえんと増えていくぜ☆\",");

            //
            // 仕様バージョン
            //
            sb.AppendLine();
            sb.AppendLine("\"Version\",1.0,");

            //
            // 駒割
            //
            sb.AppendLine();
            sb.AppendLine("\"#KomaWari 駒割の更新回数。\",");//コメント行

            sb.Append("\"Komawari\",\"(0)歩\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H01_Fu_____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(1)香\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H02_Kyo____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(2)桂\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H03_Kei____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(3)銀\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H04_Gin____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(4)金\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H05_Kin____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(5)玉\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H06_Oh_____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(6)飛\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H07_Hisya__]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(7)角\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H08_Kaku___]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(8)と金\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H11_Tokin__]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(9)成香\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H12_NariKyo]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(10)成桂\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H13_NariKei]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(11)成銀\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H14_NariGin]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(12)竜\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H09_Ryu____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(13)馬\",");
            sb.Append(tv.Komawari[(int)Komasyurui14.H10_Uma____]);
            sb.AppendLine(",");


            //
            // KK
            //
            sb.AppendLine();
            sb.AppendLine("\"#KK 行が自玉、列が敵玉\",");//コメント行
            sb.Append("\"#\",\"#\",");//列見出し行
            for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
            {
                sb.Append("\"");
                sb.Append(FeatureVectorImpl.K_To_Label(k2));
                sb.Append("\",");
            }
            sb.AppendLine();
            for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)//データ行
            {
                sb.Append("\"KK\",\"");// 行見出し
                sb.Append(FeatureVectorImpl.K_To_Label(k1));
                sb.Append("\",");

                for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)//データ列
                {
                    sb.Append(tv.NikomaKankei_KK[k1,k2]);
                    sb.Append(",");
                }

                sb.AppendLine();
            }

            //
            // KP
            //
            sb.AppendLine("");
            sb.AppendLine("\"#KP 行が自玉、列が調査項目\",");//コメント行
            sb.Append("\"#\",\"#\",");//列見出し行
            for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
            {
                sb.Append("\"");
                sb.Append(FeatureVectorImpl.P_To_Label(p2));
                sb.Append("\",");
            }
            sb.AppendLine();
            for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)//データ行
            {
                sb.Append("\"KP\",\"");// 行見出し
                sb.Append(FeatureVectorImpl.K_To_Label(k1));
                sb.Append("\",");

                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)//データ列
                {
                    sb.Append(tv.NikomaKankei_KP[k1, p2]);
                    sb.Append(",");
                }

                sb.AppendLine();
            }

            //
            // PP
            //
            sb.AppendLine("");
            sb.AppendLine("\"#PP P1P2も、P2P1も同じなので表は半分で済むが、入れている\",");//コメント行
            sb.Append("\"#\",\"#\",");//列見出し行
            for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
            {
                sb.Append("\"");
                sb.Append(FeatureVectorImpl.P_To_Label(p2));
                sb.Append("\",");
            }
            sb.AppendLine();
            for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)//データ行
            {
                sb.Append("\"PP\",\"");// 行見出し
                sb.Append(FeatureVectorImpl.P_To_Label(p1));
                sb.Append("\",");

                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)//データ列
                {
                    sb.Append(tv.NikomaKankei_PP[p1, p2]);
                    sb.Append(",");
                }

                sb.AppendLine();
            }

            return sb.ToString();
        }


    }
}
