﻿
namespace Grayscale.P505_Atama_Unou_.L___250_Unou
{
    public interface FeatureVector
    {
        /// <summary>
        /// 駒割の価値。
        /// </summary>
        double[] Komawari { get; set; }

        /// <summary>
        /// 二駒関係ＫＫ☆
        /// 
        /// 自玉の位置８１マス　×　相手玉の位置８１マス
        /// </summary>
        double[,] NikomaKankei_KK { get; set; }

        /// <summary>
        /// 二駒関係ＫＰ
        /// 
        /// 自玉の位置８１マス　×　１２２４種類の調査項目
        /// </summary>
        double[,] NikomaKankei_KP { get; set; }

        /// <summary>
        /// 二駒関係ＰＰ☆
        /// 
        /// １２２４種類の調査項目　×　１２２４種類の調査項目
        /// </summary>
        double[,] NikomaKankei_PP { get; set; }

        /// <summary>
        /// 増減の確認用。
        /// </summary>
        /// <returns></returns>
        double GetTotal_KK();

        /// <summary>
        /// 増減の確認用。
        /// </summary>
        /// <returns></returns>
        double GetTotal_KP();

        /// <summary>
        /// 増減の確認用。
        /// </summary>
        /// <returns></returns>
        double GetTotal_PP();
        
        /// <summary>
        /// ファイルから読み込みます。
        /// </summary>
        /// <param name="filepath"></param>
        bool Make_FromFile(string filepath);

        /// <summary>
        /// ファイルから読み込みます。
        /// </summary>
        /// <param name="filepath"></param>
        bool Make_FromFile_KK(string filepath);

        /// <summary>
        /// 適当に数字を埋めます☆
        /// </summary>
        void Make_Random();

    }
}
