﻿using Grayscale.P013_Collection_.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P256_SeizaFinger.L250____Struct;
using Grayscale.P363_KyokumMoves.L250____Struct;
using Grayscale.P363_KyokumMoves.L500____Util;
using Grayscale.P507_Atama______.L___125_Sokutei;
using System.Collections.Generic;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P507_Atama______.L125____Sokutei
{

    public class KomanoKikiImpl : KomanoKiki
    {
        /// <summary>
        /// 枡毎の、味方、敵。
        /// </summary>
        private Dictionary<int, Playerside> HMasu_PlayersideList { get; set; }

        /// <summary>
        /// 枡毎の、利き数。
        /// </summary>
        public Dictionary<int, int> Kikisu_AtMasu_1P { get; set; }
        public Dictionary<int, int> Kikisu_AtMasu_2P { get; set; }



        private KomanoKikiImpl()
        {
            this.HMasu_PlayersideList = new Dictionary<int, Playerside>();
            for (int masuIndex = 0; masuIndex < 202; masuIndex++)
            {
                this.HMasu_PlayersideList.Add(masuIndex, Playerside.Empty);
            }

            this.Kikisu_AtMasu_1P = new Dictionary<int, int>();
            for (int masuIndex = 0; masuIndex < 202; masuIndex++)
            {
                this.Kikisu_AtMasu_1P.Add(masuIndex, 0);
            }

            this.Kikisu_AtMasu_2P = new Dictionary<int, int>();
            for (int masuIndex = 0; masuIndex < 202; masuIndex++)
            {
                this.Kikisu_AtMasu_2P.Add(masuIndex, 0);
            }
        }


        /// <summary>
        /// 駒の利きを調べます。
        /// </summary>
        /// <param name="src_Sky"></param>
        /// <returns></returns>
        public static KomanoKikiImpl MasuBETUKikisu(
            Node<Starbeamable, KyokumenWrapper>  node_forLog,
            SkyConst src_Sky, Playerside tebanside)
        {

            // ①現手番の駒の移動可能場所_被王手含む
            List_OneAndMulti<Finger, SySet<SyElement>> komaBETUSusumeruMasus;

            Util_KyokumenMoves.LA_Split_KomaBETUSusumeruMasus(
                3,
                node_forLog,
                out komaBETUSusumeruMasus,//進めるマス
                new MmGenjo_MovableMasuImpl(
                    true,//本将棋か
                    src_Sky,//現在の局面
                    tebanside,//手番
                    false//相手番か
                ),
                null
            );

            KomanoKikiImpl self = new KomanoKikiImpl();

            //
            // 「升ごとの敵味方」を調べます。
            //
            foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
            {
                RO_Star koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);

                self.HMasu_PlayersideList[Util_Masu10.AsMasuNumber(koma.Masu)] = koma.Pside;
            }

            //
            // 駒のない升は無視します。
            //

            //
            // 駒のあるマスに、その駒の味方のコマが効いていれば　味方＋１
            //
            foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
            {
                //
                // 駒
                //
                RO_Star koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);

                // 将棋盤上の戦駒のみ判定
                if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(koma.Masu))
                {
                    goto gt_Next1;
                }


                //
                // 駒の利きカウント FIXME:貫通してないか？
                //
                komaBETUSusumeruMasus.Foreach_Entry((Finger figKoma2, SySet<SyElement> kikiZukei, ref bool toBreak) =>
                {
                    IEnumerable<SyElement> kikiMasuList = kikiZukei.Elements;
                    foreach (SyElement masu in kikiMasuList)
                    {
                        // その枡に利いている駒のハンドルを追加
                        if (self.HMasu_PlayersideList[Util_Masu10.AsMasuNumber(masu)] == Playerside.Empty)
                        {
                            // 駒のないマスは無視。
                        }
                        else if (Playerside.P1 == koma.Pside)
                        {
                            // 利きのあるマスにある駒と、この駒のプレイヤーサイドが同じ。
                            self.Kikisu_AtMasu_1P[Util_Masu10.AsMasuNumber(masu)] += 1;
                        }
                        else
                        {
                            // 反対の場合。
                            self.Kikisu_AtMasu_2P[Util_Masu10.AsMasuNumber(masu)] += 1;
                        }
                    }
                });

            gt_Next1:
                ;
            }

            return self;

        }

    }

}
