﻿using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P507_Atama______.L___250_KyHandanOrder;

namespace Grayscale.P507_Atama______.L250____UtilKyHandanOrder
{

    /// <summary>
    /// 局面判断オーダー。
    /// </summary>
    public abstract class Util_KyHandanOrder
    {
        /// <summary>
        /// 判断オーダー別、自信クラス別倍率。
        /// </summary>
        public static double Get_JisinClassBetu_Bairitu(KyHandanOrderName handanOrderName, KyHyokaKoumokuName hyokaKoumokuName, KyJisinClass jisinClass)
        {
            return Util_KyHandanOrder.JisinClassBetu_Bairitu[(int)handanOrderName,(int)hyokaKoumokuName,(int)jisinClass];
        }
        private static readonly double[,,] JisinClassBetu_Bairitu;

        static Util_KyHandanOrder()
        {
            //--------------------------------------------------------------------------------
            // 要素数の更新漏れに注意
            //--------------------------------------------------------------------------------
            int handanOrderSu = 2;
            int hyokaKoumokuSu = 12;
            int jisinClassSu = 7;
            Util_KyHandanOrder.JisinClassBetu_Bairitu = new double[handanOrderSu,hyokaKoumokuSu,jisinClassSu];
            double[, ,] d = Util_KyHandanOrder.JisinClassBetu_Bairitu;// 変数名を短くする。

            //
            // 判断オーダー0
            //
            {
                int a = (int)KyHandanOrderName.Error;
                //double[,] order = new double[hyokaKoumokuSu, jisinClassSu];
                //Util_KyHandanOrder.JisinClassBetu_Bairitu[a, (int)KyHyokaKoumokuName.Unknown___________, (int)KyJisinClass.UNKNOWN] = order;

                d[a, (int)KyHyokaKoumokuName.Unknown___________, (int)KyJisinClass.UNKNOWN] = 0.0d;
            }

            //
            // 判断オーダー1
            //
            {
                int a = (int)KyHandanOrderName.Default;
                int b;
                //double[,] order = new double[hyokaKoumokuSu, jisinClassSu];
                //Util_KyHandanOrder.JisinClassBetu_Bairitu[a] = order;

                b = (int)KyHyokaKoumokuName.Unknown___________;
                d[a,b,(int)KyJisinClass.UNKNOWN] = 0.0d;

                b = (int)KyHyokaKoumokuName.GyokuNoMamori_____;
                d[a,b,(int)KyJisinClass.M_] = 200.0d;
                d[a,b,(int)KyJisinClass.A_] = 200.0d;
                d[a,b,(int)KyJisinClass.B1] = 200.0d;
                d[a,b,(int)KyJisinClass.B2] = 200.0d;
                d[a,b,(int)KyJisinClass.C1] = 200.0d;
                d[a,b,(int)KyJisinClass.C2] = 200.0d;

                b = (int)KyHyokaKoumokuName.Himoduki__________;
                d[a, b, (int)KyJisinClass.M_] = 1000d;//510d→5.1d→51d→510d→5100d
                d[a, b, (int)KyJisinClass.A_] = 1000d;
                d[a, b, (int)KyJisinClass.B1] = 1000d;
                d[a, b, (int)KyJisinClass.B2] = 1000d;
                d[a, b, (int)KyJisinClass.C1] = 1000d;
                d[a, b, (int)KyJisinClass.C2] = 1000d;

                b = (int)KyHyokaKoumokuName.Ido_______________;
                d[a,b,(int)KyJisinClass.M_] =  500.0d;//0～1000。
                d[a,b,(int)KyJisinClass.A_] =  500.0d;
                d[a,b,(int)KyJisinClass.B1] =  500.0d;
                d[a,b,(int)KyJisinClass.B2] =  500.0d;
                d[a,b,(int)KyJisinClass.C1] =  500.0d;
                d[a,b,(int)KyJisinClass.C2] =  500.0d;

                b = (int)KyHyokaKoumokuName.KakuTouNoHimoduki_;
                d[a,b,(int)KyJisinClass.M_] =  1000.0d;// 100→1000という極端な点数を叩き出すように設定。
                d[a,b,(int)KyJisinClass.A_] =  1000.0d;// 歩で叩かれたら、角頭に歩を置いておくだけではだめで、目の前の歩を取るということもしないといけない。
                d[a,b,(int)KyJisinClass.B1] =  1000.0d;
                d[a,b,(int)KyJisinClass.B2] =  1000.0d;
                d[a,b,(int)KyJisinClass.C1] =  1000.0d;
                d[a,b,(int)KyJisinClass.C2] =  1000.0d;

                b = (int)KyHyokaKoumokuName.Kimagure__________;
                d[a, b, (int)KyJisinClass.M_] = 333.3d;//きまぐれ（紐付きの1/3ぐらいで）
                d[a, b, (int)KyJisinClass.A_] = 333.3d;
                d[a, b, (int)KyJisinClass.B1] = 333.3d;
                d[a, b, (int)KyJisinClass.B2] = 333.3d;
                d[a, b, (int)KyJisinClass.C1] = 333.3d;
                d[a, b, (int)KyJisinClass.C2] = 333.3d;

                b = (int)KyHyokaKoumokuName.KomaDoku__________;
                d[a,b,(int)KyJisinClass.M_] =  100000.0d;// 歩＝１００点のとき 100000.0d にしたが、歩＝１００／１６６００（王）に改造したので 10000000.0d にした。
                d[a,b,(int)KyJisinClass.A_] =  100000.0d;
                d[a,b,(int)KyJisinClass.B1] =  100000.0d;
                d[a,b,(int)KyJisinClass.B2] =  100000.0d;
                d[a,b,(int)KyJisinClass.C1] =  100000.0d;
                d[a,b,(int)KyJisinClass.C2] =  100000.0d;

                b = (int)KyHyokaKoumokuName.MenomaenoFuWoTore_;
                d[a,b,(int)KyJisinClass.M_] =  450.0d;
                d[a,b,(int)KyJisinClass.A_] =  450.0d;
                d[a,b,(int)KyJisinClass.B1] =  450.0d;
                d[a,b,(int)KyJisinClass.B2] =  450.0d;
                d[a,b,(int)KyJisinClass.C1] =  450.0d;
                d[a,b,(int)KyJisinClass.C2] =  450.0d;

                b = (int)KyHyokaKoumokuName.NikomaKankeiKkKpPp;
                d[a,b,(int)KyJisinClass.M_] =  100000.0d;//※KK、KP、PPを足すとでかくなるので、jisinTenは小さくしてある。
                d[a,b,(int)KyJisinClass.A_] =  100000.0d;
                d[a,b,(int)KyJisinClass.B1] =  100000.0d;
                d[a,b,(int)KyJisinClass.B2] =  100000.0d;
                d[a,b,(int)KyJisinClass.C1] =  100000.0d;
                d[a,b,(int)KyJisinClass.C2] =  100000.0d;

                b = (int)KyHyokaKoumokuName.Toosi_____________;
                d[a,b,(int)KyJisinClass.M_] =  500.0d;
                d[a,b,(int)KyJisinClass.A_] =  500.0d;
                d[a,b,(int)KyJisinClass.B1] =  500.0d;
                d[a,b,(int)KyJisinClass.B2] =  500.0d;
                d[a,b,(int)KyJisinClass.C1] =  500.0d;
                d[a,b,(int)KyJisinClass.C2] =  500.0d;

                b = (int)KyHyokaKoumokuName.Toru______________;
                d[a,b,(int)KyJisinClass.M_] =  10.0d;
                d[a,b,(int)KyJisinClass.A_] =  10.0d;
                d[a,b,(int)KyJisinClass.B1] =  10.0d;
                d[a,b,(int)KyJisinClass.B2] =  10.0d;
                d[a,b,(int)KyJisinClass.C1] =  10.0d;
                d[a,b,(int)KyJisinClass.C2] =  10.0d;

                b = (int)KyHyokaKoumokuName.Tukisute__________;
                d[a,b,(int)KyJisinClass.M_] =  100.0d;
                d[a,b,(int)KyJisinClass.A_] =  100.0d;
                d[a,b,(int)KyJisinClass.B1] =  100.0d;
                d[a,b,(int)KyJisinClass.B2] =  100.0d;
                d[a,b,(int)KyJisinClass.C1] =  100.0d;
                d[a,b,(int)KyJisinClass.C2] =  100.0d;
            }
        }
    }

}
