﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;

namespace Grayscale.P507_Atama______.L500____KyHandan
{

    /// <summary>
    /// 局面の得点計算。
    /// </summary>
    public abstract class KyHandanAbstract : KyHandan
    {

        /// <summary>
        /// 名前
        /// </summary>
        public TenonagareName Name
        {
            get
            {
                return this.name;
            }
        }
        private TenonagareName name;

        /// <summary>
        /// コンストラクター。
        /// </summary>
        /// <param name="name"></param>
        public KyHandanAbstract(TenonagareName name)
        {
            this.name = name;
        }

        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="keisanArgs"></param>
        /// <returns></returns>
        abstract public void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs keisanArgs, KwErrorHandler errH);

    }
}
