﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P256_SeizaFinger.L250____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using System.Collections.Generic;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    /// <summary>
    /// 「玉の守り」
    /// 
    /// 自玉の近くに、自分の金、銀があれば加点。それ以外の駒は無視。
    /// 
    /// ただし、自分の回りに３枚目の金、銀（どれかは適当）があった時点で計算を中断します。
    /// （４枚目以降の金銀は、加点しません）
    /// 
    /// </summary>
    public class KyHandan_GyokuNoMamori : KyHandanAbstract
    {
        public KyHandan_GyokuNoMamori():base(TenonagareName.GyokuNoMamori)
        {
        }


        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen = 0.0d;//互角
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;

            //
            // 1P玉と、2P玉。
            //
            RO_Star koma_1PGyoku_orNull;
            RO_Star koma_2PGyoku_orNull;
            Util_Sky_FingersQueryFx.Split_1PGyoku_2PGyoku(out koma_1PGyoku_orNull,out koma_2PGyoku_orNull, src_Sky);

            //
            // 25近傍に、得点の重みを付けます。単純に、同心円とします。
            //
            // 金・銀３枚が近くにあれば 1.0 になる想定です。
            //
            double kk = 0.0d;
            double aa = 1.0d / 3.0d;
            double bb = 1.0d / 3.0d / 3.0d;
            double cc = 1.0d / 3.0d / 3.0d / 3.0d;
            double dd = 1.0d / 3.0d / 3.0d / 3.0d / 3.0d;
            double ee = 1.0d / 3.0d / 3.0d / 3.0d / 3.0d / 3.0d;
            double[] omomi = new double[]{
                    ee, dd, cc, dd, ee,
                    dd, bb, aa, bb, dd,
                    cc, aa, kk, aa, cc,
                    dd, bb, aa, bb, dd,
                    ee, dd, cc, dd, ee,
                };

            //
            // 先手玉
            //
            if (null!=koma_1PGyoku_orNull)
            {
                Playerside pside = Playerside.P1;

                int gyoku_Suji;
                Util_MasuNum.TryMasuToSuji(koma_1PGyoku_orNull.Masu, out gyoku_Suji);
                int gyoku_Dan;
                Util_MasuNum.TryMasuToDan(koma_1PGyoku_orNull.Masu, out gyoku_Dan);

                jisinTen += this.GetJisinten(src_Sky, pside, gyoku_Suji, gyoku_Dan, omomi);
            }

            //
            // 後手玉
            //
            if (null != koma_2PGyoku_orNull)
            {
                Playerside pside = Playerside.P2;

                int gyoku_Suji;
                Util_MasuNum.TryMasuToSuji(koma_2PGyoku_orNull.Masu, out gyoku_Suji);
                int gyoku_Dan;
                Util_MasuNum.TryMasuToDan(koma_2PGyoku_orNull.Masu, out gyoku_Dan);

                jisinTen += this.GetJisinten(src_Sky, pside, gyoku_Suji, gyoku_Dan, omomi);
            }

        //gt_EndMethod:
            string utiwake = "";
#if DEBUG
            // 明細の作成
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("略");
                utiwake = sb.ToString();
            }
#endif

            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.GyokuNoMamori_____,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }


        /// <summary>
        /// 自信点の取得
        /// </summary>
        private double GetJisinten(SkyConst src_Sky, Playerside pside, int gyoku_Suji, int gyoku_Dan, double[] omomi)
        {
            double jisinTen = 0.0d;//互角

            int[] sujis = new int[25];
            int[] dans = new int[25];
            {
                //
                // 25近傍の筋と段。12の位置に、視点の中心となる駒があるとします。
                //
                //    -2  -1   0  +1  +2
                //  ┌─┬─┬─┬─┬─┐
                //-2│ 0│ 1│ 2│ 3│ 4│
                //  ├─┼─┼─┼─┼─┤
                //-1│ 5│ 6│ 7│ 8│ 9│
                //  ├─┼─┼─┼─┼─┤
                // 0│10│11│12│13│14│
                //  ├─┼─┼─┼─┼─┤
                //+1│15│16│17│18│19│
                //  ├─┼─┼─┼─┼─┤
                //+2│20│21│22│23│24│
                //  └─┴─┴─┴─┴─┘
                //
                int index = 0;
                for (int dDan = -2; dDan < 3; dDan++)
                {
                    for (int dSuji = -2; dSuji < 3; dSuji++)
                    {
                        sujis[index] = gyoku_Suji + dSuji;
                        dans[index] = gyoku_Dan + dDan;
                        index++;
                    }
                }
            }

            // 25近傍のマス番号を取得しておきます。該当がなければ Masu_Honshogi.Error。
            Dictionary<SyElement, double> masuOmomi = new Dictionary<SyElement, double>();
            {
                for (int index = 0; index < 25; index++)
                {
                    SyElement masu = Util_Masu10.OkibaSujiDanToMasu(Okiba.ShogiBan, sujis[index], dans[index]);
                    if (masu != Masu_Honshogi.Error)
                    {
                        masuOmomi.Add(masu, omomi[index]);
                    }
                }
            }

            //
            // 味方の金、銀について。
            // ３つを想定しているものの、４つ以上あっても単純に足します。
            //
            foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
            {
                RO_Star koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);

                if (koma.Pside == pside &&
                    (
                        koma.Komasyurui == Komasyurui14.H04_Gin____
                     || koma.Komasyurui == Komasyurui14.H05_Kin____
                     || koma.Komasyurui == Komasyurui14.H09_Ryu____
                     || koma.Komasyurui == Komasyurui14.H10_Uma____
                     || koma.Komasyurui == Komasyurui14.H11_Tokin__
                     || koma.Komasyurui == Komasyurui14.H12_NariKyo
                     || koma.Komasyurui == Komasyurui14.H13_NariKei
                     || koma.Komasyurui == Komasyurui14.H14_NariGin
                     )
                    )
                {
                    if (masuOmomi.ContainsKey(koma.Masu))
                    {
                        jisinTen += masuOmomi[koma.Masu];
                    }
                }
            }

            if(1.0d<jisinTen)//リミットチェック
            {
                jisinTen = 1.0d;
            }

            if (pside==Playerside.P2)
            {
                jisinTen *= -1;//符号反転
            }

            return jisinTen;
        }

    }
}
