﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P256_SeizaFinger.L250____Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___125_Sokutei;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L125____Sokutei;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号


#if DEBUG
using System.Text;
using System.Collections.Generic;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    /// <summary>
    /// 評価計算
    /// 
    /// 紐が付いていたら加点。
    /// </summary>
    public class KyHandan_Himoduki : KyHandanAbstract
    {

        public KyHandan_Himoduki():base(TenonagareName.Himoduki)
        {
        }


        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen = 0.0;//互角
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;

            //
            // 駒の利きの計算。
            //
            KomanoKiki komanoKiki = KomanoKikiImpl.MasuBETUKikisu(
                args.Node,
                src_Sky,
                args.Node.Value.ToKyokumenConst.KaisiPside);







            //
            // 1P
            //
            int p1_lose = 0; // 利きの枚数で相手が勝っていた件数。
#if DEBUG
            List<string> p1_yaburareruMasu = new List<string>();
#endif
            {
                Playerside pside = Playerside.P1;
                //
                // 「紐が付いていない駒の少なさ」による加点。
                //
                //int p1_himoduki = 0; // 味方の駒に、味方の駒の利きが１つ被っていれば＋１。
                //int p1_neraware = 0; // 味方の駒に、相手の駒の利きが１つ被っていれば＋１。

                //
                // 味方の駒があるマスの得点は、マイナスなら集計。（減点法）
                // 敵の駒があるマスの得点は、プラスなら集計。（減点法）
                //
                // 駒は４０枚あり、貫通して加点するのもある。
                //
                foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
                {
                    RO_Star koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);

                    if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(koma.Masu))
                    {
                        goto gt_Next2;
                    }

                    if (pside == koma.Pside)
                    {
                        // 1Pの駒

                        // その升に利いている 1P の利きの数。
                        int p1_kiki = komanoKiki.Kikisu_AtMasu_1P[Util_Masu10.AsMasuNumber(koma.Masu)];//FIXME:

                        // その升に利いている 2P の利きの数。
                        int p2_kiki = komanoKiki.Kikisu_AtMasu_2P[Util_Masu10.AsMasuNumber(koma.Masu)];//FIXME:

                        //switch (src_Sky.KaisiPside)//例えば歩がぶつかっているとお互い利きが被っていて±０なので、手番側が＋１になるよう、効きを２倍にします。
                        //{
                        //    case Playerside.P1: p1_kiki *= 2; break;
                        //    case Playerside.P2: p2_kiki *= 2; break;
                        //}
                        //p1_himoduki += p1_kiki;
                        //p1_neraware += p2_kiki;

                        // 破られる場合
                        if (p1_kiki < p2_kiki)
                        {
                            p1_lose++;
#if DEBUG
                            p1_yaburareruMasu.Add(Util_Masu10.ToSujiKanji(koma.Masu));
#endif
                        }
                    }

                gt_Next2:
                    ;
                }
            }

            //
            // 2P
            //
            int p2_lose = 0; // 利きの枚数で味方が勝っていた件数。
#if DEBUG
            List<string> p2_yaburareruMasu = new List<string>();
#endif
            {
                Playerside pside = Playerside.P2;
                //
                // 「紐が付いていない駒の少なさ」による加点。
                //
                //int p2_himoduki = 0; // 相手の駒に、相手の駒の利きが１つ被っていれば＋１。
                //int p2_neraware = 0; // 相手の駒に、味方の駒の利きが１つ被っていれば＋１。


                //
                // 味方の駒があるマスの得点は、マイナスなら集計。（減点法）
                // 敵の駒があるマスの得点は、プラスなら集計。（減点法）
                //
                // 駒は４０枚あり、貫通して加点するのもある。
                //
                foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
                {
                    RO_Star koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);

                    if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(koma.Masu))
                    {
                        goto gt_Next2;
                    }

                    if (pside == koma.Pside)
                    {
                        // 2Pの駒

                        // その升に利いている相手の利きの数。
                        int p2_kiki = komanoKiki.Kikisu_AtMasu_2P[Util_Masu10.AsMasuNumber(koma.Masu)];//FIXME:

                        // その升に利いている味方の利きの数。
                        int p1_kiki = komanoKiki.Kikisu_AtMasu_1P[Util_Masu10.AsMasuNumber(koma.Masu)];//FIXME:

                        //switch (src_Sky.KaisiPside)//例えば歩がぶつかっているとお互い利きが被っていて±０なので、手番側が＋１になるよう、効きを２倍にします。
                        //{
                        //    case Playerside.P1: p1_kiki *= 2; break;
                        //    case Playerside.P2: p2_kiki *= 2; break;
                        //}

                        //p2_himoduki += p2_kiki;
                        //p2_neraware += p1_kiki;

                        // 破られる場合
                        if (p2_kiki < p1_kiki)
                        {
                            p2_lose++;
#if DEBUG
                            p2_yaburareruMasu.Add(Util_Masu10.ToSujiKanji(koma.Masu));
#endif
                        }
                    }

                gt_Next2:
                    ;
                }
            }






            //
            // 3箇所、破れている差があれば、1.0の差になるものとします。
            //
            jisinTen = 1.0d * (double)(p2_lose - p1_lose) / 3.0d;

            string utiwake = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();
                sb.Append(" " + jisinTen);
                sb.Append("点    ");
                sb.Append(" 衝突箇所勝ち数=" + (p2_lose - p1_lose));
                sb.Append(" 1Pが破られる" + p1_lose + "箇所");
                foreach (string s in p1_yaburareruMasu)
                {
                    sb.Append("[");
                    sb.Append(s);
                    sb.Append("]");
                }

                sb.Append(" 2Pが破られる" + p2_lose + "箇所");
                foreach (string s in p2_yaburareruMasu)
                {
                    sb.Append("[");
                    sb.Append(s);
                    sb.Append("]");
                }
                utiwake = sb.ToString();
            }
#endif

            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.Himoduki__________,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }


    }
}
