﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using Grayscale.P507_Atama______.L490____UtilSokutei;

#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    /// <summary>
    /// 「取る」。
    /// </summary>
    public class KyHandan_Ido : KyHandanAbstract
    {

        public KyHandan_Ido():base(TenonagareName.Ido)
        {
        }


        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen = 0.0d;//互角
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;

            //
            // どの駒（のある場所）が
            // 指定のマスより、どれぐらい離れているか（距離）
            //
            int kyori = Util_KomanoKyori.GetKyori(args.TenonagareGenjo.Masu, args.TenonagareGenjo.Koma1.Masu);
            jisinTen = 1.0d - (3.0d * (double)kyori / 100.0d);//てきとーな数字です。

            if (args.PlayerInfo.Playerside == Playerside.P2)
            {
                jisinTen *= -1;//符号反転
            }

            //// ログ
            //{
            //    string sasite = Converter04.Sasite_ToString_ForLog(args.Input_node.Key);// どの指し手の局面で
            //    ((ShogiEngine)args.Owner).Log_Engine.WriteLine_AddMemo("駒[" + Haiyaku184Array.Name[(int)koma.Haiyaku].Trim() + "(No." + (int)((Atamanosumi)args.atamanosumi).Finger + ")]が、マス[" + Converter04.Masu_ToKanji(((Atamanosumi)args.Input_atamanosumi).Masu) + "]を目指したいんだぜ～☆。指し手が[" + sasite + "]なら、距離は[" + kyori + "]、スコアは[" + score + "]だぜ☆");
            //}

            string utiwake = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("1 - ( 3 * 距離 " + kyori + " / 100 )");
                utiwake = sb.ToString();
            }
#endif

            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.Ido_______________,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }


    }
}
