﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___125_Sokutei;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L125____Sokutei;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号


#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    /// <summary>
    /// 「角頭」の紐付き。
    /// 
    /// 先手から見て。
    /// （１）８七の地点に、「味方の駒」がある。               （　　０．１点）
    /// （２）項１を満たし、８七の地点の駒に、味方の駒が１つ以上利いている。 （　　１．０点）
    /// （３）項１～２のどれでもない。                         （　　０．０点）
    /// </summary>
    public class KyHandan_KakuTouNoHimoduki : KyHandanAbstract
    {


        public KyHandan_KakuTouNoHimoduki():base(TenonagareName.KakuTouNoHimoduki)
        {
        }


        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {

            double jisinTen = 0.0d;//互角
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;
            int p1_level = this.GetLevel(Masu_Honshogi.ban87_８七, args, src_Sky);// 1P
            int p2_level = this.GetLevel(Masu_Honshogi.ban23_２三, args, src_Sky);// 2P




            switch (p1_level - p2_level)
            {
                case 2: jisinTen = 1.0d; break;
                case 1: jisinTen = 0.1d; break;
                case 0: jisinTen = 0.0d; break;
                case -1: jisinTen = -0.1d; break;
                case -2: jisinTen = -1.0d; break;
                default: jisinTen = 0.0d; break;
            }
            


            string utiwake = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();

                switch(p1_level)
                {
                    case 2: sb.Append("(1P角頭 駒有、紐有 +1.0)"); break;
                    case 1: sb.Append("(1P角頭 駒有 +0.1)"); break;
                    default: break;
                }

                switch (p2_level)
                {
                    case 2: sb.Append("(2P角頭 駒有、紐有 -1.0)"); break;
                    case 1: sb.Append("(2P角頭 駒有 -0.1)"); break;
                    default: break;
                }

                utiwake = sb.ToString();
            }
#endif

            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.KakuTouNoHimoduki_,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }

        private int GetLevel(SyElement masuKtou, KyHandanArgs args, SkyConst src_Sky)
        {
            int result_level = 0;

            //
            // （１）角頭に味方の駒があるか？
            //
            Finger masuKtou_KomaFig;
            RO_Star komaKtou = null;
            {
                masuKtou_KomaFig = Util_Sky_FingersQuery.InMasuNow(src_Sky, masuKtou).ToFirst();

                if (Fingers.Error_1 == masuKtou_KomaFig)
                {
                    // 角頭に駒がない。
                    goto gt_Next1;
                }

                komaKtou = Util_Koma.FromFinger(src_Sky, masuKtou_KomaFig);
                if (args.PlayerInfo.Playerside != komaKtou.Pside)
                {
                    // 味方の駒ではない。
                    goto gt_Next1;
                }
                result_level++;
            }
        gt_Next1:

            //
            // （２）角頭に味方の駒があり、その角頭の駒に１つ以上　味方のひもが利いるか。
            //
            //
            int kikisu;
            {
                KomanoKiki komaNoKiki = KomanoKikiImpl.MasuBETUKikisu(
                    args.Node,
                    src_Sky, args.Node.Value.ToKyokumenConst.KaisiPside);

                kikisu = komaNoKiki.Kikisu_AtMasu_1P[Util_Masu10.AsMasuNumber(masuKtou)];//FIXME:

                if (result_level < 1 || kikisu < 1)
                {
                    // 角頭に味方の駒がないか、 1つも利いていない。
                    goto gt_Next2;
                }

                result_level++;
            }
        gt_Next2:

            return result_level;
        }

    }
}
