﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L060____UtilLua;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;


#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    public class KyHandan_Kimagure : KyHandanAbstract
    {

        public KyHandan_Kimagure():base(TenonagareName.Kimagure)
        {
        }

        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen;

//#if DEBUG
            // Luaを使って、スコアを出します。Luaの通信テストをしたいだけ☆
            Util_Lua_KifuWarabe.Perform("score_kimagure");
            jisinTen = Util_Lua_KifuWarabe.Score;//-1.0～1.0。Luaでは小数点の有効桁数を丸めない。
//#endif


            string utiwake = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("きまぐれ ");
                sb.Append(Util_Lua_KifuWarabe.Score);
                utiwake = sb.ToString();
                jisinTen = Util_Lua_KifuWarabe.Score;
            }
#else
            //jisinTen *= 0.01;//0.00～1.00。
            //score = LarabeRandom.Random.NextDouble() * 100.0d;

#endif

            //
            // TODO: 
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(//自信クラス別スコア倍率
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.Kimagure__________,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }

    }


}
