﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号


#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    public class KyHandan_KomaDoku : KyHandanAbstract
    {

        public KyHandan_KomaDoku():base(TenonagareName.KomaDoku)
        {
        }

        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="args"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen = 0.0d;//互角
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;


            double score_p1 = 0.0d;
            double score_p2 = 0.0d;



            src_Sky.Foreach_Starlights((Finger finger, Starlight light, ref bool toBreak) =>
            {
                RO_Starlight ms = (RO_Starlight)light;

                RO_Star koma = Util_Koma.AsKoma(ms.Now);

                // 駒の種類による点数　／　王の点数。　※王の点数が 1.0 になる。
                //
                // 最初、100～2000、16600の範囲で設定した。その後は自動調整されるかも。
                // ÷100 ぐらいしておくか。
                //
                double komaScore_temp = args.Unou.FeatureVector.Komawari[(int)koma.Komasyurui] / args.Unou.FeatureVector.Komawari[(int)Komasyurui14.H06_Oh_____];


                if (koma.Pside == Playerside.P1)
                {
                    score_p1 += komaScore_temp;
                }
                else
                {
                    score_p2 += komaScore_temp;
                }
            });

            jisinTen = score_p1 - score_p2;


            string utiwake = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("駒得");
                utiwake = sb.ToString();
            }
#endif

            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.KomaDoku__________,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }

    }


}
