﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P256_SeizaFinger.L250____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using System.Text;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    /// <summary>
    /// 「目の前の歩を取れ」。
    /// 
    /// 
    /// （１）味方の駒の前に歩がある。  （１箇所につき  －２０点。最大－１００点）
    /// </summary>
    public class KyHandan_MenomaenoFuWoTore : KyHandanAbstract
    {

        public KyHandan_MenomaenoFuWoTore() : base(TenonagareName.MenomaenoFuWoTore)
        {
        }


        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen = 0.0d;//互角
            StringBuilder sbUtiwake = new StringBuilder();
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;

            // 目の前の歩（餌）
            int p1_esa = 0;
            int p2_esa = 0;

            foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
            {
                // 駒
                RO_Star koma = Util_Koma.FromFinger(src_Sky, figKoma);

                switch(koma.Pside)
                {
                    case Playerside.P1:
                        {
                            SyElement p2Masu = Util_Masu10.Offset(Okiba.ShogiBan, koma.Masu, 0, -1);
                            Finger p2KomaFig = Util_Sky_FingersQuery.InMasuNow(src_Sky, p2Masu).ToFirst();
                            if (Fingers.Error_1 == p2KomaFig)
                            {
                                goto gt_Next1;
                            }
                            RO_Star p2Koma = Util_Koma.FromFinger(src_Sky, p2KomaFig);// 相手駒
                            if (p2Koma.Komasyurui != Komasyurui14.H01_Fu_____)
                            {
                                // 歩じゃなければ無視。「と金」も無視。
                                goto gt_Next1;
                            }
                            p1_esa++;
                        }
                        break;
                    case Playerside.P2:
                        {
                            SyElement p1Masu = Util_Masu10.Offset(Okiba.ShogiBan, koma.Masu, 0, +1);
                            Finger p1KomaFig = Util_Sky_FingersQuery.InMasuNow(src_Sky, p1Masu).ToFirst();
                            if (Fingers.Error_1 == p1KomaFig)
                            {
                                goto gt_Next1;
                            }
                            RO_Star p1Koma = Util_Koma.FromFinger(src_Sky, p1KomaFig);// 相手駒
                            if (p1Koma.Komasyurui != Komasyurui14.H01_Fu_____)
                            {
                                // 歩じゃなければ無視。「と金」も無視。
                                goto gt_Next1;
                            }
                            p2_esa++;
                        }
                        break;
                    default:
                        break;
                }

            gt_Next1:
                ;
            }

            // 歩同士では、目の前に歩があるかどうかは、1P、2Pのどちら側から見ても 同数になります。
            // 手番の方は、2倍にします。
            switch(args.PlayerInfo.Playerside)
            {
                case Playerside.P1: p1_esa *= 2; break;
                case Playerside.P2: p2_esa *= 2; break;
                default: break;
            }

            // 目の前に歩が３個あれば　1.0点とします。
            // 目の前に歩を置かれている局面を、残しているほど不利と判定するために、正負の符号を反転させます。
            jisinTen = -1 * (double)(p2_esa - p1_esa) / 3.0d;

            if (1.0d < jisinTen)
            {
                jisinTen = 1.0d;
            }
            else if(jisinTen<-1.0d)
            {
                jisinTen = -1.0d;
            }




            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.MenomaenoFuWoTore_,
                        jisinClass
                    )
                ),
                 sbUtiwake.ToString(),
                 jisinClass);
        }


    }
}
