﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P212_ConvPside__.L500____Converter;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P256_SeizaFinger.L250____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P505_Atama_Unou_.L___250_Unou;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using System;
using System.Diagnostics;
using System.Windows.Forms;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号


#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    /// <summary>
    /// 評価計算
    /// 
    /// 二駒関係ＫＫ。
    /// 二駒関係ＫＰ。
    /// 二駒関係ＰＰ。
    /// </summary>
    public class KyHandan_NikomaKankeiKkKpPp : KyHandanAbstract
    {

        public KyHandan_NikomaKankeiKkKpPp()
            : base(TenonagareName.NikomaKankeiKkp)
        {
        }


        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// 
        /// FIXME: ２駒関係は、先手から見た評価として作ってください。先手有利で正、互角で0、後手有利で負としてください。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen_Komawari = 0.0;//互角
            double jisinTen_Kk = 0.0;
            double jisinTen_Kp = 0.0;
            double jisinTen_Pp = 0.0;
            // 「駒割」の評価値を、「２駒関係」よりは上げたいので、数字が大きく成り過ぎないように倍率を掛けます。
            // 元の値は -999～999 を いくつか 掛け合わせたものになる。
            double bairituKk = 0.0001;//0.001
            double bairituKp = 0.0001;//0.00001
            double bairituPp = 0.000001;// PP の大小幅が大きすぎる。要素リストや、計算式が間違っているのかも。
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;

            // FIXME: 計算を飛ばしています。
            //goto gt_Next999;

            //
            // （１）自分の駒の数（評価値を加点）
            //

            //
            // （２）相手の駒の数（評価値を減点）
            //


            //
            // （３）ＫＫの評価。自玉→相手玉。（評価値を加算）
            //
            RO_Star koma_Jigyoku_orNull;//自玉
            RO_Star koma_Aitegyoku_orNull;//相手玉
            Util_Sky_FingersQueryFx.Split_Jigyoku_Aitegyoku(
                out koma_Jigyoku_orNull,
                out koma_Aitegyoku_orNull,
                src_Sky,
                args.PlayerInfo.Playerside,
                Conv_Playerside.Reverse(args.PlayerInfo.Playerside)
            );
            int k_ji_koumoku;
            int k_aite_koumoku;
            {
                if (koma_Jigyoku_orNull==null || Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(koma_Jigyoku_orNull.Masu))
                {
                    // 自玉が将棋盤上に無い場合
                    goto gt_Next999;
                }

                if (koma_Aitegyoku_orNull==null || Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(koma_Aitegyoku_orNull.Masu))
                {
                    // 相手玉が将棋盤上に無い場合
                    goto gt_Next999;
                }

                k_ji_koumoku = Util_Masu10.AsMasuNumber(koma_Jigyoku_orNull.Masu);
                k_aite_koumoku = Util_Masu10.AsMasuNumber(koma_Aitegyoku_orNull.Masu);

                jisinTen_Kk += args.Unou.FeatureVector.NikomaKankei_KK[k_ji_koumoku, k_aite_koumoku];
            }

            //
            // （４）ＫＰの評価。自玉→Ｐ。将棋盤。評価値を加算。
            //
            // とりあえず、３８駒の位置だけ評価します。
            //
            {
                foreach (Finger p2_figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
                {
                    RO_Star p2_koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(p2_figKoma).Now);

                    if (Komasyurui14.H06_Oh_____ == p2_koma.Komasyurui)
                    {
                        // 王様は無視します。
                        goto gt_Next40;
                    }

                    if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(p2_koma.Masu))
                    {
                        goto gt_Next40;
                    }

                    // Ｐの１２２４種類の調査項目☆
                    //                         （内訳
                    //                                 ※まず、先手の駒
                    //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
                    //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※自分の持ち駒
                    //                                 
                    //                                 ※次に、後手の駒
                    //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
                    //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※相手の持ち駒
                    //                         ）

                    // 駒Ｐのマス番号
                    int p2_masuHandle = Util_Masu10.AsMasuNumber(p2_koma.Masu);

                    int p2_koumoku = this.GetKoumokuP_Shogiban(p2_koma, args.PlayerInfo);

                    Debug.Assert(0 <= k_ji_koumoku && k_ji_koumoku <= 80, "k1_index=[" + k_ji_koumoku + "]");
                    try
                    {
                        jisinTen_Kp += args.Unou.FeatureVector.NikomaKankei_KP[k_ji_koumoku, p2_koumoku];
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("k1_index=[" + k_ji_koumoku + "]\n" +
                            "p2_koumoku=[" + p2_koumoku + "] / p2_masuHandle=[" + p2_masuHandle + "]\n" +
                            "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                    }

                gt_Next40:
                    ;
                }
            }

            //
            // （５）ＫＰの評価。自玉側。持駒。評価値を加算。
            //
            {
                foreach (Komasyurui14 syurui in Array_Komasyurui.MotiKoma7Syurui)
                {
                    int p2_koumoku;

                    //
                    // 自項目は評価値を加算
                    //
                    p2_koumoku = this.GetKoumokuP_Moti(src_Sky, args.PlayerInfo.Playerside, syurui);

                    try
                    {
                        jisinTen_Kp += args.Unou.FeatureVector.NikomaKankei_PP[k_ji_koumoku, p2_koumoku];
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("k1_index=[" + k_ji_koumoku + "]\n" +
                            "p2_koumoku=[" + p2_koumoku + "]\n" +
                            "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                    }

                    //
                    // 相手項目は評価値を減算
                    //
                    p2_koumoku = this.GetKoumokuP_Moti(src_Sky, Conv_Playerside.Reverse(args.PlayerInfo.Playerside), syurui);

                    try
                    {
                        jisinTen_Kp -= args.Unou.FeatureVector.NikomaKankei_PP[k_ji_koumoku, p2_koumoku];
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("k1_index=[" + k_ji_koumoku + "]\n" +
                            "p2_koumoku=[" + p2_koumoku + "]\n" +
                            "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                    }
                }
            }


            //
            // （６）ＫＰの評価。敵玉側。将棋盤。（評価値を減算）
            //
            {
                foreach (Finger p2_figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
                {
                    RO_Star p2_koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(p2_figKoma).Now);

                    if (Komasyurui14.H06_Oh_____ == p2_koma.Komasyurui)
                    {
                        // 王様は無視します。
                        goto gt_Next40;
                    }

                    if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(p2_koma.Masu))
                    {
                        goto gt_Next40;
                    }

                    // Ｐの１２２４種類の調査項目☆
                    //                         （内訳
                    //                                 ※まず、先手の駒
                    //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
                    //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※自分の持ち駒
                    //                                 
                    //                                 ※次に、後手の駒
                    //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
                    //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※相手の持ち駒
                    //                         ）

                    // 駒Ｐのマス番号
                    int p2_masuHandle = Util_Masu10.AsMasuNumber(p2_koma.Masu);

                    int p2_koumoku = this.GetKoumokuP_Shogiban(p2_koma, args.PlayerInfo);

                    Debug.Assert(0 <= k_ji_koumoku && k_ji_koumoku <= 80, "k1_index=[" + k_ji_koumoku + "]");
                    try
                    {
                        jisinTen_Kp -= args.Unou.FeatureVector.NikomaKankei_KP[k_aite_koumoku, p2_koumoku];
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("k_aite_koumoku=[" + k_aite_koumoku + "]\n" +
                            "p2_koumoku=[" + p2_koumoku + "] / p2_masuHandle=[" + p2_masuHandle + "]\n" +
                            "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                    }

                gt_Next40:
                    ;
                }
            }

            //
            // （７）ＫＰの評価。相手側。持ち駒。（評価値を減算）
            //
            {
                foreach (Komasyurui14 syurui in Array_Komasyurui.MotiKoma7Syurui)
                {
                    int p2_koumoku;

                    //
                    // 相手項目は評価値を減算
                    //
                    p2_koumoku = this.GetKoumokuP_Moti(src_Sky, args.PlayerInfo.Playerside, syurui);

                    try
                    {
                        jisinTen_Kp -= args.Unou.FeatureVector.NikomaKankei_PP[k_aite_koumoku, p2_koumoku];
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("k_aite_koumoku=[" + k_aite_koumoku + "]\n" +
                            "p2_koumoku=[" + p2_koumoku + "]\n" +
                            "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                    }

                    //
                    // 自項目は評価値を加算
                    //
                    p2_koumoku = this.GetKoumokuP_Moti(src_Sky, Conv_Playerside.Reverse(args.PlayerInfo.Playerside), syurui);

                    try
                    {
                        jisinTen_Kp += args.Unou.FeatureVector.NikomaKankei_PP[k_aite_koumoku, p2_koumoku];
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("k_aite_koumoku=[" + k_aite_koumoku + "]\n" +
                            "p2_koumoku=[" + p2_koumoku + "]\n" +
                            "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                    }
                }
            }

            //
            // （８）ＰＰの評価（将棋盤×将棋盤）
            // （９）ＰＰの評価（将棋盤×持ち駒）
            //
            // とりあえず、３８駒の位置だけ評価します。
            //
            {
                foreach (Finger p1_figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
                {
                    RO_Star p1_koma;
                    int p1_masuHandle;
                    {
                        p1_koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(p1_figKoma).Now);

                        if (Komasyurui14.H06_Oh_____ == p1_koma.Komasyurui)
                        {
                            // 王様は無視します。
                            goto gt_Next82;
                        }

                        if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(p1_koma.Masu))
                        {
                            goto gt_Next82;
                        }

                        // 駒Ｐのマス番号
                        p1_masuHandle = Util_Masu10.AsMasuNumber(p1_koma.Masu);
                    }


                    int p1_koumoku = this.GetKoumokuP_Shogiban(p1_koma, args.PlayerInfo);

                    {
                        //
                        // P2＝将棋盤
                        //
                        foreach (Finger p2_figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
                        {
                            RO_Star p2_koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(p2_figKoma).Now);

                            if (Komasyurui14.H06_Oh_____ == p2_koma.Komasyurui)
                            {
                                // 王様は無視します。
                                goto gt_Next81;
                            }

                            if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(p2_koma.Masu))
                            {
                                goto gt_Next81;
                            }

                            // Ｐの１２２４種類の調査項目☆
                            //                         （内訳
                            //                                 ※まず、先手の駒
                            //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
                            //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※自分の持ち駒
                            //                                 
                            //                                 ※次に、後手の駒
                            //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
                            //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※相手の持ち駒
                            //                         ）

                            // 駒Ｐのマス番号
                            int p2_masuHandle = Util_Masu10.AsMasuNumber(p2_koma.Masu);

                            int p2_koumoku = this.GetKoumokuP_Shogiban(p2_koma, args.PlayerInfo);

                            try
                            {
                                jisinTen_Pp += args.Unou.FeatureVector.NikomaKankei_PP[p1_koumoku, p2_koumoku];
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("k1_index=[" + k_ji_koumoku + "]\n" +
                                    "p2_koumoku=[" + p2_koumoku + "] / p2_masuHandle=[" + p2_masuHandle + "]\n" +
                                    "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                            }

                        gt_Next81:
                            ;
                        }

                        //
                        // P2=自分の持ち駒（評価値を加算）
                        //
                        foreach (Komasyurui14 syurui in Array_Komasyurui.MotiKoma7Syurui)
                        {
                            int p2_koumoku = this.GetKoumokuP_Moti(src_Sky, args.PlayerInfo.Playerside, syurui);

                            try
                            {
                                jisinTen_Pp += args.Unou.FeatureVector.NikomaKankei_PP[k_ji_koumoku, p2_koumoku];
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("k1_index=[" + k_ji_koumoku + "]\n" +
                                    "p2_koumoku=[" + p2_koumoku + "]\n" +
                                    "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                            }
                        }

                        //
                        // P2=相手の持ち駒（評価値を減算）
                        //
                        foreach (Komasyurui14 syurui in Array_Komasyurui.MotiKoma7Syurui)
                        {
                            int p2_koumoku = this.GetKoumokuP_Moti(src_Sky, Conv_Playerside.Reverse(args.PlayerInfo.Playerside), syurui);

                            try
                            {
                                jisinTen_Pp -= args.Unou.FeatureVector.NikomaKankei_PP[k_ji_koumoku, p2_koumoku];
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("k1_index=[" + k_ji_koumoku + "]\n" +
                                    "p2_koumoku=[" + p2_koumoku + "]\n" +
                                    "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                            }
                        }

                    }

                gt_Next82:
                    ;
                }
            }

            //
            // （１０）ＰＰの評価（持ち駒×持ち駒）
            //
            if (true)
            {
                foreach (Komasyurui14 p1_syurui in Array_Komasyurui.MotiKoma7Syurui)
                {
                    int p1_koumoku;

                    //
                    // P1=自分の持ち駒
                    //
                    p1_koumoku = this.GetKoumokuP_Moti(src_Sky, args.PlayerInfo.Playerside, p1_syurui);
                    {
                        //
                        // P2=自分の持ち駒（評価値を加算）
                        //
                        foreach (Komasyurui14 p2_syurui in Array_Komasyurui.MotiKoma7Syurui)
                        {
                            int p2_koumoku = this.GetKoumokuP_Moti(src_Sky, args.PlayerInfo.Playerside, p2_syurui);

                            try
                            {
                                jisinTen_Pp += args.Unou.FeatureVector.NikomaKankei_PP[p1_koumoku, p2_koumoku];
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("p1_koumoku=[" + p1_koumoku + "]\n" +
                                    "p2_koumoku=[" + p2_koumoku + "]\n" +
                                    "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                            }
                        }

                        //
                        // P2=相手の持ち駒（評価値を減算）
                        //
                        foreach (Komasyurui14 p2_syurui in Array_Komasyurui.MotiKoma7Syurui)
                        {
                            int p2_koumoku = this.GetKoumokuP_Moti(src_Sky, Conv_Playerside.Reverse(args.PlayerInfo.Playerside), p2_syurui);

                            try
                            {
                                jisinTen_Pp -= args.Unou.FeatureVector.NikomaKankei_PP[p1_koumoku, p2_koumoku];
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("p1_koumoku=[" + p1_koumoku + "]\n" +
                                    "p2_koumoku=[" + p2_koumoku + "]\n" +
                                    "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                            }
                        }
                    }


                    //
                    // P1=相手の持ち駒
                    //
                    p1_koumoku = this.GetKoumokuP_Moti(src_Sky, Conv_Playerside.Reverse(args.PlayerInfo.Playerside), p1_syurui);
                    {
                        //
                        // P2=自分の持ち駒（評価値を加算）
                        //
                        foreach (Komasyurui14 p2_syurui in Array_Komasyurui.MotiKoma7Syurui)
                        {
                            int p2_koumoku = this.GetKoumokuP_Moti(src_Sky, args.PlayerInfo.Playerside, p2_syurui);

                            try
                            {
                                jisinTen_Pp += args.Unou.FeatureVector.NikomaKankei_PP[p1_koumoku, p2_koumoku];
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("p1_koumoku=[" + p1_koumoku + "]\n" +
                                    "p2_koumoku=[" + p2_koumoku + "]\n" +
                                    "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                            }
                        }

                        //
                        // P2=相手の持ち駒（評価値を減算）
                        //
                        foreach (Komasyurui14 p2_syurui in Array_Komasyurui.MotiKoma7Syurui)
                        {
                            int p2_koumoku = this.GetKoumokuP_Moti(src_Sky, Conv_Playerside.Reverse(args.PlayerInfo.Playerside), p2_syurui);

                            try
                            {
                                jisinTen_Pp -= args.Unou.FeatureVector.NikomaKankei_PP[p1_koumoku, p2_koumoku];
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("p1_koumoku=[" + p1_koumoku + "]\n" +
                                    "p2_koumoku=[" + p2_koumoku + "]\n" +
                                    "args.Unou.NikomaKankei_KP=[" + args.Unou.FeatureVector.NikomaKankei_KP.Length + "]");
                            }
                        }
                    }
                }
            }


        gt_Next999:

            double jisinTen = jisinTen_Komawari + jisinTen_Kk * bairituKk + jisinTen_Kp * bairituKp + jisinTen_Pp * bairituPp;
            string utiwake = "";
#if DEBUG
            // 評価明細
            {
                StringBuilder sb = new StringBuilder();

                sb.Append(" 二駒関係 総合");
                sb.Append(jisinTen);
                sb.Append("点");

                sb.Append("    ／    内訳");

                sb.Append("    駒割");
                sb.Append(jisinTen_Komawari);
                sb.Append("点");

                sb.Append("    ＫＫ");
                sb.Append(jisinTen_Kk * bairituKk);
                sb.Append("点（");
                sb.Append(jisinTen_Kk);
                sb.Append("×");
                sb.Append(bairituKk);
                sb.Append("）");

                sb.Append("    ＫＰ");
                sb.Append(jisinTen_Kp * bairituKp);
                sb.Append("点（");
                sb.Append(jisinTen_Kp);
                sb.Append("×");
                sb.Append(bairituKp);
                sb.Append("）");

                sb.Append("    ＰＰ");
                sb.Append(jisinTen_Pp * bairituPp);
                sb.Append("点（");
                sb.Append(jisinTen_Pp);
                sb.Append("×");
                sb.Append(bairituPp);
                sb.Append("）");

                utiwake = sb.ToString();
            }
#endif
            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyakuman_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.NikomaKankeiKkKpPp,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }


        /// <summary>
        /// Pの将棋盤上の駒の位置の、配列の添え字番号。
        /// </summary>
        /// <param name="p_koma"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        private int GetKoumokuP_Shogiban(RO_Star p_koma, PlayerInfo playerInfo)
        {
            int koumokuP;

            // 駒Ｐのマス番号
            int p_masuHandle = Util_Masu10.AsMasuNumber(p_koma.Masu);

            if (p_koma.Pside == playerInfo.Playerside)
            {
                // 自分の駒
                switch (p_koma.ToNarazuCase())//成らずケース
                {
                    case Komasyurui14.H01_Fu_____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Fu__ + p_masuHandle; break;
                    case Komasyurui14.H02_Kyo____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kyo_ + p_masuHandle; break;
                    case Komasyurui14.H03_Kei____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kei_ + p_masuHandle; break;
                    case Komasyurui14.H04_Gin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Gin_ + p_masuHandle; break;
                    case Komasyurui14.H05_Kin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kin_ + p_masuHandle; break;
                    case Komasyurui14.H07_Hisya__: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Hi__ + p_masuHandle; break;
                    case Komasyurui14.H08_Kaku___: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__Ban_Kaku + p_masuHandle; break;
                    default: koumokuP = -1;
                        OwataMinister.ERROR.DonimoNaranAkirameta("二駒関係のP自分の駒");
                        break;//TODO:エラー処理したい。
                }
            }
            else
            {
                // 相手の駒
                switch (p_koma.ToNarazuCase())//成らずケース
                {
                    case Komasyurui14.H01_Fu_____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteBan_Fu__ + p_masuHandle; break;
                    case Komasyurui14.H02_Kyo____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kyo_ + p_masuHandle; break;
                    case Komasyurui14.H03_Kei____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kei_ + p_masuHandle; break;
                    case Komasyurui14.H04_Gin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteBan_Gin_ + p_masuHandle; break;
                    case Komasyurui14.H05_Kin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kin_ + p_masuHandle; break;
                    case Komasyurui14.H07_Hisya__: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteBan_Hi__ + p_masuHandle; break;
                    case Komasyurui14.H08_Kaku___: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteBan_Kaku + p_masuHandle; break;
                    default: koumokuP = -1;
                        OwataMinister.ERROR.DonimoNaranAkirameta("二駒関係のP相手の駒");
                        break;//TODO:エラー処理したい。
                }
            }

            Debug.Assert(0 <= koumokuP && koumokuP < FeatureVectorImpl.CHOSA_KOMOKU_P, "koumokuP=[" + koumokuP + "]");
            return koumokuP;
        }

        /// <summary>
        /// Pの持ち駒項目の、配列の添え字番号。
        /// </summary>
        /// <param name="src_Sky"></param>
        /// <param name="pside"></param>
        /// <param name="syurui"></param>
        /// <returns></returns>
        private int GetKoumokuP_Moti(SkyConst src_Sky, Playerside pside, Komasyurui14 syurui)
        {
            Fingers fingers = Util_Sky_FingersQuery.InOkibaPsideKomasyuruiNow(src_Sky, Conv_Playerside.ToKomadai(pside), pside, syurui);

            int koumokuP;
            switch (pside)
            {
                case Playerside.P1:
                    switch (syurui)
                    {
                        case Komasyurui14.H01_Fu_____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__MotiFu__ + fingers.Count; break;
                        case Komasyurui14.H02_Kyo____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKyo_ + fingers.Count; break;
                        case Komasyurui14.H03_Kei____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKei_ + fingers.Count; break;
                        case Komasyurui14.H04_Gin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__MotiGin_ + fingers.Count; break;
                        case Komasyurui14.H05_Kin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKin_ + fingers.Count; break;
                        case Komasyurui14.H07_Hisya__: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__MotiHi__ + fingers.Count; break;
                        case Komasyurui14.H08_Kaku___: koumokuP = (int)NikomaKankeiP_ChosaKomoku.Ji__MotiKaku + fingers.Count; break;
                        default: koumokuP = -1;
                            OwataMinister.ERROR.DonimoNaranAkirameta("二駒関係のP自分の持ち駒");
                            break;//TODO:エラー処理したい。
                    }
                    break;
                case Playerside.P2:
                    switch (syurui)
                    {
                        case Komasyurui14.H01_Fu_____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteMotiFu__ + fingers.Count; break;
                        case Komasyurui14.H02_Kyo____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteMotiKyo_ + fingers.Count; break;
                        case Komasyurui14.H03_Kei____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteMotiKei_ + fingers.Count; break;
                        case Komasyurui14.H04_Gin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteMotiGin_ + fingers.Count; break;
                        case Komasyurui14.H05_Kin____: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteMotiKin_ + fingers.Count; break;
                        case Komasyurui14.H07_Hisya__: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteMotiHi__ + fingers.Count; break;
                        case Komasyurui14.H08_Kaku___: koumokuP = (int)NikomaKankeiP_ChosaKomoku.AiteMotiKaku + fingers.Count; break;
                        default: koumokuP = -1;
                            OwataMinister.ERROR.DonimoNaranAkirameta("二駒関係のP相手の持ち駒");
                            break;//TODO:エラー処理したい。
                    }
                    break;
                default:
                    koumokuP = -1;
                    OwataMinister.ERROR.DonimoNaranAkirameta("二駒関係のP持ち駒_サイド不明");
                    break;
            }
            return koumokuP;
        }
    }
}
