﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P256_SeizaFinger.L250____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;
using System.Collections.Generic;
using System.Linq;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号


#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{

    /// <summary>
    /// 飛車道が通っているとか、香車道が通っているとか
    /// </summary>
    public class KyHandan_Toosi : KyHandanAbstract
    {

        public double Keisu_Fu;
        public double Keisu_Kyo;
        public double Keisu_Kei;
        public double Keisu_Gin;
        public double Keisu_Kin;
        public double Keisu_Oh;
        public double Keisu_Hisya;
        public double Keisu_Kaku;
        public double Keisu_Ryu;
        public double Keisu_Uma;
        public double Keisu_Tokin;
        public double Keisu_NariKyo;
        public double Keisu_NariKei;
        public double Keisu_NariGin;


        public KyHandan_Toosi():base(TenonagareName.Toosi)
        {
            // 1マスの得点。
            this.Keisu_Fu = 0.0d;
            this.Keisu_Kyo = 0.0d;//香車は別に、たくさんの升に利かそうとがんばらなくていい。
            this.Keisu_Kei = 0.0d;
            this.Keisu_Gin = 0.0d;
            this.Keisu_Kin = 0.0d;
            this.Keisu_Oh = 0.0d;
            this.Keisu_Hisya = 0.05d;//飛車・龍は２枚ある。
            this.Keisu_Kaku = 0.04d;//角・馬は２枚ある。
            this.Keisu_Ryu = 0.05d;
            this.Keisu_Uma = 0.04d;
            this.Keisu_Tokin = 0.0d;
            this.Keisu_NariKyo = 0.0d;
            this.Keisu_NariKei = 0.0d;
            this.Keisu_NariGin = 0.0d;
        }

        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen_p1 = 0.0d;
            double jisinTen_p2 = 0.0d;
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;



            //
            // 「紐が付いていない駒の少なさ」による加点。
            //
            // 自分の駒について、味方の駒の利きが被っていれば＋１（貫通）
            //                     敵の駒の利きが被っていれば－１（貫通）
            //
            //   敵の駒について、味方の駒の利きが被っていれば＋１（貫通）
            //                     敵の駒の利きが被っていれば－１（貫通）
            //




            //
            // 駒のない升は無視し、
            // 駒のあるマスに、その駒の味方のコマが効いていれば　＋１
            // 駒のあるマスに、その駒の相手のコマが効いていれば　－１
            //
            foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
            {
                RO_Star koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);

                if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(koma.Masu))
                {
                    goto gt_Next1;
                }
                // 将棋盤上のみ。

                // 駒の利き
                SySet<SyElement> kikiZukei = Util_Sky_SyugoQuery.KomaKidou_Potential(figKoma, src_Sky);

                IEnumerable<SyElement> kikiMasuList = kikiZukei.Elements;
                // 通し
                double toosi = kikiMasuList.Count();

                // 係数
                switch (koma.Komasyurui)
                {
                    case Komasyurui14.H01_Fu_____: toosi *= this.Keisu_Fu; break;
                    case Komasyurui14.H02_Kyo____: toosi *= this.Keisu_Kyo; break;
                    case Komasyurui14.H03_Kei____: toosi *= this.Keisu_Kei; break;
                    case Komasyurui14.H04_Gin____: toosi *= this.Keisu_Gin; break;
                    case Komasyurui14.H05_Kin____: toosi *= this.Keisu_Kin; break;
                    case Komasyurui14.H06_Oh_____: toosi *= this.Keisu_Oh; break;
                    case Komasyurui14.H07_Hisya__: toosi *= this.Keisu_Hisya; break;
                    case Komasyurui14.H08_Kaku___: toosi *= this.Keisu_Kaku; break;
                    case Komasyurui14.H09_Ryu____: toosi *= this.Keisu_Ryu; break;
                    case Komasyurui14.H10_Uma____: toosi *= this.Keisu_Uma; break;
                    case Komasyurui14.H11_Tokin__: toosi *= this.Keisu_Tokin; break;
                    case Komasyurui14.H12_NariKyo: toosi *= this.Keisu_NariKyo; break;
                    case Komasyurui14.H13_NariKei: toosi *= this.Keisu_NariKei; break;
                    case Komasyurui14.H14_NariGin: toosi *= this.Keisu_NariGin; break;
                    default: break;
                }

                if (args.PlayerInfo.Playerside == koma.Pside)
                {
                    // 味方の駒
                    jisinTen_p1 += toosi;
                }
                else
                {
                    // 敵の駒
                    jisinTen_p2 += toosi;
                }

            gt_Next1:
                ;
            }


            double jisinTen = jisinTen_p1 - jisinTen_p2;
            string utiwake = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("P1=");
                sb.Append(jisinTen_p1);
                sb.Append("　P2=");
                sb.Append(jisinTen_p2);
                utiwake = sb.ToString();
            }
#endif

            //
            // TODO: 状況別スコア倍率
            //
            KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.Toosi_____________,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }


    }

}
