﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L250____UtilKyHandanOrder;


#if DEBUG
using System.Text;
#endif

namespace Grayscale.P507_Atama______.L500____KyHandan
{


    /// <summary>
    /// 「突き捨て」。
    /// </summary>
    public class KyHandan_Tukisute : KyHandanAbstract
    {

        public KyHandan_Tukisute():base(TenonagareName.Tukisute)
        {
        }


        /// <summary>
        /// 自信点（評価値）を返します。先手が有利なら最高 1.0、後手が有利なら最高 -1.0、互角は 0.0 です。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaMeisai_Koumoku out_meisaiKoumoku, KyHandanArgs args, KwErrorHandler errH)
        {
            double jisinTen = 0.0d;//互角
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;

            //
            // 指定された駒。
            //
            RO_Star koma1 = args.TenonagareGenjo.Koma1;

            if (Okiba.ShogiBan != Util_Masu10.Masu_ToOkiba(koma1.Masu))
            {
                // 指定された駒が将棋盤の上になければ、無視。
                goto gt_EndMethod;
            }

            //
            // 初期位置にいると、点数が低いものとします。
            //
            if (koma1.Masu == args.TenonagareGenjo.Masu)
            {
                jisinTen = 0.0d;
            }
            else
            {
                jisinTen = 1.0d;
            }

            ////
            //// 先手から見た盤に回転。
            ////
            //SyElement komaMasu = Util_Masu.BothSenteView(koma1.Masu, koma1.Pside);
            //int dan;
            //Util_MasuNum.MasuToDan(komaMasu, out dan);

            if (args.PlayerInfo.Playerside == Playerside.P2)
            {
                jisinTen *= -1;//符号反転
            }

        gt_EndMethod:
            string utiwake = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();
                // 初期位置にいると、点数が低いものとします。
                if (koma1.Masu == args.TenonagareGenjo.Masu)
                {
                    sb.Append("(初期位置 0.0d)");
                }
                else
                {
                    sb.Append("(初期位置から離れている 1.0d)");
                }
                utiwake = sb.ToString();
            }
#endif
            //
            // TODO: 状況別スコア倍率
            //
        KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
            out_meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                Util_KyHyoka.Keisan(
                    jisinTen,
                    KyHyokaSaido.Hyaku_bunnoichi,
                    Util_KyHandanOrder.Get_JisinClassBetu_Bairitu(
                        args.TenonagareGenjo.HandanOrderName,
                        KyHyokaKoumokuName.Tukisute__________,
                        jisinClass
                    )
                ),
                 utiwake,
                 jisinClass);
        }


    }
}
