﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P321_KyokumHyoka.L500____Util;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L500____KyHandan;
using Grayscale.P511_KifuWarabe_.L___020_Kokoro;
using Grayscale.P511_KifuWarabe_.L___040_KyHyoka;
using System.Collections.Generic;

namespace Grayscale.P511_KifuWarabe_.L040____KyHyoka
{

    /// <summary>
    /// 局面の評価エンジン。
    /// </summary>
    public class KyHyokaCalculatorImpl : KyHyokaCalculator
    {

        /// <summary>
        /// 局面のスコアラーのリスト。
        /// </summary>
        public Dictionary<TenonagareName, KyHandan> KyHyokas { get { return this.kyHyokas; } }
        private Dictionary<TenonagareName, KyHandan> kyHyokas;


        public KyHyokaCalculatorImpl()
        {


            // 評価一覧
            {
                Dictionary<TenonagareName, KyHandan> dic = new Dictionary<TenonagareName, KyHandan>();
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_Ido());// 移動
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_Toru());// 取る
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_Tukisute());// 突き捨て
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_KomaDoku());// 駒を持っていることによる加点。平手なら、両者同じ駒を持っているので、相殺されて 0 点。
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_Himoduki());// 駒の紐付き。
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_KakuTouNoHimoduki());// 角頭の紐付き。
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_MenomaenoFuWoTore());// 目の前の歩を取れ。
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_Kimagure());//気まぐれ
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_Toosi());// 飛車道が通っているなどによる加点。
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_GyokuNoMamori());// 玉の守りによる加点。
                KyHyokaCalculatorImpl.AddDic(dic, new KyHandan_NikomaKankeiKkKpPp());// 三駒関係ＫＫＰによる加点。
                this.kyHyokas = dic;
            }

        }


        private static void AddDic(Dictionary<TenonagareName, KyHandan> dic, KyHandan score)
        {
            dic.Add(score.Name, score);
        }


        /// <summary>
        /// レッツ☆判断！
        /// 
        /// （１）ノードは、局面であるとともに、点数を覚えておくこともできます。
        /// （２）考え方の条件を指定します。
        /// （３）このメソッドは、「指定の駒が、指定のマスより、どれぐらい離れているか」で点数付けします。
        /// （４）ノードに、点数を設定します。
        /// </summary>
        public KyHyokaMeisai_Koumoku LetHandan(
            Tenonagare tenonagare,
            KifuNode node,
            PlayerInfo playerInfo,
            UnouImpl unou,
            KwErrorHandler errH
            )
        {
            KyHyokaMeisai_Koumoku meisaiKoumoku;

            if (this.KyHyokas.ContainsKey(tenonagare.Name))
            {
                this.KyHyokas[tenonagare.Name].Keisan(out meisaiKoumoku, new KyHandanArgsImpl(tenonagare, node, unou, playerInfo), errH);
            }
            else
            {
                //
                // TODO: 状況別スコア倍率
                //
                double jisinTen = 0.0d;
                KyJisinClass jisinClass = Conv_JisinTen.ToJisinClass(jisinTen);
                meisaiKoumoku = new KyHyokaMeisai_KoumokuImpl(
                    Util_KyHyoka.Keisan(
                        jisinTen,
                        KyHyokaSaido.Saigoni_Total,
                        1.0d
                    ),
                     "ヌル",
                     jisinClass);
            }

            return meisaiKoumoku;
        }

    }


}
