﻿
using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P031_ConvText___.L500____Converter;
using Grayscale.P153_KifuSfen___.L___250_Report;
using Grayscale.P158_LogKyokuPng.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L250____Struct;
using Grayscale.P322_KifuTree___.L500____Util;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P511_KifuWarabe_.L___040_KyHyoka;

namespace Grayscale.P511_KifuWarabe_.L009_KyHyoka
{
    public class KyHyokaWriterImpl : KyHyokaWriter
    {
        private static int logFileCounter;


        /// <summary>
        /// 棋譜ツリーの、ノードに格納されている、局面評価明細を、出力していきます。
        /// </summary>
        public void Write_ForeachLeafs(
            string nodePath,
            KifuNode node,
            KifuTree kifu,
            PlayerInfo playerInfo,
            string relFolder,
            ReportEnvironment reportEnvironment,
            KwErrorHandler errH
            )
        {

            // 次ノードの有無
            if (0<node.Count_ChildNodes)
            {
                // 葉ノードではないなら

                // 先に奥の枝から。
                node.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> nextNode, ref bool toBreak) =>
                {

                    double score = ((KifuNode)nextNode).KyHyoka.Total();

                    // 再帰
                    this.Write_ForeachLeafs(
                        nodePath + " " + Conv_Sasite307.ToSfenFugo_ForFilename(nextNode.Key),
                        (KifuNode)nextNode,
                        kifu,
                        playerInfo,
                        relFolder + ((int)score).ToString() + "点_" + Conv_Sasite307.ToSfenFugo(nextNode.Key) + "/",
                        reportEnvironment,
                        errH
                        );

                });
            }

            // FIXME: KyokumenWrapperをデータから文字に変えるまで、一旦使えなくしたい。
            //
            // 盤１個分のログの準備
            //
            this.Log_Board(
                nodePath,
                node,
                kifu,
                relFolder,
                reportEnvironment,
                errH
            );

        }

        /// <summary>
        /// 盤１個分のログ。
        /// </summary>
        private void Log_Board(
            string nodePath,
            KifuNode node,
            KifuTree kifu,
            string relFolder,
            ReportEnvironment reportEnvironment,
            KwErrorHandler errH
            )
        {
            string fileName = "";

            try
            {

                // 出力先
                fileName    = Conv_Filepath.ToEscape( "_log_" + ((int)node.KyHyoka.Total()) + "点_" + KyHyokaWriterImpl.logFileCounter + "_" + nodePath + ".png");
                relFolder   = Conv_Filepath.ToEscape(relFolder);
                //
                // 画像ﾛｸﾞ
                //
                if (true)
                {

                    //SFEN文字列と、出力ファイル名を指定することで、局面の画像ログを出力します。
                    Util_KyokumenPng_Writer.Write1(
                        Conv_KifuNode.ToRO_Kyokumen1(node, errH),
                        relFolder,
                        fileName,
                        reportEnvironment
                        );
                    KyHyokaWriterImpl.logFileCounter++;
                }

                //
                // 評価明細
                //
                {
                    KyHyokaListWriterImpl.Write(fileName, node, relFolder, reportEnvironment);
                }
            }
            catch (System.Exception ex)
            {
                errH.DonimoNaranAkirameta(ex, "盤１個分のログを出力しようとしていたときです。\n fileName=[" + fileName + "]\n relFolder=[" + relFolder + "]"); throw ex;
            }
        }

    }
}
