﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P153_KifuSfen___.L___250_Report;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P222_Log_Kaisetu.L250____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P321_KyokumHyoka.L250____Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P511_KifuWarabe_.L___005_UsiLoop;
using Grayscale.P511_KifuWarabe_.L___020_Kokoro;
using Grayscale.P511_KifuWarabe_.L___040_KyHyoka;
using Grayscale.P511_KifuWarabe_.L___060_Minimax;
using Grayscale.P511_KifuWarabe_.L040____KyHyoka;
using System;

namespace Grayscale.P511_KifuWarabe_.L060____Minimax
{
    /// <summary>
    /// ミニマックス法エンジン
    /// </summary>
    public class MinimaxEngineImpl : MinimaxEngine
    {

        //private static int logFileCounter;

        private ShogiEngine owner;
        private KyHyokaCalculator hyokaEngineImpl;

        public MinimaxEngineImpl(ShogiEngine owner)
        {
            this.hyokaEngineImpl = new KyHyokaCalculatorImpl();

            this.owner = owner;

        }


        /// <summary>
        /// 棋譜ツリーの、ノードのネクストノードに、点数を付けていきます。
        /// </summary>
        public void Tensuduke_ForeachLeafs(
            string nodePath,
            KifuNode niniNode,//current,childの、どっちもある。バグ☆？ 棋譜ツリーに追加されているか？
            //KifuTree kifu_forAssert,
            Kokoro kokoro,
            UnouImpl unou,
            PlayerInfo playerInfo,
            ReportEnvironment reportEnvironment,
            KaisetuBoards logF_kiki,
            KwErrorHandler errH
            )
        {
//#if DEBUG
            ////
            //// 診断
            ////
            //kifu_forAssert.AssertPside(niniNode, "Tensuduke_ForeachLeafs(A) nodePath=" + nodePath,errH);// currentか、childかは任意。
            //niniNode.Foreach_ChildNodes((string key, Node<ShootingStarlightable, KyokumenWrapper> nextNode, ref bool toBreak) =>
            //{
            //    // 恐らく niniNode==child のときエラー。
            //    //
            //    // 後手番なら、１手目済みから、２手読むなど。
            //    //

            //    // 親ノードはヌルか？
            //    string text1;
            //    if (null == niniNode.ParentNode)
            //    {
            //        text1 = "親ノードはヌル";
            //    }
            //    else
            //    {
            //        text1 = Util_Translator_Sasite.ToSasite(niniNode.ParentNode, niniNode.Value, errH);
            //    }

            //    kifu_forAssert.AssertPside(nextNode, "Tensuduke_ForeachLeafs(B) nodePath=" + nodePath + "。\n"+
            //        "　key=" + key + "。任意ノードの符号＝"+ Util_Translator_Sasite.ToSasite( niniNode, niniNode.Value,errH) + "。任意ノードの個数=" + niniNode.Count_ChildNodes+"\n"+
            //        " niniNode.ParentNode=[" + text1+"]", errH);//FIXME: 任意のノードの子に、先後のずれた　nextNode　が登録されている？
            //});
//#endif


            // 次ノードの有無
            if (niniNode.Count_ChildNodes < 1)
            {
                try{
                    // 次ノードが無ければ、このノードが、葉です。
                    // 点数を付けます。

                    // 局面スコア
                    niniNode.KyHyoka.Clear();

                    // 妄想と、指定のノードを比較し、点数付けします。
                    foreach (Tenonagare nagare in kokoro.TenonagareItems)
                    {
                        niniNode.KyHyoka.Add(
                            nagare.Name.ToString(),
                            this.hyokaEngineImpl.LetHandan(nagare, niniNode, playerInfo, unou, errH)
                        );
                    }

//#if DEBUG
//                    //
//                    // 盤１個分のログの準備
//                    //
//                    Util_LogBuilder510.Build_LogBoard(
//                        nodePath,
//                        niniNode,
//                        kifu_forAssert,
//                        reportEnvironment,
//                        logF_kiki,
//                        errH
//                    );
//#endif
                }
                catch (Exception ex) { OwataMinister.WARABE_ENGINE.DonimoNaranAkirameta(ex, "葉に点数を付けたときです。"); throw ex; }

            }
            else
            {
#if DEBUG
                ////----------------------------------------
                //// 枝葉の「手番済み」番号をデバッグ出力
                ////----------------------------------------
                //System.Text.StringBuilder sb = new System.Text.StringBuilder();
                //sb.AppendLine("任意ノード　" + niniNode.Value.ToKyokumenConst.KaisiPside);
                //sb.AppendLine("┏━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┓子要素の一覧");
                //niniNode.Foreach_ChildNodes((string key1, Node<ShootingStarlightable, KyokumenWrapper> nextNode1, ref bool toBreak1) =>
                //{
                //    //
                //    // 診断
                //    //
                //    kifu_forAssert.AssertPside(nextNode1, "Tensuduke_ForeachLeafs",errH);// 任意のノードの子要素。
                //    sb.AppendLine("子　" + nextNode1.Value.ToKyokumenConst.KaisiPside);
                //    sb.AppendLine("┏━━━━━━━━━━━━━━━━━━━━┓孫要素の一覧");
                //    nextNode1.Foreach_ChildNodes((string key2, Node<ShootingStarlightable, KyokumenWrapper> nextNode2, ref bool toBreak2) =>
                //    {
                //        sb.AppendLine("孫　" + nextNode2.Value.ToKyokumenConst.KaisiPside);
                //        // 任意のノードの孫要素。
                //        //kifu.AssertPside(nextNode2);//FIXME: 任意のノードの孫に、先後のずれた　nextNode　が登録されている？
                //    });
                //    sb.AppendLine("┗━━━━━━━━━━━━━━━━━━━━┛");
                //});
                //sb.AppendLine("┗━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┛");
                //System.Windows.Forms.MessageBox.Show(System.Windows.Forms.Application.StartupPath + System.IO.Path.DirectorySeparatorChar + "../../Logs/_log_診断.txt");
                //System.IO.File.WriteAllText(System.Windows.Forms.Application.StartupPath + System.IO.Path.DirectorySeparatorChar + "../../Logs/_log_診断.txt", sb.ToString());
#endif

                try{
                    niniNode.Foreach_ChildNodes((string key1, Node<Starbeamable, KyokumenWrapper> nextNode1, ref bool toBreak1) =>
                    {
                        this.Tensuduke_ForeachLeafs(
                            nodePath + " " + Conv_Sasite307.ToSfenFugo(nextNode1.Key),
                            (KifuNode)nextNode1,//任意のノード。//棋譜ツリーに追加されているか？
                            //kifu_forAssert,
                            kokoro,
                            unou,
                            playerInfo,
                            reportEnvironment,
                            logF_kiki,
                            errH
                            );

                    });

                    // このノードが、自分の手番かどうか。
                    //kifu_forAssert.AssertPside(niniNode, "Tensuduke_ForeachLeafs",errH);
                    Playerside pside = niniNode.Value.ToKyokumenConst.KaisiPside;
                    bool jibun = playerInfo.Playerside == pside;
                    if (jibun)
                    {
                        // 自分のノードの場合、次ノードの中で一番点数の高いもの。
                        double maxScore = double.MinValue;
                        niniNode.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> nextNode, ref bool toBreak) =>
                        {
                            double score = ((KifuNode)nextNode).KyHyoka.Total();
                            if (maxScore < score)
                            {
                                maxScore = score;
                            }
                        });
                        niniNode.SetBranchKyHyoka(new KyHyokaImpl(maxScore));
                    }
                    else
                    {
                        // 相手のノードの場合、次ノードの中で一番点数の低いもの。
                        double minScore = double.MaxValue;
                        niniNode.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> nextNode, ref bool toBreak) =>
                        {
                            double score = ((KifuNode)nextNode).KyHyoka.Total();
                            if (score < minScore)
                            {
                                minScore = score;
                            }
                        });
                        niniNode.SetBranchKyHyoka(new KyHyokaImpl(minScore));
                    }
                }
                catch (Exception ex) { OwataMinister.WARABE_ENGINE.DonimoNaranAkirameta(ex, "途中のノードに点数を付けたときです。"); throw ex; }

            }
        }



    }
}
