﻿using System;
using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P222_Log_Kaisetu.L250____Struct;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P511_KifuWarabe_.L___100_Shogisasi;
using Grayscale.P153_KifuSfen___.L___250_Report;
using Grayscale.P157_SfenReport_.L500____Struct;

#if DEBUG
using System.Diagnostics;
using Grayscale.P306_LogGraphiEx.L500____Util;
#endif

namespace Grayscale.P511_KifuWarabe_.L099____Util
{
    public abstract class Util_LogWriter500_HyokaMeisai
    {

        public static ReportEnvironment REPORT_ENVIRONMENT;
        static Util_LogWriter500_HyokaMeisai()
        {
            Util_LogWriter500_HyokaMeisai.REPORT_ENVIRONMENT = new ReportEnvironmentImpl(
                        "../../Logs/局面画像ﾛｸﾞ/",//argsDic["outFolder"],
                        "../../Data/img/gkLog/",//argsDic["imgFolder"],
                        "koma1.png",//argsDic["kmFile"],
                        "suji1.png",//argsDic["sjFile"],
                        "20",//argsDic["kmW"],
                        "20",//argsDic["kmH"],
                        "8",//argsDic["sjW"],
                        "12"//argsDic["sjH"]
                        );
        }


        /// <summary>
        /// 評価明細ログの書出し
        /// </summary>
        public static void Log_HyoukaMeisai(
            Shogisasi shogisasi,
            KaisetuBoards logF_kiki,
            KifuTree kifu,
            PlayerInfo playerInfo,
            KwErrorHandler errH
            )
        {
#if DEBUG
            try
            {
                string sasiteText1 = Conv_Sasite307.ToSfenFugo(kifu.CurNode.Key);
                KifuNode kifuNode1 = (KifuNode)kifu.CurNode;
                string relFolder = "" + Conv_Sasite307.ToSfenFugo_ForFilename(kifu.CurNode.Key) + "/";

                // 評価明細のログ出力。
                shogisasi.KyHyokaWriter.Write_ForeachLeafs(
                    sasiteText1,
                    kifuNode1,
                    kifu,
                    playerInfo,
                    relFolder,
                    Util_LogWriter500_HyokaMeisai.REPORT_ENVIRONMENT,
                    errH
                    );
            }
            catch (Exception ex)
            {
                //>>>>> エラーが起こりました。
                string message = ex.GetType().Name + " " + ex.Message + "：評価明細付きのログ出力をしていたときです。：";
                Debug.Fail(message);

                // どうにもできないので  ログだけ取って、上に投げます。
                OwataMinister.WARABE_ENGINE.Logger.WriteLine_Error(message);
                throw ex;
            }

            try
            {
                if (0 < logF_kiki.boards.Count)//ﾛｸﾞが残っているなら
                {
                    bool enableLog = true;// false;
                    //
                    // ログの書き出し
                    //
                    Util_GraphicalLog.WriteHtml5(
                        enableLog,
                        "#評価ログ",
                        "[" + Conv_KaisetuBoards.ToJsonStr(logF_kiki) + "]"
                    );

                    // 書き出した分はクリアーします。
                    logF_kiki.boards.Clear();
                }
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "局面評価明細を出力しようとしたときです。"); throw ex; }
#endif
        }

        /// <summary>
        /// 評価明細ログの書出し
        /// </summary>
        public static void Log_Html5(
            Shogisasi shogisasi,
            KaisetuBoards logF_kiki,
            KifuTree kifu,
            PlayerInfo playerInfo,
            KwErrorHandler errH
            )
        {
#if DEBUG
            try
            {
                if (0 < logF_kiki.boards.Count)//ﾛｸﾞが残っているなら
                {
                    bool enableLog = true;// false;
                    //
                    // ログの書き出し
                    //
                    Util_GraphicalLog.WriteHtml5(
                        enableLog,
                        "#評価ログ",
                        "[" + Conv_KaisetuBoards.ToJsonStr(logF_kiki) + "]"
                    );

                    // 書き出した分はクリアーします。
                    logF_kiki.boards.Clear();
                }
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "HTML5ログを出力しようとしたときです。"); throw ex; }
#endif
        }

    }
}
