﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P011_Random_____.L500____Struct;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P222_Log_Kaisetu.L250____Struct;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L500____Util;
using Grayscale.P375_TansaFukasa.L500____Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___250_KyHandanOrder;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P511_KifuWarabe_.L___005_UsiLoop;
using Grayscale.P511_KifuWarabe_.L___020_Kokoro;
using Grayscale.P511_KifuWarabe_.L___040_KyHyoka;
using Grayscale.P511_KifuWarabe_.L___060_Minimax;
using Grayscale.P511_KifuWarabe_.L___100_Shogisasi;
using Grayscale.P511_KifuWarabe_.L009_KyHyoka;
using Grayscale.P511_KifuWarabe_.L020____Kokoro;
using Grayscale.P511_KifuWarabe_.L060____Minimax;
using Grayscale.P511_KifuWarabe_.L080____ScoreSibori;
using Grayscale.P511_KifuWarabe_.L099____Util;
using System;
using System.Collections.Generic;


#if DEBUG

#endif

namespace Grayscale.P511_KifuWarabe_.L100____Shogisasi
{
    /// <summary>
    /// 将棋指しエンジン。
    /// 
    /// 指し手を決めるエンジンです。
    /// </summary>
    public class ShogisasiImpl : Shogisasi
    {
        private ShogiEngine Owner { get { return this.owner; } }
        private ShogiEngine owner;

        /// <summary>
        /// 心エンジン。
        /// </summary>
        public Kokoro Kokoro { get; set; }

        /// <summary>
        /// 点数付けエンジン。
        /// </summary>
        public MinimaxEngine MinimaxEngine { get; set; }

        /// <summary>
        /// 枝狩りエンジン。
        /// </summary>
        public ScoreSiboriEngine EdagariEngine { get; set; }

        /// <summary>
        /// 思考エンジンの性格。
        /// </summary>
        public Seikaku Seikaku { get; set; }

        /// <summary>
        /// 局面評価ライター。
        /// </summary>
        public KyHyokaWriter KyHyokaWriter{get;set;}

        /// <summary>
        /// 右脳。
        /// </summary>
        public UnouImpl Unou { get; set; }

        public ShogisasiImpl(ShogiEngine owner)
        {
            this.owner = owner;
            this.Kokoro = new KokoroImpl(this.owner);
            this.MinimaxEngine = new MinimaxEngineImpl(this.owner);
            this.EdagariEngine = new ScoreSiboriEngine();

            this.Seikaku = new Seikaku();
            this.KyHyokaWriter = new KyHyokaWriterImpl();

            this.Unou = new UnouImpl();
        }

        /// <summary>
        /// 対局開始のとき。
        /// </summary>
        public void OnTaikyokuKaisi()
        {
            this.Kokoro.ClearTenonagare();

            // 作った妄想は履歴に追加。

            //
            // 駒得が一番大事だぜ☆ｗｗｗｗ
            //

            //--------------------------------------------------------------------------------------------------------------
            //
            // テスト中。
            //

            // 「二駒関係」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.NikomaKankeiKkp, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

            //--------------------------------------------------------------------------------------------------------------
            //
            // 優先しても悪さしないもの。
            //

            // 「駒得」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.KomaDoku, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

            //--------------------------------------------------------------------------------------------------------------
            //
            // 強さの頼みの綱。
            //

            // 「紐付き」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.Himoduki, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

            //--------------------------------------------------------------------------------------------------------------
            //
            // 面白くするための苦肉の策。
            //

            // 「気まぐれ」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.Kimagure, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

            //--------------------------------------------------------------------------------------------------------------

            // 「玉の守り」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.GyokuNoMamori, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

            // 「飛車道が通っている」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.Toosi, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

            // 「目の前の歩を取れ」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.MenomaenoFuWoTore, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

            //--------------------------------------------------------------------------------------------------------------
            //
            // 故障部品
            //

            // 「角頭の紐付き」タイプの狙いを作ります。
            this.Kokoro.AddTenonagare(new TenonagareImpl(null, KyHandanOrderName.Default, TenonagareName.KakuTouNoHimoduki, null, null, new Basho(0), OwataMinister.WARABE_ENGINE));

        }

        /// <summary>
        /// 指し手を決めます。
        /// </summary>
        /// <param name="enableLog"></param>
        /// <param name="isHonshogi"></param>
        /// <param name="kifu"></param>
        /// <param name="playerInfo"></param>
        /// <param name="logTag"></param>
        /// <returns></returns>
        public KifuNode WA_Bestmove(
            bool isHonshogi,
            KifuTree kifu,
            PlayerInfo playerInfo,
            KwErrorHandler errH
            )
        {
            kifu.AssertPside(kifu.CurNode, "WA_Bestmove",errH);

            try
            {
                // 「移動」タイプの狙いを、どんどん付け足します。
                this.Kokoro.Omoituki(
                    playerInfo.Playerside, (KifuNode)kifu.CurNode, this.Seikaku);
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "ベスト指し手のチョイスをしたときの前半１０です。"); throw ex; }

            try
            {
                //
                // 指し手生成ルーチンで、棋譜ツリーを作ります。
                //
                new Tansaku_FukasaYusen_Routine().WAA_Yomu_Start(kifu, isHonshogi, errH);
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "棋譜ツリーを作っていたときです。"); throw ex; }



            // デバッグ用だが、メソッドはこのオブジェクトを必要としてしまう。
            KaisetuBoards logF_kiki = new KaisetuBoards();

#if DEBUG
            ////----------------------------------------
            //// 枝葉の「手番済み」番号をデバッグ出力
            ////----------------------------------------
            //KifuNode niniNode = (KifuNode)kifu.CurNode;//任意のノード。
            //System.Text.StringBuilder sb = new System.Text.StringBuilder();
            //sb.AppendLine("任意ノード　" + niniNode.Value.ToKyokumenConst.KaisiPside);
            //sb.AppendLine("┏━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┓子要素の一覧");
            //niniNode.Foreach_ChildNodes((string key1, Node<ShootingStarlightable, KyokumenWrapper> nextNode1, ref bool toBreak1) =>
            //{
            //    //
            //    // 診断
            //    //
            //    kifu.AssertPside(nextNode1, "WA_Bestmove",errH);// 任意のノードの子要素。
            //    sb.AppendLine("子　" + nextNode1.Value.ToKyokumenConst.KaisiPside);
            //    sb.AppendLine("┏━━━━━━━━━━━━━━━━━━━━┓孫要素の一覧");
            //    nextNode1.Foreach_ChildNodes((string key2, Node<ShootingStarlightable, KyokumenWrapper> nextNode2, ref bool toBreak2) =>
            //    {
            //        sb.AppendLine("孫　" + nextNode2.Value.ToKyokumenConst.KaisiPside);
            //        // 任意のノードの孫要素。
            //        //kifu.AssertPside(nextNode2);//FIXME: 任意のノードの孫に、先後のずれた　nextNode　が登録されている？
            //    });
            //    sb.AppendLine("┗━━━━━━━━━━━━━━━━━━━━┛");
            //});
            //sb.AppendLine("┗━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┛");
            //System.Windows.Forms.MessageBox.Show(System.Windows.Forms.Application.StartupPath + System.IO.Path.DirectorySeparatorChar + "../../Logs/_log_診断.txt");
            //System.IO.File.WriteAllText(System.Windows.Forms.Application.StartupPath + System.IO.Path.DirectorySeparatorChar + "../../Logs/_log_診断.txt", sb.ToString());
#endif

            try
            {
                // 点数を付ける（葉ノードに点数を付け、途中のノードの点数も出します）

                this.MinimaxEngine.Tensuduke_ForeachLeafs(
                    Conv_Sasite307.ToSfenFugo(kifu.CurNode.Key),
                    (KifuNode)kifu.CurNode,//任意のノード。//棋譜ツリーに追加されているか？
                    //kifu,
                    this.Kokoro,
                    this.Unou,
                    playerInfo,
                    Util_LogWriter500_HyokaMeisai.REPORT_ENVIRONMENT,
                    logF_kiki,
                    errH
                );
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "ノードに点数を付けたときです。"); throw ex; }

            //
            // 評価明細ログの書出し
            //
            Util_LogWriter500_HyokaMeisai.Log_HyoukaMeisai(
                this,
                logF_kiki,
                kifu,
                playerInfo,
                errH
                );
            //Util_LogWriter500_HyokaMeisai.Log_Html5(
            //    this,
            //    logF_kiki,
            //    kifu,
            //    playerInfo,
            //    errH
            //    );

            try
            {
                // 評価値の高いノードだけを残します。
                this.EdagariEngine.EdaSibori_HighScore(kifu, this.Kokoro);
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "ベスト指し手のチョイスをしたときの後半２０です。"); throw ex; }


            // 評価値の同点があれば、同点決勝をして　1手に決めます。
            KifuNode bestKifuNode = null;
            try
            {
                bestKifuNode = this.ChoiceNode_DoutenKessyou(kifu, isHonshogi, errH);
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "ベスト指し手のチョイスをしたときの後半３０です。"); throw ex; }


            return bestKifuNode;
        }

        /// <summary>
        /// 同点決勝。
        /// 
        /// 評価値が同点のノード（指し手）の中で、ランダムに１つ選びます。
        /// </summary>
        /// <param name="kifu">ツリー構造になっている棋譜</param>
        /// <param name="logTag">ログ</param>
        /// <returns></returns>
        private KifuNode ChoiceNode_DoutenKessyou(
            KifuTree kifu,
            bool isHonshogi, KwErrorHandler errH)
        {
            KifuNode bestKifuNode = null;

            {
                // 次のノードをリストにします。
                //List<KifuNode> nextNodes = Util_Converter280.NextNodes_ToList(kifu.CurNode);

                // 次のノードをシャッフル済みリストにします。
                List<KifuNode> nextNodes_shuffled = Conv_NextNodes.ToList(kifu.CurNode);
                LarabeShuffle<KifuNode>.Shuffle_FisherYates(ref nextNodes_shuffled);

                // シャッフルした最初のノードを選びます。
                if (0 < nextNodes_shuffled.Count)
                {
                    bestKifuNode = nextNodes_shuffled[0];
                }
            }

            return bestKifuNode;
        }



    }
}
