﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P005_Tushin_____.L500____Util;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P213_Komasyurui_.L500____Util;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P234_Komahaiyaku.L500____Util;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P276_SeizaStartp.L500____Struct;
using Grayscale.P292_JsaFugo____.L500____Util;
using Grayscale.P295_JsaFugoWrit.L500____Writer;
using Grayscale.P322_KifuTree___.L250____Struct;
using Grayscale.P324_ShogiGuiBas.L___500_Struct;
using Grayscale.P341_Ittesasu___.L___250_OperationA;
using Grayscale.P341_Ittesasu___.L250____OperationA;
using Grayscale.P341_Ittesasu___.L500____UtilA;
using Grayscale.P355_KifuParserA.L___500_Parser;
using Grayscale.P355_KifuParserA.L500____Parser;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.CompilerServices;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P603_ShogiServer.L500____UtilInServer
{


    public class Util_InServer
    {





        /// <summary>
        /// 「棋譜ツリーのカレントノード」の差替え、
        /// および
        /// 「ＧＵＩ用局面データ」との同期。
        /// 
        /// (1) 駒をつまんでいるときに、マウスの左ボタンを放したとき。
        /// (2) 駒の移動先の升の上で、マウスの左ボタンを放したとき。
        /// (3) 成る／成らないダイアログボックスが出たときに、マウスの左ボタンを押下したとき。
        /// </summary>
        /// <param name="kifu"></param>
        /// <param name="newNode"></param>
        public static void SetCurNode_Srv(
            ShogiGui_Base shogiGui_Base,
            Node<Starbeamable, KyokumenWrapper> newNode
            )
        {
            Debug.Assert(null != newNode, "新規ノードがヌル。");

            shogiGui_Base.Model_PnlTaikyoku.Kifu.SetCurNode( newNode);

            shogiGui_Base.Model_PnlTaikyoku.SetGuiSky(newNode.Value.ToKyokumenConst);
            shogiGui_Base.Model_PnlTaikyoku.GuiTemezumi = shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode.Value.ToKyokumenConst.Temezumi;

            shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode, "SetCurNode_Srv", OwataMinister.BY_SERVER);
            shogiGui_Base.Model_PnlTaikyoku.GuiPside = Util_InServer.CurPside(shogiGui_Base);
        }

        public static Playerside CurPside(ShogiGui_Base shogiGui_Base)
        {
            shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode, "CurPside", OwataMinister.BY_SERVER); Playerside pside = shogiGui_Base.Model_PnlTaikyoku.Kifu.CurNode.Value.ToKyokumenConst.KaisiPside;
            return pside;
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// １手進む
        /// ************************************************************************************************************************
        /// 
        /// ＜棋譜読込用＞＜マウス入力非対応＞
        /// 
        /// 「棋譜並べモード」と「vsコンピューター対局」でも、これを使いますが、
        /// 「棋譜並べモード」では送られてくる SFEN が「position startpos moves 8c8d」とフルであるのに対し、
        /// 「vsコンピューター対局」では、送られてくる SFEN が「8c8d」だけです。
        /// 
        /// それにより、処理の流れが異なります。
        /// 
        /// </summary>
        public static bool ReadLine_TuginoItteSusumu_Srv(
            ref string inputLine,
            ShogiGui_Base shogiGui_Base,
            out bool toBreak,
            string hint
            ,
            [CallerMemberName] string memberName = "",
            [CallerFilePath] string sourceFilePath = "",
            [CallerLineNumber] int sourceLineNumber = 0
            )
        {
            bool successful = false;
            KifuParserA_Impl kifuParserA_Impl = new KifuParserA_Impl();
            KifuParserA_Result result = new KifuParserA_ResultImpl();
            KifuParserA_Genjo genjo = new KifuParserA_GenjoImpl( inputLine);

            try
            {

                kifuParserA_Impl.Delegate_OnChangeSky_Im_Srv = Util_InServer.OnChangeSky_Im_Srv;

                KwLogger logTag = OwataMinister.BY_SERVER.Logger;

                if (kifuParserA_Impl.State is KifuParserA_StateA0_Document)
                {
                    // 最初はここ

                    logTag.WriteLine_AddMemo("... ...");
                    logTag.WriteLine_AddMemo("ｻｲｼｮﾊｺｺ☆　：　" + memberName + "." + sourceFilePath + "." + sourceLineNumber);
                    inputLine = kifuParserA_Impl.Execute_Step(
                        ref result,
                        shogiGui_Base,
                        genjo,
                        OwataMinister.BY_SERVER
                        );

                    Debug.Assert(result.Out_newNode_OrNull == null, "ここでノードに変化があるのはおかしい。");

                    if (genjo.ToBreak)
                    {
                        goto gt_EndMethod;
                    }
                    // （１）position コマンドを処理しました。→startpos
                    // （２）日本式棋譜で、何もしませんでした。→moves
                }

                if (kifuParserA_Impl.State is KifuParserA_StateA1_SfenPosition)
                {
                    //------------------------------------------------------------
                    // このブロックでは「position ～ moves 」まで一気に(*1)を処理します。
                    //------------------------------------------------------------
                    //
                    //          *1…初期配置を作るということです。
                    // 

                    {
                        string message = "ﾂｷﾞﾊ　ﾋﾗﾃ　ﾏﾀﾊ　ｼﾃｲｷｮｸﾒﾝ　ｦ　ｼｮﾘｼﾀｲ☆ inputLine=[" + inputLine + "]";
                        logTag.WriteLine_AddMemo(message);

                        inputLine = kifuParserA_Impl.Execute_Step(
                            ref result,
                            shogiGui_Base,
                            genjo,
                            OwataMinister.BY_SERVER
                            );
                        Debug.Assert(result.Out_newNode_OrNull == null, "ここでノードに変化があるのはおかしい。");


                        if (genjo.ToBreak)
                        {
                            goto gt_EndMethod;
                        }
                    }


                    {
                        logTag.WriteLine_AddMemo("ﾂｷﾞﾊ　ﾑｰﾌﾞｽ　ｦ　ｼｮﾘｼﾀｲ☆");
                        inputLine = kifuParserA_Impl.Execute_Step(
                            ref result,
                            shogiGui_Base,
                            genjo,
                            OwataMinister.BY_SERVER
                            );
                        Debug.Assert(result.Out_newNode_OrNull == null, "ここでノードに変化があるのはおかしい。");


                        if (genjo.ToBreak)
                        {
                            goto gt_EndMethod;
                        }
                        // moves を処理しました。
                        // ここまでで、「position ～ moves 」といった記述が入力されていたとすれば、入力欄から削除済みです。
                    }


                    // →moves
                }

                //
                // 対COMP戦で関係があるのはここです。
                //
                if (kifuParserA_Impl.State is KifuParserA_StateA2_SfenMoves)
                {
                    logTag.WriteLine_AddMemo("ﾂｷﾞﾊ　ｲｯﾃ　ｼｮﾘｼﾀｲ☆");
                    inputLine = kifuParserA_Impl.Execute_Step(
                        ref result,
                        shogiGui_Base,
                        genjo,
                        OwataMinister.BY_SERVER
                        );

                    if (null != result.Out_newNode_OrNull)
                    {
                        shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(result.Out_newNode_OrNull, "ReadLine_TuginoItteSusumu_Srv",OwataMinister.BY_SERVER);
                        Util_InServer.SetCurNode_Srv(shogiGui_Base, result.Out_newNode_OrNull);
                    }

                    if (genjo.ToBreak)
                    {
                        goto gt_EndMethod;
                    }


                    // １手を処理した☆？
                }


                successful = true;
            }
            catch (Exception ex)
            {
                Util_Message.Show(ex.GetType().Name+"："+ ex.Message);
                toBreak = true;
                successful = false;
            }

        gt_EndMethod:
            toBreak = genjo.ToBreak;
            return successful;
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="kifu"></param>
        /// <param name="restText"></param>
        /// <param name="startposImporter"></param>
        /// <param name="logTag"></param>
        public static void OnChangeSky_Im_Srv(
            ShogiGui_Base shogiGui_Base,
            StartposImporter startposImporter,
            KifuParserA_Genjo genjo,
            KwErrorHandler errH
            )
        {
            // ************************************************************************************************************************
            // SFENの初期配置の書き方(*1)を元に、駒を並べます。
            // ************************************************************************************************************************
            // 
            //     *1…「position startpos moves 7g7f 3c3d 2g2f」といった書き方。
            //     

            //------------------------------
            // 駒の配置
            //------------------------------
            {
                // 初期局面の先後
                Playerside firstPside;
                if (startposImporter.RO_SfenStartpos.PsideIsBlack)
                {
                    // 黒は先手。
                    firstPside = Playerside.P1;
                }
                else
                {
                    // 白は後手。
                    firstPside = Playerside.P2;
                }

                Starbeamable sasite = Util_Sky258A.NULL_OBJECT_SASITE;//ルートなので

                SkyConst src_Sky_New = startposImporter.ToSky(firstPside,
                    startposImporter.RO_SfenStartpos.Temezumi// FIXME: 将棋所だと常に 1 かも？？
                    );
                Node<Starbeamable, KyokumenWrapper> newNode =
                        new KifuNodeImpl(
                            sasite,
                            new KyokumenWrapper( SkyConst.NewInstance(
                                src_Sky_New,
                                -1 // src_Sky_Newで設定済みだからそのまま。
                                ))
                        );

                shogiGui_Base.Model_PnlTaikyoku.Kifu.AssertPside(newNode, "OnChangeSky_Im_Srv",OwataMinister.BY_SERVER);
                Util_InServer.SetCurNode_Srv(shogiGui_Base, newNode);// GUIに通知するだけ。
            }



            // 駒袋に表示されている駒を、駒台に表示させます。
            {
                // 駒袋に表示されている駒を、駒台へ表示されるように移します。
                List<Komasyurui14> syuruiList = new List<Komasyurui14>();
                List<int> countList = new List<int>();
                List<Playerside> psideList = new List<Playerside>();

                //------------------------------------------------------------------------------------------------------------------------
                // 移動計画作成
                //------------------------------------------------------------------------------------------------------------------------

                //------------------------------
                // ▲王
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1K)
                {
                    syuruiList.Add(Komasyurui14.H06_Oh_____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1K);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mK=" + ro_SfenStartpos.Moti1K);
                }

                //------------------------------
                // ▲飛
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1R)
                {
                    syuruiList.Add(Komasyurui14.H07_Hisya__);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1R);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mR=" + ro_SfenStartpos.Moti1R);
                }

                //------------------------------
                // ▲角
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1B)
                {
                    syuruiList.Add(Komasyurui14.H08_Kaku___);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1B);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mB=" + ro_SfenStartpos.Moti1B);
                }

                //------------------------------
                // ▲金
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1G)
                {
                    syuruiList.Add(Komasyurui14.H05_Kin____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1G);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mG=" + ro_SfenStartpos.Moti1G);
                }

                //------------------------------
                // ▲銀
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1S)
                {
                    syuruiList.Add(Komasyurui14.H04_Gin____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1S);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mS=" + ro_SfenStartpos.Moti1S);
                }

                //------------------------------
                // ▲桂
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1N)
                {
                    syuruiList.Add(Komasyurui14.H03_Kei____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1N);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mN=" + ro_SfenStartpos.Moti1N);
                }

                //------------------------------
                // ▲香
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1L)
                {
                    syuruiList.Add(Komasyurui14.H02_Kyo____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1L);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mL=" + ro_SfenStartpos.Moti1L);
                }

                //------------------------------
                // ▲歩
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti1P)
                {
                    syuruiList.Add(Komasyurui14.H01_Fu_____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti1P);
                    psideList.Add(Playerside.P1);
                    //System.C onsole.WriteLine("mP=" + ro_SfenStartpos.Moti1P);
                }

                //------------------------------
                // △王
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2k)
                {
                    syuruiList.Add(Komasyurui14.H06_Oh_____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2k);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("mk=" + ro_SfenStartpos.Moti2k);
                }

                //------------------------------
                // △飛
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2r)
                {
                    syuruiList.Add(Komasyurui14.H07_Hisya__);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2r);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("mr=" + ro_SfenStartpos.Moti2r);
                }

                //------------------------------
                // △角
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2b)
                {
                    syuruiList.Add(Komasyurui14.H08_Kaku___);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2b);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("mb=" + ro_SfenStartpos.Moti2b);
                }

                //------------------------------
                // △金
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2g)
                {
                    syuruiList.Add(Komasyurui14.H05_Kin____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2g);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("mg=" + ro_SfenStartpos.Moti2g);
                }

                //------------------------------
                // △銀
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2s)
                {
                    syuruiList.Add(Komasyurui14.H04_Gin____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2s);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("ms=" + ro_SfenStartpos.Moti2s);
                }

                //------------------------------
                // △桂
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2n)
                {
                    syuruiList.Add(Komasyurui14.H03_Kei____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2n);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("mn=" + ro_SfenStartpos.Moti2n);
                }

                //------------------------------
                // △香
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2l)
                {
                    syuruiList.Add(Komasyurui14.H02_Kyo____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2l);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("ml=" + ro_SfenStartpos.Moti2l);
                }

                //------------------------------
                // △歩
                //------------------------------
                if (0 < startposImporter.RO_SfenStartpos.Moti2p)
                {
                    syuruiList.Add(Komasyurui14.H01_Fu_____);
                    countList.Add(startposImporter.RO_SfenStartpos.Moti2p);
                    psideList.Add(Playerside.P2);
                    //System.C onsole.WriteLine("mp=" + ro_SfenStartpos.Moti2p);
                }




                //------------------------------------------------------------------------------------------------------------------------
                // 移動
                //------------------------------------------------------------------------------------------------------------------------
                for (int i = 0; i < syuruiList.Count; i++)
                {
                    Playerside itaruPside;   //(至)先後
                    Okiba itaruOkiba;   //(至)置き場

                    if (Playerside.P2 == psideList[i])
                    {
                        // 宛：後手駒台
                        itaruPside = Playerside.P2;
                        itaruOkiba = Okiba.Gote_Komadai;
                    }
                    else
                    {
                        // 宛：先手駒台
                        itaruPside = Playerside.P1;
                        itaruOkiba = Okiba.Sente_Komadai;
                    }


                    //------------------------------
                    // 駒を、駒袋から駒台に移動させます。
                    //------------------------------
                    {
                        SkyBuffer buffer_Sky = new SkyBuffer(shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst);

                        Fingers komas = Util_Sky_FingersQuery.InOkibaKomasyuruiNow( SkyConst.NewInstance(
                            buffer_Sky,
                            -1//そのまま。
                            ), Okiba.KomaBukuro, syuruiList[i]);
                        int moved = 1;
                        foreach (Finger koma in komas.Items)
                        {
                            // 駒台の空いている枡
                            SyElement akiMasu = Util_IttesasuRoutine.GetKomadaiKomabukuroSpace(itaruOkiba, SkyConst.NewInstance(
                                buffer_Sky,
                                -1//そのまま
                                ));

                            buffer_Sky.PutOverwriteOrAdd_Starlight(koma, new RO_Starlight(
                                new RO_Star(
                                itaruPside,
                                akiMasu,
                                syuruiList[i]
                                )));

                            if (countList[i] <= moved)
                            {
                                break;
                            }

                            moved++;
                        }
                        shogiGui_Base.Model_PnlTaikyoku.SetGuiSky( SkyConst.NewInstance(
                            buffer_Sky,
                            -1//そのまま
                            ));
                    }

                }
            }
        }




        /// <summary>
        /// ************************************************************************************************************************
        /// [巻戻し]ボタン
        /// ************************************************************************************************************************
        /// </summary>
        public static bool Makimodosi_Srv(
            out Finger movedKoma,
            out Finger foodKoma,
            out string fugoJStr,
            ShogiGui_Base shogiGui,
            KwErrorHandler errH
            )
        {
            bool successful = false;

            //------------------------------
            // 棋譜から１手削ります
            //------------------------------
            Node<Starbeamable, KyokumenWrapper> removeeLeaf = shogiGui.Model_PnlTaikyoku.Kifu.CurNode;
            int korekaranoTemezumi = removeeLeaf.Value.ToKyokumenConst.Temezumi - 1;//１手前へ。

            if (removeeLeaf.IsRoot())
            {
                // ルート
                fugoJStr = "×";
                movedKoma = Fingers.Error_1;
                foodKoma = Fingers.Error_1;
                goto gt_EndMethod;
            }


            //------------------------------
            // 符号
            //------------------------------
            //
            // 移動前と、移動後では、駒が変わっていることがあります。
            // 例えば、「▲２二角成」なら　移動前は角、移動後は馬です。
            //
            // そこで[巻戻し]ボタンでは、移動前の駒に従って、「進んできた動きとは逆の動き」を行います。

            RO_Star koma = Util_Koma.AsKoma(removeeLeaf.Key.LongTimeAgo);

            fugoJStr =Util_Translator_JsaFugo.ToString_UseDou( Array_JsaFugoCreator15.ItemMethods[
                (int)Util_Komahaiyaku184.Syurui(koma.Haiyaku)
            ](
                removeeLeaf.Key,
                new KyokumenWrapper(shogiGui.Model_PnlTaikyoku.GuiSkyConst),
                errH
            ),removeeLeaf);
            //MessageBox.Show("[巻戻し]符号＝" + fugoJStr, "デバッグ");




            //------------------------------
            // 前の手に戻します
            //------------------------------
            IttemodosuResult ittemodosuResult = new IttemodosuResultImpl(Fingers.Error_1, Fingers.Error_1, null, Komasyurui14.H00_Null___, null);
            {
                //Ks14 foodKomaSyurui;//取った駒があれば、取った駒の種類。
                //SkyConst susunda_Sky_orNull;
                //
                // 一手巻き戻す
                //
                Util_IttemodosuRoutine.Before1(
                    new IttemodosuArgImpl(
                        shogiGui.Model_PnlTaikyoku.Kifu.CurNode,
                        removeeLeaf.Key,
                        korekaranoTemezumi
                    ),
                    out ittemodosuResult,
                    errH
                    );
                Util_IttemodosuRoutine.Before2(
                    ref ittemodosuResult,
                    errH
                    );
                Util_IttemodosuRoutine.After3_ChangeCurrent(
                    shogiGui.Model_PnlTaikyoku.Kifu
                    );
            }
            movedKoma = ittemodosuResult.FigMovedKoma;
            foodKoma = ittemodosuResult.FigFoodKoma;

            successful = true;


        gt_EndMethod:
            return successful;
        }





        /// <summary>
        /// ************************************************************************************************************************
        /// [コマ送り]ボタン
        /// ************************************************************************************************************************
        /// 
        /// vsコンピューター対局でも、タイマーによって[コマ送り]が実行されます。
        /// 
        /// </summary>
        public static bool Komaokuri_Srv(
            ref string inputLine,
            ShogiGui_Base shogiGui_Base,
            KwErrorHandler errH
            ,
            [CallerMemberName] string memberName = "",
            [CallerFilePath] string sourceFilePath = "",
            [CallerLineNumber] int sourceLineNumber = 0
            )
        {

            bool toBreak = false;
            Util_InServer.ReadLine_TuginoItteSusumu_Srv(
                ref inputLine,
                shogiGui_Base,
                out toBreak,
                "hint"
                );

            return true;
        }




        /// <summary>
        /// ************************************************************************************************************************
        /// 駒を動かします(1)。マウスボタンが押下されたとき。
        /// ************************************************************************************************************************
        /// 
        /// 成る、成らない関連。
        /// 
        /// </summary>
        public static void Komamove1a_50Srv(
            out bool torareruKomaAri,
            out RO_Star koma_Food_after,
            Starlight dst,
            Finger fig_btnTumandeiruKoma,
            RO_Star foodee_koma,//取られる対象の駒
            ShogiGui_Base shogiGui_Base,
            KwErrorHandler errH
            )
        {

            Finger btnKoma_Food_Koma;



            // 取られることになる駒のボタン
            btnKoma_Food_Koma = Util_Sky_FingersQuery.InMasuNow(shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst, foodee_koma.Masu).ToFirst();
            if (Fingers.Error_1 == btnKoma_Food_Koma)
            {
                koma_Food_after = null;
                torareruKomaAri = false;
                btnKoma_Food_Koma = Fingers.Error_1;
                goto gt_EndBlock1;
            }
            else
            {
                //>>>>> 取る駒があったとき
                torareruKomaAri = true;
            }





            Komasyurui14 koma_Food_pre_Syurui = Util_Koma.AsKoma(shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst.StarlightIndexOf(btnKoma_Food_Koma).Now).Komasyurui;


            // その駒は、駒置き場に移動させます。
            SyElement akiMasu;
            switch (foodee_koma.Pside)
            {
                case Playerside.P2:

                    akiMasu = Util_IttesasuRoutine.GetKomadaiKomabukuroSpace(Okiba.Gote_Komadai, shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst);
                    if (Masu_Honshogi.Error != akiMasu)
                    {
                        // 駒台に空きスペースがありました。
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        koma_Food_after = new RO_Star(
                            Playerside.P2,
                            akiMasu,//駒台へ
                            Util_Komasyurui14.NarazuCaseHandle(koma_Food_pre_Syurui)
                        );
                    }
                    else
                    {
                        // エラー：　駒台に空きスペースがありませんでした。
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        koma_Food_after = new RO_Star(
                            Playerside.P2,
                            Util_Masu10.OkibaSujiDanToMasu(
                                Okiba.Gote_Komadai,
                                Util_Koma.CTRL_NOTHING_PROPERTY_SUJI,
                                Util_Koma.CTRL_NOTHING_PROPERTY_DAN
                            ),
                            Util_Komasyurui14.NarazuCaseHandle(koma_Food_pre_Syurui)
                        );
                    }

                    break;

                case Playerside.P1://thru
                default:

                    akiMasu = Util_IttesasuRoutine.GetKomadaiKomabukuroSpace(Okiba.Sente_Komadai, shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst);
                    if (Masu_Honshogi.Error != akiMasu)
                    {
                        // 駒台に空きスペースがありました。
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        koma_Food_after = new RO_Star(
                            Playerside.P1,
                            akiMasu,//駒台へ
                            Util_Komasyurui14.NarazuCaseHandle(koma_Food_pre_Syurui)
                        );
                    }
                    else
                    {
                        // エラー：　駒台に空きスペースがありませんでした。
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        koma_Food_after = new RO_Star(
                            Playerside.P1,
                            Util_Masu10.OkibaSujiDanToMasu(
                                Okiba.Sente_Komadai,
                                Util_Koma.CTRL_NOTHING_PROPERTY_SUJI,
                                Util_Koma.CTRL_NOTHING_PROPERTY_DAN
                            ),
                            Util_Komasyurui14.NarazuCaseHandle(koma_Food_pre_Syurui)
                        );
                    }

                    break;
            }



        gt_EndBlock1:


            SkyConst sky2;
            if (btnKoma_Food_Koma != Fingers.Error_1)
            {
                //------------------------------
                // 取られる駒があった場合
                //------------------------------
                sky2 = SkyConst.NewInstance_OverwriteOrAdd_Light(
                        shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst,
                        -1,//そのまま
                        //
                        // 指した駒
                        //
                        fig_btnTumandeiruKoma,
                        dst,
                        //
                        // 取られた駒
                        //
                        btnKoma_Food_Koma,
                        new RO_Starlight(
                            koma_Food_after
                        )
                    );
            }
            else
            {
                //------------------------------
                // 取られる駒がなかった場合
                //------------------------------
                RO_Star movedKoma = Util_Koma.AsKoma(shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst.StarlightIndexOf(fig_btnTumandeiruKoma).Now);

                sky2 = SkyConst.NewInstance_OverwriteOrAdd_Light(
                        shogiGui_Base.Model_PnlTaikyoku.GuiSkyConst,
                        -1,//そのまま
                        //
                        // 指した駒
                        //
                        fig_btnTumandeiruKoma,
                        dst,
                        //
                        // 手得計算
                        //
                        movedKoma.Komasyurui,
                        0,
                        movedKoma.Masu
                    );
            }

            shogiGui_Base.Model_PnlTaikyoku.SetGuiSky(sky2);
            // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
            // 棋譜は変更された。
            // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
        }


    }


}
