﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P007_Csv________.L500____Util;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P212_ConvPside__.L500____Converter;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P234_Komahaiyaku.L500____Util;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P276_SeizaStartp.L500____Struct;
using Grayscale.P292_JsaFugo____.L250____Struct;
using Grayscale.P292_JsaFugo____.L500____Util;
using Grayscale.P295_JsaFugoWrit.L500____Writer;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L250____Struct;
using Grayscale.P322_KifuTree___.L500____Util;
using Grayscale.P603_ShogiServer.L500____UtilInServer;
using Grayscale.P703_ShogiGui___.L___050_Shape;
using Grayscale.P703_ShogiGui___.L___100_Ui;
using Grayscale.P703_ShogiGui___.L___125_Scene;
using Grayscale.P703_ShogiGui___.L___500_Gui;
using Grayscale.P703_ShogiGui___.L080____Sprite;
using Grayscale.P703_ShogiGui___.L100____Macro;
using Grayscale.P703_ShogiGui___.L101____Util;
using Grayscale.P703_ShogiGui___.L499____Util;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P703_ShogiGui___.L500____GUI
{
    public class WidgetsLoader_KifuNarabe : WidgetsLoader
    {
        public string FileName { get; set; }

        public WidgetsLoader_KifuNarabe(string fileName)
        {
            this.FileName = fileName;
        }

        public virtual void Step1_ReadFile(object obj_shogiGui)
        {
            ShogiGui shogiGui = (ShogiGui)obj_shogiGui;

            List<List<string>> rows = Util_Csv.ReadCsv(this.FileName, Encoding.UTF8);

            // 最初の1行は、列名。
            Dictionary<string, int> columnNameIndex = new Dictionary<string, int>();
            {
                int i = 0;
                foreach (string columnName in rows[0])
                {
                    columnNameIndex.Add(columnName, i);
                    i++;
                }
            }
            rows.RemoveRange(0, 1);

            foreach (List<string> row in rows)
            {
                if (0 == row.Count)
                {
                    // 列のない行は無視します。
                    goto gt_NextRow;
                }

                //
                // 名称
                //
                if (!columnNameIndex.ContainsKey("name"))
                {
                    // name列のない行は無視します。
                    goto gt_NextRow;
                }
                string name = row[columnNameIndex["name"]];

                //
                // 型
                //
                string type = "Button"; // 既定値：ボタン
                if (columnNameIndex.ContainsKey("type"))
                {
                    type = row[columnNameIndex["type"]];
                }

                //
                // ウィンドウ・ガジェット生成、パネルへ追加
                //
                UserWidget widget;
                switch (type)
                {
                    case "Masu":
                        widget = new UserMasuImpl(new Shape_BtnMasuImpl());
                        break;
                    default://Button
                        widget = new UserButtonImpl(new Shape_BtnBoxImpl());
                        break;
                }
                widget.Type = type;
                widget.Name = name;
                shogiGui.Shape_PnlTaikyoku.SetWidget(name, widget);

                //
                // 「IsLight_OnFlowB_1TumamitaiKoma」のTRUE/FALSE
                //
                if (columnNameIndex.ContainsKey("IsLight_OnFlowB_1TumamitaiKoma"))
                {
                    string value = row[columnNameIndex["IsLight_OnFlowB_1TumamitaiKoma"]];
                    bool b;
                    if (bool.TryParse(value, out b))
                    {
                        widget.IsLight_OnFlowB_1TumamitaiKoma = b;
                    }
                }

                //
                // 「x」
                //
                if (columnNameIndex.ContainsKey("x"))
                {
                    string value = row[columnNameIndex["x"]];
                    int x;
                    if (int.TryParse(value, out x))
                    {
                        widget.SetBounds(new Rectangle(x, widget.Bounds.Y, widget.Bounds.Width, widget.Bounds.Height));
                    }
                }

                //
                // 「y」
                //
                if (columnNameIndex.ContainsKey("y"))
                {
                    string value = row[columnNameIndex["y"]];
                    int y;
                    if (int.TryParse(value, out y))
                    {
                        widget.SetBounds(new Rectangle(widget.Bounds.X, y, widget.Bounds.Width, widget.Bounds.Height));
                    }
                }

                //
                // 「label」
                //
                if (columnNameIndex.ContainsKey("label"))
                {
                    string value = row[columnNameIndex["label"]];
                    widget.Text = value;
                }

                //
                // 「fontSize」
                //
                if (columnNameIndex.ContainsKey("fontSize"))
                {
                    string value = row[columnNameIndex["fontSize"]];
                    float fontSize;
                    if (float.TryParse(value, out fontSize))
                    {
                        widget.FontSize = fontSize;
                    }
                }

                //
                // 「fugo」
                //
                if (columnNameIndex.ContainsKey("fugo"))
                {
                    string value = row[columnNameIndex["fugo"]];
                    widget.Fugo = value;
                }

                //
                // 「width」
                //
                if (columnNameIndex.ContainsKey("width"))
                {
                    string value = row[columnNameIndex["width"]];
                    int width;
                    if (int.TryParse(value, out width))
                    {
                        widget.SetBounds(new Rectangle(widget.Bounds.X, widget.Bounds.Y, width, widget.Bounds.Height));
                    }
                }

                //
                // 「height」
                //
                if (columnNameIndex.ContainsKey("height"))
                {
                    string value = row[columnNameIndex["height"]];
                    int height;
                    if (int.TryParse(value, out height))
                    {
                        widget.SetBounds(new Rectangle(widget.Bounds.X, widget.Bounds.Y, widget.Bounds.Width, height));
                    }
                }

                //
                // 「visible」
                //
                if (columnNameIndex.ContainsKey("visible"))
                {
                    string value = row[columnNameIndex["visible"]];
                    bool visible;
                    if (bool.TryParse(value, out visible))
                    {
                        widget.Visible = visible;
                    }
                }

                //
                // 「backColor」
                //
                if (columnNameIndex.ContainsKey("backColor"))
                {
                    string value = row[columnNameIndex["backColor"]];
                    if ("" != value)
                    {
                        widget.BackColor = Color.FromName(value);
                    }
                }

                //
                // 「okiba」
                //
                if (columnNameIndex.ContainsKey("okiba"))
                {
                    string value = row[columnNameIndex["okiba"]];
                    switch (value)
                    {
                        case "ShogiBan":
                            widget.Okiba = Okiba.ShogiBan;
                            break;
                        case "Sente_Komadai":
                            widget.Okiba = Okiba.Sente_Komadai;
                            break;
                        case "Gote_Komadai":
                            widget.Okiba = Okiba.Gote_Komadai;
                            break;
                        case "KomaBukuro":
                            widget.Okiba = Okiba.KomaBukuro;
                            break;
                        default:
                            break;
                    }
                }

                //
                // 「suji」
                //
                if (columnNameIndex.ContainsKey("suji"))
                {
                    string value = row[columnNameIndex["suji"]];
                    int suji;
                    if (int.TryParse(value, out suji))
                    {
                        widget.Suji = suji;
                    }
                }

                //
                // 「dan」
                //
                if (columnNameIndex.ContainsKey("dan"))
                {
                    string value = row[columnNameIndex["dan"]];
                    int dan;
                    if (int.TryParse(value, out dan))
                    {
                        widget.Dan = dan;
                    }
                }

                //
                // 「masuHandle」
                //
                if (columnNameIndex.ContainsKey("masuHandle"))
                {
                    string value = row[columnNameIndex["masuHandle"]];
                    int masuHandle;
                    if (int.TryParse(value, out masuHandle))
                    {
                        widget.MasuHandle = masuHandle;
                    }
                }

            gt_NextRow:
                ;
            }
        }

        public virtual void Step2_Compile_AllWidget(object obj_shogiGui)
        {
            ShogiGui shogiGui = (ShogiGui)obj_shogiGui;

            foreach (UserWidget widget in shogiGui.Shape_PnlTaikyoku.Widgets.Values)
            {
                widget.Compile();
            }
        }

        public virtual void Step3_SetEvent(object obj_shogiGui)
        {
            ShogiGui shogiGui1 = (ShogiGui)obj_shogiGui;

            //----------
            // [成る]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnNaru");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH2
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;


                    shogiGui.Shape_PnlTaikyoku.SetNaruFlag(true);
                    this.After_NaruNaranai(
                        shogiGui
                        , btnKoma_Selected
                        , errH2
                        );
                };
            }

            //----------
            // [成らない]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnNaranai");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    shogiGui.Shape_PnlTaikyoku.SetNaruFlag(false);
                    this.After_NaruNaranai(
                        shogiGui
                        , btnKoma_Selected
                        , errH
                        );
                };
            }

            //----------
            // [クリアー]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnClear");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Util_Lua_KifuNarabe.ShogiGui = shogiGui;
                    Util_Lua_KifuNarabe.ErrH = errH;
                    Util_Lua_KifuNarabe.Perform("click_clearButton");
                };
            }

            //----------
            // [再生]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnPlay");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Util_Lua_KifuNarabe.ShogiGui = shogiGui;
                    Util_Lua_KifuNarabe.ErrH = errH;
                    Util_Lua_KifuNarabe.Perform("click_playButton");
                };
            }

            //----------
            // [コマ送り]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnForward");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    string restText = Util_InGui.ReadLine_FromTextbox();
                    Util_InServer.Komaokuri_Srv(ref restText, shogiGui, errH);
                    Util_InGui.Komaokuri_Gui(restText, shogiGui, errH);
                    Util_Menace.Menace(shogiGui, errH);// メナス
                };
            }

            //----------
            // [巻戻し]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnBackward");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    Finger movedKoma;
                    Finger foodKoma;//取られた駒
                    string fugoJStr;

                    if (!Util_InServer.Makimodosi_Srv(out movedKoma, out foodKoma, out fugoJStr, shogiGui, errH))
                    {
                        goto gt_EndBlock;
                    }

                    Util_InGui.Makimodosi_Gui(shogiGui,movedKoma,foodKoma,fugoJStr, Util_InGui.ReadLine_FromTextbox(), errH);
                    Util_Menace.Menace(shogiGui, errH);//メナス

                gt_EndBlock:
                    ;
                };
            }


            //----------
            // ログ出せボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnLogdase");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    ui_PnlMain.ShogiGui.Logdase();
                };
            }




            //----------
            // [壁置く]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnKabeOku");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    // [壁置く]←→[駒動かす]切替
                    switch(widget.Text)
                    {
                        case "壁置く":
                            widget.Text = "駒動かす";
                            break;
                        default:
                            widget.Text = "壁置く";
                            break;
                    }

                    shogiGui.ResponseData.ToRedraw();
                };
            }


            //----------
            // [出力切替]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnSyuturyokuKirikae");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH2
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    switch (shogiGui.Shape_PnlTaikyoku.SyuturyokuKirikae)
                    {
                        case SyuturyokuKirikae.Japanese:
                            shogiGui.Shape_PnlTaikyoku.SetSyuturyokuKirikae(SyuturyokuKirikae.Sfen);
                            break;
                        case SyuturyokuKirikae.Sfen:
                            shogiGui.Shape_PnlTaikyoku.SetSyuturyokuKirikae(SyuturyokuKirikae.Html);
                            break;
                        case SyuturyokuKirikae.Html:
                            shogiGui.Shape_PnlTaikyoku.SetSyuturyokuKirikae(SyuturyokuKirikae.Japanese);
                            break;
                    }

                    shogiGui.ResponseData.OutputTxt = ResponseGedanTxt.Kifu;
                };
            }

            //----------
            // [▲]～[打]符号ボタン
            //----------
            {
                string[] buttonNames = new string[]{
                        "BtnFugo_Sente"// [▲]～[打]符号ボタン
                        ,"BtnFugo_Gote"
                        ,"BtnFugo_1"
                        ,"BtnFugo_2"
                        ,"BtnFugo_3"
                        ,"BtnFugo_4"
                        ,"BtnFugo_5"
                        ,"BtnFugo_6"
                        ,"BtnFugo_7"
                        ,"BtnFugo_8"
                        ,"BtnFugo_9"
                        ,"BtnFugo_Dou"
                        ,"BtnFugo_Fu"
                        ,"BtnFugo_Hisya"
                        ,"BtnFugo_Kaku"
                        ,"BtnFugo_Kyo"
                        ,"BtnFugo_Kei"
                        ,"BtnFugo_Gin"
                        ,"BtnFugo_Kin"
                        ,"BtnFugo_Oh"
                        ,"BtnFugo_Gyoku"
                        ,"BtnFugo_Tokin"
                        ,"BtnFugo_Narikyo"
                        ,"BtnFugo_Narikei"
                        ,"BtnFugo_Narigin"
                        ,"BtnFugo_Ryu"
                        ,"BtnFugo_Uma"
                        ,"BtnFugo_Yoru"
                        ,"BtnFugo_Hiku"
                        ,"BtnFugo_Agaru"
                        ,"BtnFugo_Migi"
                        ,"BtnFugo_Hidari"
                        ,"BtnFugo_Sugu"
                        ,"BtnFugo_Nari"
                        ,"BtnFugo_Funari"
                        ,"BtnFugo_Da"
                    };

                foreach (string buttonName in buttonNames)
                {
                    UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget(buttonName);
                    widget.Delegate_MouseHitEvent = (
                        object obj_shogiGui2
                        , Shape_BtnKoma btnKoma_Selected
                        , KwErrorHandler errH2
                        ) =>
                    {
                        ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                        Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                        shogiGui.ResponseData.SetAppendInputTextString(shogiGui.Shape_PnlTaikyoku.GetWidget(buttonName).Fugo);
                    };
                }
            }


            //----------
            // [全消]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnFugo_Zenkesi");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH2
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    shogiGui.ResponseData.InputTextString = "";
                };
            }


            //----------
            // [ここから採譜]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnFugo_KokokaraSaifu");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH2
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.AssertPside(ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.CurNode,"Step3",errH2);
                    Util_KifuTree282.SetStartpos_KokokaraSaifu(ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu, Util_InServer.CurPside(ui_PnlMain.ShogiGui), errH2);
                    shogiGui.ResponseData.OutputTxt = ResponseGedanTxt.Kifu;
                };
            }

            //----------
            // 初期配置ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnSyokihaichi");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH2
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    WidgetsLoader_KifuNarabe.Perform_SyokiHaichi( ui_PnlMain, errH2 );
                };
            }


            //----------
            // [向き]ボタン
            //----------
            {
                UserWidget widget = shogiGui1.Shape_PnlTaikyoku.GetWidget("BtnMuki");
                widget.Delegate_MouseHitEvent = (
                    object obj_shogiGui2
                    , Shape_BtnKoma btnKoma_Selected
                    , KwErrorHandler errH2
                    ) =>
                {
                    ShogiGui shogiGui = (ShogiGui)obj_shogiGui2;

                    Ui_PnlMain ui_PnlMain = ((Ui_ShogiForm1)shogiGui.OwnerForm).Ui_PnlMain1;

                    Shape_BtnKoma movedKoma = shogiGui.Shape_PnlTaikyoku.Btn_MovedKoma();

                    RO_Star koma;
                    Finger figKoma = Fingers.Error_1;

                    if (null != movedKoma)
                    {
                        //>>>>> 移動直後の駒があるとき
                        koma = Util_Koma.AsKoma(ui_PnlMain.ShogiGui.Model_PnlTaikyoku.GuiSkyConst.StarlightIndexOf(movedKoma.Finger).Now);
                        figKoma = movedKoma.Finger;
                    }
                    else if (null != btnKoma_Selected)
                    {
                        //>>>>> 選択されている駒があるとき
                        koma = Util_Koma.AsKoma(ui_PnlMain.ShogiGui.Model_PnlTaikyoku.GuiSkyConst.StarlightIndexOf(btnKoma_Selected.Koma).Now);
                        figKoma = btnKoma_Selected.Koma;
                    }
                    else
                    {
                        koma = null;
                    }

                    if (null != koma)
                    {
                        KifuNode modifyNode = new KifuNodeImpl(
                            ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.CurNode.Key,//現在の局面を流用
                            new KyokumenWrapper(
                                SkyConst.NewInstance_OverwriteOrAdd_Light(
                                    ui_PnlMain.ShogiGui.Model_PnlTaikyoku.GuiSkyConst,
                                    -1,//そのまま
                                    figKoma,
                                    new RO_Starlight(
                                        new RO_Star(
                                            Conv_Playerside.Reverse(koma.Pside),//向きを逆さにします。
                                            koma.Masu,
                                            koma.Komasyurui
                                        )
                                    )
                                )
                            )
                        );
                        // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
                        // ここで局面データを変更します。
                        // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
                        ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.AssertPside(modifyNode, "Step3", errH2);
                        Util_InServer.SetCurNode_Srv(ui_PnlMain.ShogiGui, modifyNode);
                        ui_PnlMain.ShogiGui.ResponseData.ToRedraw();
                    }
                };
            }
        }

        /// <summary>
        /// [初期配置]ボタン
        /// </summary>
        public static void Perform_SyokiHaichi(
            Ui_PnlMain ui_PnlMain,
            KwErrorHandler errH
            )
        {
            ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.Clear();// 棋譜を空っぽにします。
            ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.SetProperty(Word_KifuTree.PropName_Startpos, "startpos");//平手の初期局面
            Playerside firstPside = Playerside.P1;//Util_Playerside.Reverse(((KifuNode)ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.CurNode).Tebanside)
            //ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.SetProperty(Word_KifuTree.PropName_FirstPside, firstPside);

            KifuNode newNode = new KifuNodeImpl(
                                        Util_Sky258A.NULL_OBJECT_SASITE,//ルートなので
                                        new KyokumenWrapper(Util_SkyWriter.New_Hirate(firstPside))//[初期配置]ボタン押下時
                                        );

            // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
            // ここで棋譜の変更をします。
            // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
            Util_InServer.SetCurNode_Srv(ui_PnlMain.ShogiGui, newNode);
            ui_PnlMain.ShogiGui.Model_PnlTaikyoku.Kifu.AssertPside(newNode,"Perform_SyokiHaichi",errH);
            ui_PnlMain.ShogiGui.ResponseData.ToRedraw();

            ui_PnlMain.ShogiGui.ResponseData.RedrawStarlights();// 駒の再描画要求
            ui_PnlMain.ShogiGui.ResponseData.OutputTxt = ResponseGedanTxt.Clear;
            ui_PnlMain.ShogiGui.ResponseData.ToRedraw();
        }

        /// <summary>
        /// 成る／成らない
        /// </summary>
        /// <param name="shogiGui"></param>
        /// <param name="btnTumandeiruKoma"></param>
        /// <param name="errH"></param>
        private void After_NaruNaranai(
            ShogiGui shogiGui
            , Shape_BtnKoma btnTumandeiruKoma
            , KwErrorHandler errH
        )
        {

            // 駒を動かします。
            {
                // GuiからServerへ渡す情報
                Komasyurui14 syurui;
                Starlight dst;
                Util_InGui.Komamove1a_49Gui(out syurui, out dst, btnTumandeiruKoma, shogiGui.Shape_PnlTaikyoku.NaruBtnMasu, shogiGui);

                // ServerからGuiへ渡す情報
                bool torareruKomaAri;
                RO_Star koma_Food_after;
                Util_InServer.Komamove1a_50Srv(out torareruKomaAri, out koma_Food_after, dst, btnTumandeiruKoma.Koma, Util_Koma.AsKoma(dst.Now), shogiGui, errH);

                Util_InGui.Komamove1a_51Gui(torareruKomaAri, koma_Food_after, shogiGui);
            }

            {
                //----------
                // 移動済表示
                //----------
                shogiGui.Shape_PnlTaikyoku.SetHMovedKoma(btnTumandeiruKoma.Finger);

                //------------------------------
                // 棋譜に符号を追加（マウスボタンが放されたとき）TODO:まだ早い。駒が成るかもしれない。
                //------------------------------
                // 棋譜

                Starbeamable sasite = new RO_Starbeam(
                    //btnTumandeiruKoma.Finger,
                    shogiGui.Shape_PnlTaikyoku.MouseStarlightOrNull2.Now,

                    shogiGui.Model_PnlTaikyoku.GuiSkyConst.StarlightIndexOf(btnTumandeiruKoma.Finger).Now,

                    shogiGui.Shape_PnlTaikyoku.MousePos_FoodKoma != null ? shogiGui.Shape_PnlTaikyoku.MousePos_FoodKoma.Komasyurui : Komasyurui14.H00_Null___
                    );// 選択している駒の元の場所と、移動先


                {
                    //
                    // 成ったので、指し手データ差替え。
                    //
                    StartposImporter.Assert_HirateHonsyogi(new SkyBuffer(shogiGui.Model_PnlTaikyoku.GuiSkyConst), "newNode作成前");
                    KifuNode newNode = new KifuNodeImpl(
                        sasite,
                        new KyokumenWrapper(SkyConst.NewInstance_ReversePside(// 先後を反転させます。
                            shogiGui.Model_PnlTaikyoku.GuiSkyConst,
                            shogiGui.Model_PnlTaikyoku.GuiSkyConst.Temezumi + 1//１手進める
                            ))
                    );
                    StartposImporter.Assert_HirateHonsyogi(new SkyBuffer(newNode.Value.ToKyokumenConst), "newNode作成後");


                    //「成る／成らない」ボタンを押したときです。
                    ((KifuNode)shogiGui.Model_PnlTaikyoku.Kifu.CurNode).PutTuginoitte_New(newNode);
                    shogiGui.Model_PnlTaikyoku.Kifu.AssertPside(newNode,"After_NaruNaranai",errH);

                    // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
                    // ここで棋譜の変更をします。
                    // ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
                    Util_InServer.SetCurNode_Srv(shogiGui, newNode);
                    shogiGui.ResponseData.ToRedraw();
                }


                //------------------------------
                // 符号表示
                //------------------------------
                RO_Star koma = Util_Koma.AsKoma(sasite.LongTimeAgo);

                JsaFugoImpl fugoJ;
                fugoJ = Array_JsaFugoCreator15.ItemMethods[(int)Util_Komahaiyaku184.Syurui(koma.Haiyaku)](sasite, new KyokumenWrapper(shogiGui.Model_PnlTaikyoku.GuiSkyConst), errH);//「▲２二角成」なら、馬（dst）ではなくて角（src）。

                shogiGui.Shape_PnlTaikyoku.SetFugo(Util_Translator_JsaFugo.ToString_UseDou( fugoJ,
                    shogiGui.Model_PnlTaikyoku.Kifu.CurNode
                    ));


                //------------------------------
                // チェンジターン
                //------------------------------
                if (!shogiGui.Shape_PnlTaikyoku.Requested_NaruDialogToShow)
                {
                    //System.C onsole.WriteLine("マウス左ボタンを押したのでチェンジターンします。");
                    shogiGui.ChangeTurn(errH);
                }
            }


            shogiGui.ResponseData.RedrawStarlights();// 駒の再描画要求

            //System.C onsole.WriteLine("つまんでいる駒を放します。(6)");
            shogiGui.Shape_PnlTaikyoku.SetFigTumandeiruKoma(-1);//駒を放した扱いです。

            shogiGui.Shape_PnlTaikyoku.SetNaruMasu(null);

            shogiGui.ResponseData.OutputTxt = ResponseGedanTxt.Kifu;
            shogiGui.ResponseData.ToRedraw();

            Starbeamable last;
            {
                Node<Starbeamable, KyokumenWrapper> kifuElement = shogiGui.Model_PnlTaikyoku.Kifu.CurNode;

                last = (Starbeamable)kifuElement.Key;
            }
            shogiGui.ChangeTurn(errH);//マウス左ボタンを押したのでチェンジターンします。

            shogiGui.Shape_PnlTaikyoku.Request_NaruDialogToShow(false);
            shogiGui.Shape_PnlTaikyoku.GetWidget("BtnNaru").Visible = false;
            shogiGui.Shape_PnlTaikyoku.GetWidget("BtnNaranai").Visible = false;
            shogiGui.SetScene(SceneName.SceneB_1TumamitaiKoma);
        }

    }
}
