﻿using Grayscale.P163_KifuCsa____.L___250_Struct;
using Grayscale.P163_KifuCsa____.L250____Struct;
using Grayscale.P505_Atama_Unou_.L___250_Unou;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P505_Atama_Unou_.L510____UtilFvFormat;
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace Grayscale.P720_FvWriter___
{
    public partial class Uc_Main : UserControl
    {

        public Uc_Main()
        {
            InitializeComponent();
        }

        private void btnWriter_Click(object sender, EventArgs e)
        {
            /*
            string filepath = Application.StartupPath + "\\サンプルfv_bin.csv";

            FeatureVector fv = new FeatureVectorImpl();
            //fv.Make_Random();
            //fv.Make_FromFile(filepath);


            File.WriteAllText(filepath, Util_FeatureVectorWriter.Format_Text(fv));
            MessageBox.Show("サンプルファイルを書き出しました。\n"+
                "filepath=[" + filepath + "]");
             */
        }

        private void btnMakeRandom_Click(object sender, EventArgs e)
        {
            //string filepath = Application.StartupPath + "../../Data/fv.csv";
            string filepath = Application.StartupPath + "/../../Data/fv.csv";

            FeatureVector fv = new FeatureVectorImpl();
            fv.Make_Random();

            File.WriteAllText(filepath, Util_FeatureVectorFormat.Format_Text(fv));
            MessageBox.Show("サンプルファイルを書き出しました。\n" +
                "filepath=[" + filepath + "]");
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            string filepathR = Application.StartupPath + "/../../Data/fv.csv";
            string filepathR_KK = Application.StartupPath + "/../../Data/fv_KK.csv";
            string filepathW = Application.StartupPath + "/../../Data/fv_2.csv";

            FeatureVector fv = new FeatureVectorImpl();

            if (fv.Make_FromFile(filepathR))
            {
            }

            if (fv.Make_FromFile_KK(filepathR_KK))
            {
            }

            File.WriteAllText(filepathW, Util_FeatureVectorFormat.Format_Text(fv));

#if DEBUG
            MessageBox.Show("FVファイルを読み込んで、書き出しました。\n" +
                "readFilepath=["+filepathR+"]"+
                "writeFilepath=[" + filepathW + "]");
#endif
        }

        /// <summary>
        /// 棋譜読込み
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnReadKifu_Click(object sender, EventArgs e)
        {
            if (!File.Exists(this.txtKifuFilepath.Text))
            {
                goto gt_EndMethod;
            }


            CsaKifu csaKifu = Util_Csa.ReadFile(this.txtKifuFilepath.Text);

            StringBuilder sb = new StringBuilder();
            List<CsaKifuSasite> sasiteList = csaKifu.SasiteList;
            foreach(CsaKifuSasite csaSasite in sasiteList)
            {
                sb.Append(csaSasite.OptionTemezumi);
                sb.Append("手目 ");
                sb.Append(csaSasite.DestinationMasu);
                sb.Append(" ");
                sb.Append(csaSasite.Second);
                sb.Append(" ");
                sb.Append(csaSasite.Sengo);
                sb.Append(" ");
                sb.Append(csaSasite.SourceMasu);
                sb.Append(" ");
                sb.Append(csaSasite.Syurui);
                sb.AppendLine();
            }
            this.txtSasiteList.Text = sb.ToString();

        gt_EndMethod:
            ;
        }

        /// <summary>
        /// 「ゼロクリアーでファイル作成」（タイアド・ベクター）
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnMakeZero_Tv_Click(object sender, EventArgs e)
        {
            string filepath = Application.StartupPath + "/../../Data/tv.csv";
            MessageBox.Show("準備。\n" +
                "filepath=[" + filepath + "]");

            TiredVector tv = new TiredVectorImpl();
            tv.Make_Zero();

            File.WriteAllText(filepath, Util_TiredVectorFormat.Format_Text(tv));
            MessageBox.Show("サンプルファイルを書き出しました。\n" +
                "filepath=[" + filepath + "]");
        }

        /// <summary>
        /// リザルト・ベクターを０クリアーで作成
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCreateRv0Clear_Click(object sender, EventArgs e)
        {
            string filepath = Application.StartupPath + "/../../Data/rv.csv";
            MessageBox.Show("準備。\n" +
                "filepath=[" + filepath + "]");

            ResultVector rv = new ResultVectorImpl();
            rv.Make_Zero();

            File.WriteAllText(filepath, Util_ResultVectorFormat.Format_Text(rv));
            MessageBox.Show("サンプルファイルを書き出しました。\n" +
                "filepath=[" + filepath + "]");
        }

        /// <summary>
        /// 表変形fv_KK 書き出し（旧Fvから）
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn_HyoHenkeiFvKK_Click(object sender, EventArgs e)
        {
            string filepathR = Application.StartupPath + "/../../Data/fv.csv";
            string filepathW = Application.StartupPath + "/../../Data/fv_KK.csv";

            FeatureVector fv = new FeatureVectorImpl();
            fv.Make_FromFile(filepathR);

            File.WriteAllText(filepathW, Util_FeatureVectorFormat.Format_KK(fv));
            MessageBox.Show("サンプルファイルを書き出しました。\n" +
                "filepath=[" + filepathW + "]");

        }


    }
}
