﻿using Grayscale.P321_KyokumHyoka.L___250_Struct;
using System;
using System.Text;

namespace Grayscale.P743_FvLearn____.L250____Learn
{
    /// <summary>
    /// 合法手リストのアイテム。
    /// </summary>
    public class GohosyuListItem
    {

        /// <summary>
        /// 合法手の連番。
        /// </summary>
        public int Count { get { return this.count; } }
        private int count;

        /// <summary>
        /// SFEN符号
        /// </summary>
        public string Sfen { get { return this.sfen; } }
        private string sfen;

        /// <summary>
        /// JSAの指し手符号
        /// </summary>
        public string JsaSasiteStr { get { return this.jsaSasiteStr; } }
        private string jsaSasiteStr;

        /// <summary>
        /// 評価明細の項目
        /// </summary>
        public KyHyokaMeisai_Koumoku MeisaiKoumoku { get { return this.meisaiKoumoku; } }
        private KyHyokaMeisai_Koumoku meisaiKoumoku;

        public GohosyuListItem(int count, string sfen, string jsaSasiteStr, KyHyokaMeisai_Koumoku meisaiKoumoku)
        {
            this.count = count;
            this.sfen = sfen;
            this.jsaSasiteStr = jsaSasiteStr;
            this.meisaiKoumoku = meisaiKoumoku;
        }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("(");
            sb.Append(String.Format("{0,3}", this.Count));
            sb.Append(")");

            // 日本将棋連盟式の指し手の符号表示は全角。「▲５三銀右不成」の７文字幅を最大と想定。
            sb.Append(this.JsaSasiteStr);
            switch (this.JsaSasiteStr.Length)
            {
                case 4: sb.Append("　　　"); break;
                case 5: sb.Append("　　"); break;
                //case 6: sb.Append("　"); break;
            }
            sb.Append("　");
            sb.Append(String.Format("{0,5}", this.Sfen));

            // ここに、二駒関係の評価値を出したい。
            sb.Append("　");
            sb.Append(this.MeisaiKoumoku.Score.ToString());
#if DEBUG
            sb.Append("　");
            sb.Append(this.MeisaiKoumoku.Utiwake);
#endif

            return sb.ToString();
        }

    }
}
