﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P153_KifuSfen___.L___250_Report;
using Grayscale.P157_SfenReport_.L500____Struct;
using Grayscale.P158_LogKyokuPng.L500____Util;
using Grayscale.P163_KifuCsa____.L___250_Struct;
using Grayscale.P163_KifuCsa____.L250____Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P213_Komasyurui_.L500____Util;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P236_KomahaiyaTr.L500____Table;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P248_Michi______.L500____Word;
using Grayscale.P250_KomahaiyaEx.L500____Util;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P268_ConvWords__.L500____Converter;
using Grayscale.P270_ForcePromot.L250____Struct;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L250____Struct;
using Grayscale.P322_KifuTree___.L500____Util;
using Grayscale.P341_Ittesasu___.L___250_OperationA;
using Grayscale.P341_Ittesasu___.L250____OperationA;
using Grayscale.P341_Ittesasu___.L500____UtilA;
using Grayscale.P375_TansaFukasa.L500____Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P505_Atama_Unou_.L___250_Unou;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___250_KyHandanOrder;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P507_Atama______.L500____KyHandan;
using Grayscale.P511_KifuWarabe_.L020____Kokoro;
using Grayscale.P743_FvLearn____.L___250_Learn;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Windows.Forms;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P743_FvLearn____.L250____Learn
{
    /// <summary>
    /// 学習用フォーム。
    /// </summary>
    public class LearningFormImpl : LearningForm
    {

        public static ReportEnvironment REPORT_ENVIRONMENT;
        static LearningFormImpl()
        {
            LearningFormImpl.REPORT_ENVIRONMENT = new ReportEnvironmentImpl(
                        "../../Logs/", //"../../Logs/局面画像ﾛｸﾞ/",//argsDic["outFolder"],
                        "../../Data/img/gkLog/",//argsDic["imgFolder"],
                        "koma1.png",//argsDic["kmFile"],
                        "suji1.png",//argsDic["sjFile"],
                        "20",//argsDic["kmW"],
                        "20",//argsDic["kmH"],
                        "8",//argsDic["sjW"],
                        "12"//argsDic["sjH"]
                        );
        }

        private CsaKifu CsaKifu { get; set; }

        public KifuTree Kifu { get; set; }

        /// <summary>
        /// フィーチャー・ベクター。
        /// </summary>
        public FeatureVector Fv { get; set; }

        /// <summary>
        /// タイアド・ベクター。
        /// </summary>
        public TiredVector Tv { get; set; }

        /// <summary>
        /// リザルト・ベクター。
        /// </summary>
        public ResultVector Rv { get; set; }

        public LearningFormImpl()
        {
            this.Fv = new FeatureVectorImpl();
            this.Tv = new TiredVectorImpl();
            this.Rv = new ResultVectorImpl();
        }

        /// <summary>
        /// 初期設定。
        /// </summary>
        public void AtBegin(Uc_Main uc_Main)
        {
            // データの読取「道」
            if (Michi187Array.Load("../../Data/data_michi187.csv"))
            {
            }

            // データの読取「配役」
            Util_Array_KomahaiyakuEx184.Load("../../Data/data_haiyaku185_UTF-8.csv", Encoding.UTF8);

            // データの読取「強制転成表」　※駒配役を生成した後で。
            Array_ForcePromotion.Load("../../Data/data_forcePromotion_UTF-8.csv", Encoding.UTF8);
            File.WriteAllText("../../Logs/_log_強制転成表.html", Array_ForcePromotion.LogHtml());

            // データの読取「配役転換表」
            Data_KomahaiyakuTransition.Load("../../Data/data_syuruiToHaiyaku.csv", Encoding.UTF8);
            File.WriteAllText("../../Logs/_log_配役転換表.html", Data_KomahaiyakuTransition.LogHtml());

            // fv.csvファイルへのパス。
            uc_Main.TxtFvFilepath.Text = Path.GetFullPath("../../Data/fv.csv");
            uc_Main.TxtStatus1.Text = "開くボタンで開いてください。";
        }

        /// <summary>
        /// 棋譜ツリーを準備します。
        /// </summary>
        public void CreateKifuTree(Uc_Main uc_Main)
        {
            //
            // 棋譜
            //
            Playerside firstPside = Playerside.P1;
            this.Kifu = new KifuTreeImpl(
                    new KifuNodeImpl(
                        Util_Sky258A.NULL_OBJECT_SASITE,
                        new KyokumenWrapper( SkyConst.NewInstance(
                            Util_SkyWriter.New_Hirate(firstPside),
                            0//初期局面なので、0手目済み。
                            ))// きふわらべ起動時 // FIXME:平手とは限らないが。
                    )
            );
            //this.Kifu.SetProperty(Word_KifuTree.PropName_FirstPside, firstPside);
            this.Kifu.AssertPside(this.Kifu.CurNode,"CreateKifuTree",OwataMinister.LEARNER);
            this.Kifu.SetProperty(Word_KifuTree.PropName_Startpos, "startpos");// 平手 // FIXME:平手とは限らないが。

            Debug.Assert(!Util_MasuNum.OnKomabukuro(
                Util_Masu10.AsMasuNumber(((RO_Star)this.Kifu.CurNode.Value.ToKyokumenConst.StarlightIndexOf((Finger)0).Now).Masu)
                ), "駒が駒袋にあった。");
        }

        /// <summary>
        /// 合法手リストの表示
        /// </summary>
        /// <param name="uc_Main"></param>
        public void ShowGohosyu(Uc_Main uc_Main, KwErrorHandler errH)
        {
            uc_Main.TxtTemezumi.Text = this.Kifu.CurNode.Value.ToKyokumenConst.Temezumi.ToString();

            {
                // 合法手の数
                uc_Main.TxtGohosyuTe.Text = ((KifuNode)this.Kifu.CurNode).Count_ChildNodes.ToString();// "?";

                //----------------------------------------
                // 合法手のリストを作成
                //----------------------------------------
                List<GohosyuListItem> list = new List<GohosyuListItem>();
                uc_Main.LstGohosyu.Items.Clear();
                int itemNumber = 0;
                ((KifuNode)this.Kifu.CurNode).Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> node, ref bool toBreak) =>
                {
                    GohosyuListItem item = new GohosyuListItem(
                        itemNumber,
                        key,
                        Conv_Node322.ToSasite(node, node.Value, errH),
                        this.Evaluate((KifuNode)node)
                        );
                    list.Add(item);

                    itemNumber++;
                });

                //----------------------------------------
                // ソート
                //----------------------------------------
                //
                // 先手は正の数、後手は負の数で、絶対値の高いもの順。
                list.Sort((GohosyuListItem a, GohosyuListItem b) =>
                {
                    int result;
                    switch (this.Kifu.CurNode.Value.ToKyokumenConst.KaisiPside)
                    {
                        case Playerside.P1: result = (int)(b.MeisaiKoumoku.Score - a.MeisaiKoumoku.Score); break;
                        case Playerside.P2: result = (int)(a.MeisaiKoumoku.Score - b.MeisaiKoumoku.Score); break;
                        default: result = 0; break;
                    }
                    return result;
                });
                foreach (GohosyuListItem item in list)
                {
                    uc_Main.LstGohosyu.Items.Add(item);
                }
            }

            //
            // 画像を更新。
            //
            uc_Main.PctKyokumen.Image = null;//掴んでいる画像ファイルを放します。
            this.WritePng(OwataMinister.LEARNER);
            uc_Main.PctKyokumen.ImageLocation = "../../Logs/_log_学習局面.png";
        }

        /// <summary>
        /// 棋譜読込み。
        /// </summary>
        public void ReadKifu(Uc_Main uc_Main)
        {

            if (!File.Exists(uc_Main.TxtKifuFilepath.Text))
            {
                goto gt_EndMethod;
            }


            // CSA棋譜テキスト→対訳→データ
            this.CsaKifu = Util_Csa.ReadFile(uc_Main.TxtKifuFilepath.Text);


        gt_EndMethod:
            ;
        }

        /// <summary>
        /// 指し手一覧を、リストボックスに表示します。
        /// </summary>
        /// <param name="uc_Main"></param>
        public void ShowSasiteList(
            Uc_Main uc_Main,
            KwErrorHandler errH
            )
        {
            //
            // まず、リストを空っぽにします。
            //
            uc_Main.LstSasite.Items.Clear();

            Playerside firstPside = Playerside.P1;
            KifuTree kifu1 = new KifuTreeImpl(
                new KifuNodeImpl(
                    Util_Sky258A.NULL_OBJECT_SASITE,
                    new KyokumenWrapper( SkyConst.NewInstance(
                        Util_SkyWriter.New_Hirate(firstPside),
                        0//初期局面は 0手済み。
                        ))//日本の符号読取時
                )
            );
            kifu1.AssertPside(kifu1.CurNode, "ShowSasiteList",errH);

            List<CsaKifuSasite> sasiteList = this.CsaKifu.SasiteList;
            foreach (CsaKifuSasite csaSasite in sasiteList)
            {
                // 開始局面
                SkyConst kaisi_Sky = kifu1.CurNode.Value.ToKyokumenConst;

                //
                // csaSasite を データ指し手 に変換するには？
                //
                Starbeamable nextSasite;
                {
                    Playerside pside = Util_CsaSasite.ToPside(csaSasite);

                    // 元位置
                    SyElement srcMasu = Util_CsaSasite.ToSrcMasu(csaSasite);
                    Finger figSrcKoma;
                    if (srcMasu == Masu_Honshogi.Error)// 駒台の "00" かも。
                    {
                        //駒台の駒。
                        Komasyurui14 utuKomasyurui = Util_Komasyurui14.NarazuCaseHandle(Util_CsaSasite.ToKomasyurui(csaSasite));// 打つ駒の種類。

                        Okiba komadai;
                        switch (pside)
                        {
                            case Playerside.P1: komadai = Okiba.Sente_Komadai; break;
                            case Playerside.P2: komadai = Okiba.Gote_Komadai; break;
                            default: komadai = Okiba.Empty; break;
                        }

                        figSrcKoma = Util_Sky_FingersQuery.InOkibaPsideKomasyuruiNow(kaisi_Sky, komadai, pside, utuKomasyurui).ToFirst();
                    }
                    else
                    {
                        // 盤上の駒。
                        figSrcKoma = Util_Sky_FingerQuery.InMasuNow(kaisi_Sky, pside, srcMasu, errH);
                    }
                    RO_Star srcKoma = Util_Koma.AsKoma(kaisi_Sky.StarlightIndexOf(figSrcKoma).Now);

                    // 先位置
                    SyElement dstMasu = Util_CsaSasite.ToDstMasu(csaSasite);
                    Finger figFoodKoma = Util_Sky_FingerQuery.InShogibanMasuNow(kaisi_Sky, pside, dstMasu, errH);
                    Komasyurui14 foodKomasyurui;
                    if (figFoodKoma == Fingers.Error_1)
                    {
                        // 駒のない枡
                        foodKomasyurui = Komasyurui14.H00_Null___;//取った駒無し。
                    }
                    else
                    {
                        // 駒のある枡
                        foodKomasyurui = Util_Koma.AsKoma(kaisi_Sky.StarlightIndexOf(figFoodKoma).Now).Komasyurui;//取った駒有り。
                    }
                    Starlightable dstKoma = new RO_Star(
                        pside,
                        dstMasu,
                        Util_CsaSasite.ToKomasyurui(csaSasite)
                    );

                    nextSasite = new RO_Starbeam(
                        srcKoma,// 移動元
                        dstKoma,// 移動先
                        foodKomasyurui////取った駒
                    );
                }

                {
                    //----------------------------------------
                    // 一手指したい。
                    //----------------------------------------
                    //
                    //↓↓一手指し
                    IttesasuResult ittesasuResult;
                    Util_IttesasuRoutine.Before1(
                        new IttesasuArgImpl(
                            kifu1.CurNode.Value,
                            ((KifuNode)kifu1.CurNode).Value.ToKyokumenConst.KaisiPside,
                            nextSasite,
                            kifu1.CurNode.Value.ToKyokumenConst.Temezumi + 1//1手進める
                        ),
                        out ittesasuResult,
                        //kifu1,//診断用
                        errH
                    );
                    Debug.Assert(ittesasuResult.Get_SyuryoNode_OrNull != null, "ittesasuResult.Get_SyuryoNode_OrNull がヌル☆？！");
                    Util_IttesasuRoutine.Before2(
                        ref ittesasuResult,
                        errH
                    );
                    //
                    //次ノートを追加します。次ノードを、これからのカレントとします。
                    //
                    kifu1.AssertChildPside(kifu1.CurNode.Value.ToKyokumenConst.KaisiPside, ittesasuResult.Get_SyuryoNode_OrNull.Value.ToKyokumenConst.KaisiPside);
                    Util_IttesasuRoutine.After3_ChangeCurrent(
                        kifu1,
                        Conv_Sasite307.ToSfenFugo(ittesasuResult.Get_SyuryoNode_OrNull.Key),// nextSasiteStr,
                        ittesasuResult.Get_SyuryoNode_OrNull,
                        errH
                        );
                    // これで、棋譜ツリーに、構造変更があったはず。
                    //↑↑一手指し
                }


                string sfen;
                if (kifu1.CurNode.IsRoot())
                {
                    sfen = Util_CsaSasite.ToSfen(csaSasite, null);
                }
                else
                {
                    sfen = Util_CsaSasite.ToSfen(csaSasite, kifu1.CurNode.GetParentNode().Value.ToKyokumenConst);
                }
                SasiteListItemImpl listItem = new SasiteListItemImpl(csaSasite, sfen);
                uc_Main.LstSasite.Items.Add(listItem);
            }

            //----------------------------------------
            // ソート
            //----------------------------------------
            //List<SasiteListItemImpl> list = new List<SasiteListItemImpl>();
            //list.Sort((SasiteListItemImpl a, SasiteListItemImpl b) =>
            //{
            //    return a - b;
            //});
        }

        public void ReadFv()
        {
            string filepathR = Application.StartupPath + "/../../Data/fv.csv";
            string filepathR_KK = Application.StartupPath + "/../../Data/fv_KK.csv";
            //string filepathFv = Application.StartupPath + "../../Data/fv.csv";
            FeatureVector fv = new FeatureVectorImpl();

            if (fv.Make_FromFile(filepathR))
            {
            }

            if (fv.Make_FromFile(filepathR_KK))
            {
            }
        }

        public void WriteFv()
        {
        }

        /// <summary>
        /// [一手指す]ボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void OnIttesasuBtnClick(Uc_Main uc_Main, KwErrorHandler errH)
        {
            Stopwatch sw1 = new Stopwatch();
            sw1.Start();

            //
            // リストの先頭の項目を取得したい。
            //
            if (uc_Main.LstSasite.Items.Count < 1)
            {
                goto gt_EndMethod;
            }

            // リストボックスの先頭から指し手をSFEN形式で１つ取得。
            SasiteListItemImpl item = (SasiteListItemImpl)uc_Main.LstSasite.Items[0];
            string sfen = item.Sfen;
            if (null != errH.Dlgt_OnLog1Append_or_Null)
            {
                errH.Dlgt_OnLog1Append_or_Null("sfen=" + sfen + Environment.NewLine);
            }
               
            //
            // 現局面の合法手は、既に読んであるとします。（棋譜ツリーのNextNodesが既に設定されていること）
            //


            //
            // 合法手の一覧は既に作成されているものとします。
            // 次の手に進みます。
            //
            Starbeamable nextSasite;
            {
                if (this.Kifu.CurNode.HasChildNode(sfen))
                {
                    Node<Starbeamable, KyokumenWrapper> nextNode = this.Kifu.CurNode.GetChildNode(sfen);
                    nextSasite = nextNode.Key;//次の棋譜ノードのキーが、指し手（きふわらべ式）になっています。
                    
                }
                else
                {
                    nextSasite = null;
                    Debug.Fail("指し手[" + sfen + "]はありませんでした。\n" + this.DumpToAllGohosyu(this.Kifu.CurNode.Value.ToKyokumenConst));
                }
            }

            //----------------------------------------
            // 一手指したい。
            //----------------------------------------
            //↓↓一手指し
            IttesasuResult ittesasuResult;
            Util_IttesasuRoutine.Before1(
                new IttesasuArgImpl(
                    this.Kifu.CurNode.Value,
                    ((KifuNode)this.Kifu.CurNode).Value.ToKyokumenConst.KaisiPside,
                    nextSasite,
                    this.Kifu.CurNode.Value.ToKyokumenConst.Temezumi + 1//1手進める
                ),
                out ittesasuResult,
                //this.Kifu,//診断用
                errH
            );
            Debug.Assert(ittesasuResult.Get_SyuryoNode_OrNull != null, "ittesasuResult.Get_SyuryoNode_OrNull がヌル☆？！");
            Util_IttesasuRoutine.Before2(
                ref ittesasuResult,
                errH
            );
            //
            //次ノートを追加します。次ノードを、これからのカレントとします。
            //
            this.Kifu.AssertChildPside(this.Kifu.CurNode.Value.ToKyokumenConst.KaisiPside, ittesasuResult.Get_SyuryoNode_OrNull.Value.ToKyokumenConst.KaisiPside);
            Util_IttesasuRoutine.After3_ChangeCurrent(
                this.Kifu,
                Conv_Sasite307.ToSfenFugo(ittesasuResult.Get_SyuryoNode_OrNull.Key),
                ittesasuResult.Get_SyuryoNode_OrNull,
                errH
                );
            // これで、棋譜ツリーに、構造変更があったはず。
            //↑↑一手指し

            //----------------------------------------
            // 合法手一覧を作成したい。
            //----------------------------------------
            this.Make_GohosyuList(nextSasite, errH);

            //
            // 局面の表示を更新します。
            //
            this.ShowGohosyu(uc_Main, errH);

            //
            // リストの頭１個を除外します。
            //
            uc_Main.LstSasite.Items.RemoveAt(0);

            sw1.Stop();
            Console.WriteLine("一手指すボタン合計 = {0}", sw1.Elapsed);
            Console.WriteLine("────────────────────────────────────────");


        gt_EndMethod:
            ;
            //----------------------------------------
            // ボタン表示の回復
            //----------------------------------------
            if (0 < uc_Main.LstSasite.Items.Count)
            {
                uc_Main.BtnUpdateKyokumenHyoka.Enabled = true;//[局面評価更新]ボタン連打防止解除。
            }
        }

        /// <summary>
        /// 一手指します。
        /// </summary>
        public void Make_GohosyuList(Starbeamable sasite, KwErrorHandler errH)
        {
            //----------------------------------------
            // 合法手のNextNodesを作成します。
            //----------------------------------------
            Stopwatch sw2 = new Stopwatch();
            sw2.Start();
            this.CreateNextNodes_Gohosyu(errH);
            sw2.Stop();
            Console.WriteLine("合法手作成　　　 　= {0}", sw2.Elapsed);
            Console.WriteLine("────────────────────────────────────────");


            //
            // 内部データ
            //
            {
                if (null != errH.Dlgt_OnLog2Clear_or_Null)
                {
                    errH.Dlgt_OnLog2Clear_or_Null();
                    errH.Dlgt_OnLog2Append_or_Null(this.DumpToAllGohosyu(this.Kifu.CurNode.Value.ToKyokumenConst));
                }
            }
        }

        /// <summary>
        /// 全合法手をダンプ。
        /// </summary>
        /// <returns></returns>
        public string DumpToAllGohosyu(SkyConst src_Sky)
        {
            StringBuilder sb = new StringBuilder();
            //sb.AppendLine("--------------------");
            //sb.AppendLine("カレントノード内部データ");
            //sb.AppendLine("--------------------");
            src_Sky.Foreach_Starlights((Finger finger, Starlight light, ref bool toBreak) =>
            {
                // 番号
                sb.Append("Fig.");
                sb.Append(finger);
                sb.Append("　");

                RO_Star koma = Util_Koma.AsKoma(light.Now);

                // P1,P2
                sb.Append(koma.Pside);
                sb.Append("　");

                // 升00
                sb.Append(koma.Masu.Word);
                sb.Append("　");

                // 歩、香…
                sb.Append(Util_Komasyurui14.ToIchimoji(koma.Komasyurui));

                sb.AppendLine();
            });

            return sb.ToString();
        }

        /// <summary>
        /// 局面PNG画像書き出し。
        /// </summary>
        public void WritePng(KwErrorHandler errH)
        {
            Util_KyokumenPng_Writer.Write1(
                Conv_KifuNode.ToRO_Kyokumen1(((KifuNode)this.Kifu.CurNode), errH),
                "",//"../../Logs",
                "_log_学習局面.png",
                LearningFormImpl.REPORT_ENVIRONMENT //ShogisasiImpl.REPORT_ENVIRONMENT
                );
        }

        /// <summary>
        /// 合法手を一覧します。
        /// </summary>
        /// <param name="uc_Main"></param>
        public void CreateNextNodes_Gohosyu(KwErrorHandler errH)
        {
            try
            {
                //
                // 指し手生成ルーチンで、棋譜ツリーを作ります。
                //
                bool isHonshogi = true;
                new Tansaku_FukasaYusen_Routine().WAA_Yomu_Start(this.Kifu, isHonshogi, errH);
            }
            catch (Exception ex) { errH.DonimoNaranAkirameta(ex, "棋譜ツリーを作っていたときです。"); throw ex; }

        }

        /// <summary>
        /// 二駒関係の評価値を算出します。
        /// </summary>
        public KyHyokaMeisai_Koumoku Evaluate(KifuNode node)//(KifuNode)this.Kifu.CurNode
        {
            PlayerInfo playerInfo = new PlayerInfoImpl();
            playerInfo.Playerside = node.Value.ToKyokumenConst.KaisiPside;

            KyHandan_NikomaKankeiKkKpPp kyHandan = new KyHandan_NikomaKankeiKkKpPp();
            UnouImpl unou = new UnouImpl();
            unou.FeatureVector = this.Fv;//参照してもらうだけ。

            KyHyokaMeisai_Koumoku meisaiKoumoku;
            kyHandan.Keisan(out meisaiKoumoku,
                new KyHandanArgsImpl(
                    new TenonagareImpl(
                        null,
                        KyHandanOrderName.Default,
                        TenonagareName.NikomaKankeiKkp,
                        null,
                        null,
                        new Basho(0),
                        OwataMinister.LEARNER
                    ),
                    node,
                    unou,
                    playerInfo
                ),
                OwataMinister.LEARNER
            );

            return meisaiKoumoku;
        }

    }
}
