﻿using Grayscale.P021_ConstShogi_.L250____Const;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P212_ConvPside__.L500____Converter;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P505_Atama_Unou_.L___250_Unou;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P505_Atama_Unou_.L500____Util;
using System;
using System.Collections.Generic;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //フィンガー番号

namespace Grayscale.P743_FvLearn____.L500____Util
{
    public abstract class Util_Learning
    {
        private static double GetUp(int tired, bool isMinus)
        {
            double up;

            if (tired < 2)
            {
                up = 64.0d;
            }
            else if (tired < 4)
            {
                up = 32.0d;
            }
            else if (tired < 8)
            {
                up = 16.0d;
            }
            else if (tired < 16)
            {
                up = 12.0d;
            }
            else if (tired < 32)
            {
                up = 8.0d;
            }
            else if (tired < 64)
            {
                up = 7.0d;
            }
            else if (tired < 128)
            {
                up = 6.0d;
            }
            else if (tired < 256)
            {
                up = 5.0d;
            }
            else if (tired < 512)
            {
                up = 4.0d;
            }
            else if (tired < 1024)
            {
                up = 3.0d;
            }
            else if (tired < 2048)
            {
                up = 2.0;
            }
            else if (tired < 4096)
            {
                up = 1.0d;
            }
            else if (tired < 8192)
            {
                up = 0.75;
            }
            else if (tired < 16384)
            {
                up = 0.5;
            }
            else if (tired < 32768)
            {
                up = 0.25;
            }
            else if (tired < 65536)
            {
                up = 0.1;
            }
            else
            {
                up = 0.0078125d;
            }

            if (isMinus)//減点したいとき。
            {
                up *= -1;
            }

            return up;
        }

        /// <summary>
        /// 指定した局面の評価を、加点（減点）します。
        /// </summary>
        public static void UpdateKyokumenHyoka(
            SkyConst src_Sky,
            FeatureVector fv_ref,
            TiredVector tv,
            ResultVector rv,
            int plus_minus)
        {
            //----------------------------------------
            // [ＫＫ]　王１　×　王２
            //----------------------------------------
            {
                // 調査項目番号
                int k1 = Conv_FvKoumoku.ToKIndex_From_PsideBanjoKomasyuruiMasu(src_Sky, Playerside.P1);
                int k2 = Conv_FvKoumoku.ToKIndex_From_PsideBanjoKomasyuruiMasu(src_Sky, Playerside.P2);

                if (-1 != k1 && -1 != k2)
                {
                    //----------------------------------------
                    // よし、２駒関係だぜ☆！
                    //----------------------------------------

                    // tired値が大きいほど、数字の伸びを悪くします。
                    // FIXME: 暫定： offset値は無視します。
                    int tired = tv.NikomaKankei_KK[k1, k2];
                    double up = Util_Learning.GetUp(tired,plus_minus<0);

                    fv_ref.NikomaKankei_KK[k1, k2] += up;
                    rv.NikomaKankei_KK[k1, k2] += up;
                    tv.NikomaKankei_KK[k1, k2]++;
                }
            }

            //----------------------------------------
            // [ＫＰ]　王１　×　盤上の各駒２
            //----------------------------------------
            {
                // 調査項目番号
                int k1 = Conv_FvKoumoku.ToKIndex_From_PsideBanjoKomasyuruiMasu(src_Sky, Playerside.P1);
                if (FeatureVectorImpl.CHOSA_KOMOKU_ERROR != k1)
                {
                    //----------------------------------------
                    // さあ、２駒目はどうだぜ☆！
                    //----------------------------------------
                    src_Sky.Foreach_Starlights((Finger finger2, Starlight light2, ref bool toBreak2) =>
                    {
                        RO_Star koma2 = Util_Koma.AsKoma(light2.Now);
                        int p2 = FeatureVectorImpl.CHOSA_KOMOKU_ERROR;// 調査項目Ｐ２
                        if (Util_Masu10.GetOkiba(koma2.Masu) == Okiba.ShogiBan)// 盤上の駒
                        {
                            p2 = Conv_FvKoumoku.ToPIndex_From_PsideBanjoKomasyuruiMasu(koma2.Pside, koma2.Komasyurui, koma2.Masu);
                        }

                        if (FeatureVectorImpl.CHOSA_KOMOKU_ERROR != p2)
                        {
                            //----------------------------------------
                            // よし、２駒関係だぜ☆！
                            //----------------------------------------

                            // tired値が大きいほど、数字の伸びを悪くします。
                            // FIXME: 暫定： offset値は無視します。
                            int tired = tv.NikomaKankei_KP[k1, p2];
                            double up = Util_Learning.GetUp(tired, plus_minus < 0);

                            fv_ref.NikomaKankei_KP[k1, p2] += up;
                            rv.NikomaKankei_KP[k1, p2] += up;
                            tv.NikomaKankei_KP[k1, p2]++;
                        }
                    });
                }
            }


            //----------------------------------------
            // [ＰＰ]　盤上の各駒１　×　盤上の各駒２
            //----------------------------------------
            {
                src_Sky.Foreach_Starlights((Finger finger1, Starlight light1, ref bool toBreak1) =>
                {
                    RO_Star koma1 = Util_Koma.AsKoma(light1.Now);
                    int p1 = FeatureVectorImpl.CHOSA_KOMOKU_ERROR;// 調査項目Ｐ１
                    if (Util_Masu10.GetOkiba(koma1.Masu) == Okiba.ShogiBan)// 盤上の駒
                    {
                        p1 = Conv_FvKoumoku.ToPIndex_From_PsideBanjoKomasyuruiMasu(koma1.Pside, koma1.Komasyurui, koma1.Masu);
                    }

                    if (FeatureVectorImpl.CHOSA_KOMOKU_ERROR != p1)
                    {
                        //----------------------------------------
                        // さあ、２駒目はどうだぜ☆！
                        //----------------------------------------
                        src_Sky.Foreach_Starlights((Finger finger2, Starlight light2, ref bool toBreak2) =>
                        {
                            RO_Star koma2 = Util_Koma.AsKoma(light2.Now);
                            int p2 = FeatureVectorImpl.CHOSA_KOMOKU_ERROR;// 調査項目Ｐ２
                            if (Util_Masu10.GetOkiba(koma2.Masu) == Okiba.ShogiBan)// 盤上の駒
                            {
                                p2 = Conv_FvKoumoku.ToPIndex_From_PsideBanjoKomasyuruiMasu(koma2.Pside, koma2.Komasyurui, koma2.Masu);
                            }

                            if (FeatureVectorImpl.CHOSA_KOMOKU_ERROR != p2)
                            {
                                //----------------------------------------
                                // よし、２駒関係だぜ☆！
                                //----------------------------------------

                                // tired値が大きいほど、数字の伸びを悪くします。
                                // FIXME: 暫定： offset値は無視します。
                                int tired = tv.NikomaKankei_PP[p1, p2];
                                double up = Util_Learning.GetUp(tired, plus_minus < 0);

                                fv_ref.NikomaKankei_PP[p1, p2] += up;
                                rv.NikomaKankei_PP[p1, p2] += up;
                                tv.NikomaKankei_PP[p1, p2]++;
                            }
                        });
                    }
                });

                //----------------------------------------
                // 持ち駒
                //----------------------------------------
                foreach (Playerside pside in Array_Playerside.AllPlayers)//プレイヤー
                {
                    foreach (Komasyurui14 ks in Array_Komasyurui.MotiKoma7Syurui)//駒の種類
                    {
                        // 駒の数
                        int count = Util_Sky_FingersQuery.InOkibaKomasyuruiNow(src_Sky, Conv_Playerside.ToKomadai(pside), ks).Items.Count;//, errH
                        int chosaKomoku = Conv_FvKoumoku.ToPIndex_From_PsideMotiKomasyuruiKosu(pside, ks, count);
                    }
                }
            }
        }

        private const double HALF = 999.0d;

        /// <summary>
        /// FVを、-999.0～999.0に矯正。
        /// </summary>
        public static void Fv999_999_KK(FeatureVector fv)
        {
            //--------------------------------------------------------------------------------
            // 変換前のデータを確認。 
            //--------------------------------------------------------------------------------
            double negative_length;// 負の数の一番小さな値の絶対値。
            double positive_length;// 正の数の一番大きな値の絶対値。
            bool longest_positive; // 正の方の絶対値の方が大きければ真。
            int negative_items;//負の項目数。平均値を求めるのに使う。
            int positive_items;//正の項目数
            double negative_total;//負の合計。平均値を求めるのに使う。
            double positive_total;//正の合計。
            double zoom;
            int notZero;
            {
                //--------------------------------------------------------------------------------
                // KK
                //--------------------------------------------------------------------------------
                negative_length = 0.0d;
                positive_length = 0.0d;
                negative_items = 0;
                positive_items = 0;
                negative_total = 0.0d;
                positive_total = 0.0d;
                notZero = 0;
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
                    {
                        double value = fv.NikomaKankei_KK[k1, k2];
                        if (value < -negative_length)
                        {
                            negative_length = -value;
                        }
                        else if (positive_length < value)
                        {
                            positive_length = value;
                        }

                        if (value != 0.0d)
                        {
                            notZero++;
                        }

                        if (value < 0.0d)
                        {
                            negative_items++;
                            negative_total += value;
                        }
                        else if (0.0d < value)
                        {
                            positive_items++;
                            positive_total += value;
                        }
                    }
                }

                // 長いのは正負のどちらか。
                if (negative_length < positive_length)
                {
                    longest_positive = true;
                }
                else
                {
                    longest_positive = false;
                }
                System.Console.WriteLine("----------------------------------------");
                System.Console.WriteLine("KK");
                System.Console.WriteLine("----------------------------------------");
                System.Console.WriteLine("begin");
                System.Console.WriteLine("   negative_length =" + negative_length);
                System.Console.WriteLine("   positive_length =" + positive_length);
                System.Console.WriteLine("   longest_positive=" + longest_positive);
                System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
                System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
                System.Console.WriteLine("   notZero         =" + notZero);
                System.Console.WriteLine("----------------------------------------");
            }

            //--------------------------------------------------------------------------------
            // トポロジー的に加工します。 
            //--------------------------------------------------------------------------------
            {
                // フィーチャーベクター（ＫＫ）に入っている数字を、0に近い方順に並べます。
                // 0 は　どちらにも含めません。
                List<double> negative_numbers = new List<double>();
                List<double> positive_numbers = new List<double>();
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
                    {
                        double value = fv.NikomaKankei_KK[k1, k2];

                        if (0.0d < value)
                        {
                            positive_numbers.Add(value);
                        }
                        else if (value < 0.0d)
                        {
                            negative_numbers.Add(value);
                        }
                        else
                        {
                            // 0 は無視します。
                        }
                    }
                }

                // 0に近い方から、遠い方へ。
                positive_numbers.Sort((double a, double b) =>
                {
                    return (int)(a - b);
                });
                negative_numbers.Sort((double a, double b) =>
                {
                    return (int)(b - a);
                });

                // 置換テーブルを作成します。
                Dictionary<double, int> replaceTable = new Dictionary<double, int>();
                replaceTable.Add(0.0d, 0);

                int renumber = 1;
                foreach (double source in positive_numbers)
                {
                    if (!replaceTable.ContainsKey(source))//重複は省く
                    {
                        replaceTable.Add(source, renumber);
                        renumber++;
                    }
                }
                renumber = -1;
                foreach (double source in negative_numbers)
                {
                    if (!replaceTable.ContainsKey(source))//重複は省く
                    {
                        replaceTable.Add(source, renumber);
                        renumber--;
                    }
                }

                // 実データを全て置換します。
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
                    {
                        fv.NikomaKankei_KK[k1, k2] = replaceTable[fv.NikomaKankei_KK[k1, k2]];
                    }
                }
            }

            //--------------------------------------------------------------------------------
            // トポロジー的に加工したあとのデータを確認。 
            //--------------------------------------------------------------------------------
            {
                negative_length = 0.0d;
                positive_length = 0.0d;
                negative_items = 0;
                positive_items = 0;
                negative_total = 0.0d;
                positive_total = 0.0d;
                notZero = 0;
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
                    {
                        double value = fv.NikomaKankei_KK[k1, k2];
                        if (value < -negative_length)
                        {
                            negative_length = -value;
                        }
                        else if (positive_length < value)
                        {
                            positive_length = value;
                        }

                        if (value != 0.0d)
                        {
                            notZero++;
                        }

                        if (value < 0.0d)
                        {
                            negative_items++;
                            negative_total += value;
                        }
                        else if (0.0d < value)
                        {
                            positive_items++;
                            positive_total += value;
                        }
                    }
                }

                // 長いのは正負のどちらか。
                if (negative_length < positive_length)
                {
                    longest_positive = true;
                }
                else
                {
                    longest_positive = false;
                }
                System.Console.WriteLine("topology");
                System.Console.WriteLine("   negative_length =" + negative_length);
                System.Console.WriteLine("   positive_length =" + positive_length);
                System.Console.WriteLine("   longest_positive=" + longest_positive);
                System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
                System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
                System.Console.WriteLine("   notZero         =" + notZero);
                System.Console.WriteLine("----------------------------------------");
            }

            //----------------------------------------
            // 正負の長い方 を abs 999.0 に合わせたい。
            //----------------------------------------
            if (longest_positive)
            {
                zoom = Util_Learning.HALF / positive_length;
            }
            else
            {
                zoom = Util_Learning.HALF / negative_length;
            }

            negative_length = 0.0d;
            positive_length = 0.0d;
            negative_items = 0;
            positive_items = 0;
            negative_total = 0.0d;
            positive_total = 0.0d;
            notZero = 0;
            for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
            {
                for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
                {
                    double value = Math.Round(fv.NikomaKankei_KK[k1, k2] * zoom, 0);
                    fv.NikomaKankei_KK[k1, k2] = value;
                    if (value < -negative_length)
                    {
                        negative_length = -value;
                    }
                    else if (positive_length < value)
                    {
                        positive_length = value;
                    }

                    if (value != 0.0d)
                    {
                        notZero++;
                    }

                    if (value < 0.0d)
                    {
                        negative_items++;
                        negative_total += value;
                    }
                    else if (0.0d < value)
                    {
                        positive_items++;
                        positive_total += value;
                    }
                }
            }

            // 長いのは正負のどちらか。
            if (negative_length < positive_length)
            {
                longest_positive = true;
            }
            else
            {
                longest_positive = false;
            }
            System.Console.WriteLine("end");
            System.Console.WriteLine("   negative_length =" + negative_length);
            System.Console.WriteLine("   positive_length =" + positive_length);
            System.Console.WriteLine("   longest_positive=" + longest_positive);
            System.Console.WriteLine("   zoom            =" + zoom);
            System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
            System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
            System.Console.WriteLine("   notZero         =" + notZero);
            System.Console.WriteLine("----------------------------------------");

        }

        /// <summary>
        /// FVを、-999.0～999.0に矯正。
        /// </summary>
        public static void Fv999_999_KP(FeatureVector fv)
        {
            //--------------------------------------------------------------------------------
            // 変換前のデータを確認。 
            //--------------------------------------------------------------------------------
            double negative_length;// 負の数の一番小さな値の絶対値。
            double positive_length;// 正の数の一番大きな値の絶対値。
            bool longest_positive; // 正の方の絶対値の方が大きければ真。
            int negative_items;//負の項目数。平均値を求めるのに使う。
            int positive_items;//正の項目数
            double negative_total;//負の合計。平均値を求めるのに使う。
            double positive_total;//正の合計。
            double zoom;
            int notZero;
            {
                negative_length = 0.0d;
                positive_length = 0.0d;
                negative_items = 0;
                positive_items = 0;
                negative_total = 0.0d;
                positive_total = 0.0d;
                notZero = 0;
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        double value = fv.NikomaKankei_KP[k1, p2];
                        if (value < -negative_length)
                        {
                            negative_length = -value;
                        }
                        else if (positive_length < value)
                        {
                            positive_length = value;
                        }

                        if (value != 0.0d)
                        {
                            notZero++;
                        }

                        if (value < 0.0d)
                        {
                            negative_items++;
                            negative_total += value;
                        }
                        else if (0.0d < value)
                        {
                            positive_items++;
                            positive_total += value;
                        }
                    }
                }

                // 長いのは正負のどちらか。
                if (negative_length < positive_length)
                {
                    longest_positive = true;
                }
                else
                {
                    longest_positive = false;
                }
                System.Console.WriteLine("KP");
                System.Console.WriteLine("----------------------------------------");
                System.Console.WriteLine("begin");
                System.Console.WriteLine("   negative_length =" + negative_length);
                System.Console.WriteLine("   positive_length =" + positive_length);
                System.Console.WriteLine("   longest_positive=" + longest_positive);
                System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
                System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
                System.Console.WriteLine("   notZero         =" + notZero);
                System.Console.WriteLine("----------------------------------------");
            }

            //--------------------------------------------------------------------------------
            // トポロジー的に加工します。 
            //--------------------------------------------------------------------------------
            {
                // フィーチャーベクター（ＫＰ）に入っている数字を、0に近い方順に並べます。
                // 0 は　どちらにも含めません。
                List<double> negative_numbers = new List<double>();
                List<double> positive_numbers = new List<double>();
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        double value = fv.NikomaKankei_KP[k1, p2];

                        if (0.0d < value)
                        {
                            positive_numbers.Add(value);
                        }
                        else if (value < 0.0d)
                        {
                            negative_numbers.Add(value);
                        }
                        else
                        {
                            // 0 は無視します。
                        }
                    }
                }

                // 0に近い方から、遠い方へ。
                positive_numbers.Sort((double a, double b) =>
                {
                    return (int)(a - b);
                });
                negative_numbers.Sort((double a, double b) =>
                {
                    return (int)(b - a);
                });

                // 置換テーブルを作成します。
                Dictionary<double, int> replaceTable = new Dictionary<double, int>();
                replaceTable.Add(0.0d, 0);

                int renumber = 1;
                foreach (double source in positive_numbers)
                {
                    if (!replaceTable.ContainsKey(source))//重複は省く
                    {
                        replaceTable.Add(source, renumber);
                        renumber++;
                    }
                }
                renumber = -1;
                foreach (double source in negative_numbers)
                {
                    if (!replaceTable.ContainsKey(source))//重複は省く
                    {
                        replaceTable.Add(source, renumber);
                        renumber--;
                    }
                }

                // 実データを全て置換します。
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        fv.NikomaKankei_KP[k1, p2] = replaceTable[fv.NikomaKankei_KP[k1, p2]];
                    }
                }
            }


            //--------------------------------------------------------------------------------
            // トポロジー的に加工したあとのデータを確認。 
            //--------------------------------------------------------------------------------
            {
                negative_length = 0.0d;
                positive_length = 0.0d;
                negative_items = 0;
                positive_items = 0;
                negative_total = 0.0d;
                positive_total = 0.0d;
                notZero = 0;
                for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        double value = fv.NikomaKankei_KP[k1, p2];
                        if (value < -negative_length)
                        {
                            negative_length = -value;
                        }
                        else if (positive_length < value)
                        {
                            positive_length = value;
                        }

                        if (value != 0.0d)
                        {
                            notZero++;
                        }

                        if (value < 0.0d)
                        {
                            negative_items++;
                            negative_total += value;
                        }
                        else if (0.0d < value)
                        {
                            positive_items++;
                            positive_total += value;
                        }
                    }
                }

                // 長いのは正負のどちらか。
                if (negative_length < positive_length)
                {
                    longest_positive = true;
                }
                else
                {
                    longest_positive = false;
                }
                System.Console.WriteLine("topology");
                System.Console.WriteLine("   negative_length =" + negative_length);
                System.Console.WriteLine("   positive_length =" + positive_length);
                System.Console.WriteLine("   longest_positive=" + longest_positive);
                System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
                System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
                System.Console.WriteLine("   notZero         =" + notZero);
                System.Console.WriteLine("----------------------------------------");
            }

            //----------------------------------------
            // 正負の長い方 を abs 999.0 に合わせたい。
            //----------------------------------------
            if (longest_positive)
            {
                zoom = Util_Learning.HALF / positive_length;
            }
            else
            {
                zoom = Util_Learning.HALF / negative_length;
            }

            negative_length = 0.0d;
            positive_length = 0.0d;
            negative_items = 0;
            positive_items = 0;
            negative_total = 0.0d;
            positive_total = 0.0d;
            notZero = 0;
            for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)
            {
                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                {
                    double value = Math.Round(fv.NikomaKankei_KP[k1, p2] * zoom, 0);
                    fv.NikomaKankei_KP[k1, p2] = value;
                    if (value < -negative_length)
                    {
                        negative_length = -value;
                    }
                    else if (positive_length < value)
                    {
                        positive_length = value;
                    }

                    if (value != 0.0d)
                    {
                        notZero++;
                    }

                    if (value < 0.0d)
                    {
                        negative_items++;
                        negative_total += value;
                    }
                    else if (0.0d < value)
                    {
                        positive_items++;
                        positive_total += value;
                    }
                }
            }

            // 長いのは正負のどちらか。
            if (negative_length < positive_length)
            {
                longest_positive = true;
            }
            else
            {
                longest_positive = false;
            }
            System.Console.WriteLine("end");
            System.Console.WriteLine("   negative_length =" + negative_length);
            System.Console.WriteLine("   positive_length =" + positive_length);
            System.Console.WriteLine("   longest_positive=" + longest_positive);
            System.Console.WriteLine("   zoom            =" + zoom);
            System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
            System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
            System.Console.WriteLine("   notZero         =" + notZero);
            System.Console.WriteLine("----------------------------------------");

        }

        /// <summary>
        /// FVを、-999.0～999.0に矯正。
        /// </summary>
        public static void Fv999_999_PP(FeatureVector fv)
        {
            //--------------------------------------------------------------------------------
            // 変換前のデータを確認。 
            //--------------------------------------------------------------------------------
            double negative_length;// 負の数の一番小さな値の絶対値。
            double positive_length;// 正の数の一番大きな値の絶対値。
            bool longest_positive; // 正の方の絶対値の方が大きければ真。
            int negative_items;//負の項目数。平均値を求めるのに使う。
            int positive_items;//正の項目数
            double negative_total;//負の合計。平均値を求めるのに使う。
            double positive_total;//正の合計。
            double zoom;
            int notZero;
            {
                negative_length = 0.0d;
                positive_length = 0.0d;
                negative_items = 0;
                positive_items = 0;
                negative_total = 0.0d;
                positive_total = 0.0d;
                notZero = 0;
                for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        double value = fv.NikomaKankei_PP[p1, p2];
                        if (value < -negative_length)
                        {
                            negative_length = -value;
                        }
                        else if (positive_length < value)
                        {
                            positive_length = value;
                        }

                        if (value != 0.0d)
                        {
                            notZero++;
                        }

                        if (value < 0.0d)
                        {
                            negative_items++;
                            negative_total += value;
                        }
                        else if (0.0d < value)
                        {
                            positive_items++;
                            positive_total += value;
                        }
                    }
                }

                // 長いのは正負のどちらか。
                if (negative_length < positive_length)
                {
                    longest_positive = true;
                }
                else
                {
                    longest_positive = false;
                }
                System.Console.WriteLine("PP");
                System.Console.WriteLine("----------------------------------------");
                System.Console.WriteLine("begin");
                System.Console.WriteLine("   negative_length =" + negative_length);
                System.Console.WriteLine("   positive_length =" + positive_length);
                System.Console.WriteLine("   longest_positive=" + longest_positive);
                System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
                System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
                System.Console.WriteLine("   notZero         =" + notZero);
                System.Console.WriteLine("----------------------------------------");
            }

            //--------------------------------------------------------------------------------
            // トポロジー的に加工します。 
            //--------------------------------------------------------------------------------
            {
                // フィーチャーベクター（ＰＰ）に入っている数字を、0に近い方順に並べます。
                // 0 は　どちらにも含めません。
                List<double> negative_numbers = new List<double>();
                List<double> positive_numbers = new List<double>();
                for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        double value = fv.NikomaKankei_PP[p1, p2];

                        if (0.0d < value)
                        {
                            positive_numbers.Add(value);
                        }
                        else if (value < 0.0d)
                        {
                            negative_numbers.Add(value);
                        }
                        else
                        {
                            // 0 は無視します。
                        }
                    }
                }

                // 0に近い方から、遠い方へ。
                positive_numbers.Sort((double a, double b) =>
                {
                    return (int)(a - b);
                });
                negative_numbers.Sort((double a, double b) =>
                {
                    return (int)(b - a);
                });

                // 置換テーブルを作成します。
                Dictionary<double, int> replaceTable = new Dictionary<double, int>();
                replaceTable.Add(0.0d, 0);

                int renumber = 1;
                foreach (double source in positive_numbers)
                {
                    if (!replaceTable.ContainsKey(source))//重複は省く
                    {
                        replaceTable.Add(source, renumber);
                        renumber++;
                    }
                }
                renumber = -1;
                foreach (double source in negative_numbers)
                {
                    if (!replaceTable.ContainsKey(source))//重複は省く
                    {
                        replaceTable.Add(source, renumber);
                        renumber--;
                    }
                }

                // 実データを全て置換します。
                for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        fv.NikomaKankei_PP[p1, p2] = replaceTable[fv.NikomaKankei_PP[p1, p2]];
                    }
                }
            }

            //--------------------------------------------------------------------------------
            // トポロジー的に加工したあとのデータを確認。 
            //--------------------------------------------------------------------------------
            {
                negative_length = 0.0d;
                positive_length = 0.0d;
                negative_items = 0;
                positive_items = 0;
                negative_total = 0.0d;
                positive_total = 0.0d;
                notZero = 0;
                for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)
                {
                    for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                    {
                        double value = fv.NikomaKankei_PP[p1, p2];
                        if (value < -negative_length)
                        {
                            negative_length = -value;
                        }
                        else if (positive_length < value)
                        {
                            positive_length = value;
                        }

                        if (value != 0.0d)
                        {
                            notZero++;
                        }

                        if (value < 0.0d)
                        {
                            negative_items++;
                            negative_total += value;
                        }
                        else if (0.0d < value)
                        {
                            positive_items++;
                            positive_total += value;
                        }
                    }
                }

                // 長いのは正負のどちらか。
                if (negative_length < positive_length)
                {
                    longest_positive = true;
                }
                else
                {
                    longest_positive = false;
                }
                System.Console.WriteLine("topology");
                System.Console.WriteLine("   negative_length =" + negative_length);
                System.Console.WriteLine("   positive_length =" + positive_length);
                System.Console.WriteLine("   longest_positive=" + longest_positive);
                System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
                System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
                System.Console.WriteLine("   notZero         =" + notZero);
                System.Console.WriteLine("----------------------------------------");
            }

            //----------------------------------------
            // 正負の長い方 を abs 999.0 に合わせたい。
            //----------------------------------------
            if (longest_positive)
            {
                zoom = Util_Learning.HALF / positive_length;
            }
            else
            {
                zoom = Util_Learning.HALF / negative_length;
            }

            negative_length = 0.0d;
            positive_length = 0.0d;
            negative_items = 0;
            positive_items = 0;
            negative_total = 0.0d;
            positive_total = 0.0d;
            notZero = 0;
            for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)
            {
                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
                {
                    double value = Math.Round(fv.NikomaKankei_PP[p1, p2] * zoom, 0);
                    fv.NikomaKankei_PP[p1, p2] = value;
                    if (value < -negative_length)
                    {
                        negative_length = -value;
                    }
                    else if (positive_length < value)
                    {
                        positive_length = value;
                    }

                    if (value != 0.0d)
                    {
                        notZero++;
                    }

                    if (value < 0.0d)
                    {
                        negative_items++;
                        negative_total += value;
                    }
                    else if (0.0d < value)
                    {
                        positive_items++;
                        positive_total += value;
                    }
                }
            }

            // 長いのは正負のどちらか。
            if (negative_length < positive_length)
            {
                longest_positive = true;
            }
            else
            {
                longest_positive = false;
            }
            System.Console.WriteLine("end");
            System.Console.WriteLine("   negative_length =" + negative_length);
            System.Console.WriteLine("   positive_length =" + positive_length);
            System.Console.WriteLine("   longest_positive=" + longest_positive);
            System.Console.WriteLine("   zoom            =" + zoom);
            System.Console.WriteLine("   negative_average=" + (negative_items == 0 ? 0 : negative_total / negative_items));
            System.Console.WriteLine("   positive_average=" + (positive_items == 0 ? 0 : positive_total / positive_items));
            System.Console.WriteLine("   notZero         =" + notZero);
            System.Console.WriteLine("----------------------------------------");

        }

    }
}
