﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P505_Atama_Unou_.L___250_Unou;

namespace Grayscale.P743_FvLearn____.L___250_Learn
{

    /// <summary>
    /// 学習用フォーム。
    /// </summary>
    public interface LearningForm
    {
        KifuTree Kifu { get; set; }

        /// <summary>
        /// フィーチャー・ベクター。
        /// </summary>
        FeatureVector Fv { get; set; }

        /// <summary>
        /// タイアド・ベクター。
        /// </summary>
        TiredVector Tv { get; set; }

        /// <summary>
        /// リザルト・ベクター。
        /// </summary>
        ResultVector Rv { get; set; }

        /// <summary>
        /// 初期設定。
        /// </summary>
        void AtBegin(Uc_Main uc_Main);

        /// <summary>
        /// 棋譜ツリーを準備します。
        /// </summary>
        void CreateKifuTree(Uc_Main uc_Main);

        /// <summary>
        /// 棋譜読込み。
        /// </summary>
        void ReadKifu(Uc_Main uc_Main);

        /// <summary>
        /// [一手指す]ボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void OnIttesasuBtnClick(Uc_Main uc_Main, KwErrorHandler errH);

        /// <summary>
        /// 指し手リストを表示します。
        /// </summary>
        /// <param name="uc_Main"></param>
        void ShowSasiteList(Uc_Main uc_Main, KwErrorHandler errH);

        /// <summary>
        /// 棋譜内容の表示
        /// </summary>
        /// <param name="uc_Main"></param>
        void ShowGohosyu(Uc_Main uc_Main, KwErrorHandler errH);


        /// <summary>
        /// 局面PNG画像書き出し。
        /// </summary>
        void WritePng(KwErrorHandler errH);


        /// <summary>
        /// 合法手を一覧します。
        /// </summary>
        /// <param name="uc_Main"></param>
        void CreateNextNodes_Gohosyu( KwErrorHandler errH);

        /// <summary>
        /// 全合法手をダンプ。デバッグ用途。
        /// </summary>
        /// <returns></returns>
        string DumpToAllGohosyu(SkyConst src_Sky);

        
        /// <summary>
        /// 二駒関係の評価値を算出します。
        /// </summary>
        KyHyokaMeisai_Koumoku Evaluate(KifuNode node);

        
        /// <summary>
        /// 一手指します。
        /// </summary>
        void Make_GohosyuList( Starbeamable sasite, KwErrorHandler errH);

    }
}
