﻿using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P505_Atama_Unou_.L510____UtilFvFormat;
using Grayscale.P743_FvLearn____.L___250_Learn;
using Grayscale.P743_FvLearn____.L250____Learn;
using Grayscale.P743_FvLearn____.L500____Util;
using System;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;

namespace Grayscale.P743_FvLearn____
{
    public partial class Uc_Main : UserControl
    {

        private LearningForm LearningForm{get;set;}

        public TextBox TxtStatus1
        {
            get
            {
                return this.txtStatus1;
            }
        }

        public TextBox TxtTemezumi
        {
            get
            {
                return this.txtTemezumi;
            }
        }

        public TextBox TxtGohosyuTe
        {
            get
            {
                return this.txtGohosyuTe;
            }
        }

        public TextBox TxtKifuFilepath
        {
            get
            {
                return this.txtKifuFilepath;
            }
        }

        public TextBox TxtFvFilepath
        {
            get
            {
                return this.txtFvFilepath;
            }
        }

        public ListBox LstSasite
        {
            get
            {
                return this.lstSasite;
            }
        }

        public ListBox LstGohosyu
        {
            get
            {
                return this.lstGohosyu;
            }
        }

        public PictureBox PctKyokumen
        {
            get
            {
                return this.pctKyokumen;
            }
        }

        public Button BtnUpdateKyokumenHyoka
        {
            get
            {
                return this.btnUpdateKyokumenHyoka;
            }
        }


        public Uc_Main()
        {
            this.LearningForm = new LearningFormImpl();
            InitializeComponent();
        }

        private void btnCreateKifuTree_Click(object sender, EventArgs e)
        {
            this.LearningForm.CreateKifuTree(this);

            // 合法手を数えたい。
            this.LearningForm.CreateNextNodes_Gohosyu( OwataMinister.LEARNER);

            // 現局面を表示
            this.LearningForm.ShowGohosyu(this, OwataMinister.LEARNER);
        }

        /// <summary>
        /// 棋譜読込み
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnReadKifu_Click(object sender, EventArgs e)
        {
            this.btnReadKifu.Enabled = false;
            this.LearningForm.ReadKifu(this);

            this.LearningForm.ShowSasiteList(this, OwataMinister.LEARNER);
            
        }

        /// <summary>
        /// [一手指す]ボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSasu_Click(object sender, EventArgs e)
        {
            //
            // イベントハンドラー登録
            //
            OwataMinister.LEARNER.Dlgt_OnLog1Append_or_Null = (string log)=>
            {
                this.txtIttesasuLog.Text += log;
            };
            OwataMinister.LEARNER.Dlgt_OnLog1Clear_or_Null = () =>
            {
                this.txtIttesasuLog.Text = "";
            };
            OwataMinister.LEARNER.Dlgt_OnLog2Append_or_Null = (string log) =>
            {
                this.txtNaibuData.Text += log;
            };
            OwataMinister.LEARNER.Dlgt_OnLog2Clear_or_Null = () =>
            {
                this.txtNaibuData.Text = "";
            };

            this.LearningForm.OnIttesasuBtnClick(
                this,
                OwataMinister.LEARNER
            );
            OwataMinister.LEARNER.Dlgt_OnLog1Append_or_Null = null;
        }

        private void Uc_Main_Load(object sender, EventArgs e)
        {
            this.LearningForm.AtBegin(this);
        }

        private void btnOpenCsa_Click(object sender, EventArgs e)
        {
            this.openCsaFileDialog1.InitialDirectory = Path.GetDirectoryName(Application.StartupPath);
            DialogResult result = this.openCsaFileDialog1.ShowDialog();
            switch(result)
            {
                case DialogResult.OK:
                    this.TxtKifuFilepath.Text = this.openCsaFileDialog1.FileName;
                    this.btnReadKifu.Enabled = true;
                    break;
                default:
                    break;
            }
        }

        /// <summary>
        /// fv.csvを開くボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnOpenFvCsv_Click(object sender, EventArgs e)
        {
            if ("" != this.TxtFvFilepath.Text)
            {
                this.openFvFileDialog2.InitialDirectory = Path.GetDirectoryName( this.TxtFvFilepath.Text);
                this.openFvFileDialog2.FileName = Path.GetFileName(this.TxtFvFilepath.Text);
            }
            else
            {
                this.openFvFileDialog2.InitialDirectory = Application.StartupPath;
            }

            DialogResult result = this.openFvFileDialog2.ShowDialog();
            switch (result)
            {
                case DialogResult.OK:
                    // フィーチャー・ベクター
                    this.TxtFvFilepath.Text = this.openFvFileDialog2.FileName;
                    if (!this.LearningForm.Fv.Make_FromFile(this.TxtFvFilepath.Text))
                    {
                        this.TxtStatus1.Text = "ファイルオープン失敗 Fv。";
                        goto gt_EndMethod;
                    }
                    this.TxtStatus1.Text = "開fv。";

                    if (!this.LearningForm.Fv.Make_FromFile_KK(Path.GetDirectoryName(this.TxtFvFilepath.Text) + "/fv_KK.csv"))
                    {
                        this.TxtStatus1.Text = "ファイルオープン失敗 fv_KK。";
                        goto gt_EndMethod;
                    }
                    this.TxtStatus1.Text += "開fv_KK。";


                    // ついでに、タイアド・ベクター
                    if (!this.LearningForm.Tv.Make_FromFile(Path.GetDirectoryName(this.TxtFvFilepath.Text) + "/tv.csv"))
                    {
                        this.TxtStatus1.Text = "ファイルオープン失敗 Tv。";
                        goto gt_EndMethod;
                    }
                    this.TxtStatus1.Text += "開きました Tv。";

                    // ついでに、リザルト・ベクター
                    if (!this.LearningForm.Rv.Make_FromFile(Path.GetDirectoryName(this.TxtFvFilepath.Text) + "/rv.csv"))
                    {
                        this.TxtStatus1.Text = "ファイルオープン失敗 Rv。";
                        goto gt_EndMethod;
                    }
                    this.TxtStatus1.Text += "開きました Rv。";


                    this.btnUpdateKyokumenHyoka.Enabled = true;

                    break;
                default:
                    break;
            }

        gt_EndMethod:
            ;
        }

        /// <summary>
        /// [FV上書き]ボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnWriteFv_Click(object sender, EventArgs e)
        {
            // フィーチャー・ベクター
            File.WriteAllText(this.txtFvFilepath.Text, Util_FeatureVectorFormat.Format_Text(this.LearningForm.Fv));
            // 
            File.WriteAllText(Path.GetDirectoryName(this.TxtFvFilepath.Text) + "/fv_KK.csv", Util_FeatureVectorFormat.Format_KK(this.LearningForm.Fv));
            // ついでに、タイアド・ベクター
            File.WriteAllText(Path.GetDirectoryName(this.TxtFvFilepath.Text) + "/tv.csv", Util_TiredVectorFormat.Format_Text(this.LearningForm.Tv));
            // ついでに、リザルト・ベクター
            File.WriteAllText(Path.GetDirectoryName(this.TxtFvFilepath.Text) + "/rv.csv", Util_ResultVectorFormat.Format_Text(this.LearningForm.Rv));
        }

        /// <summary>
        /// １手指す前に。[局面評価更新]ボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnUpdateKyokumenHyoka_Click(object sender, EventArgs e)
        {
            //
            // 本譜手
            //
            if (this.LstSasite.Items.Count<1)
            {
                goto gt_EndMethod;
            }
            SasiteListItemImpl item = (SasiteListItemImpl)this.LstSasite.Items[0];
            string sfenSasiteStr = item.Sfen;


            if (sfenSasiteStr == "")
            {
                goto gt_EndMethod;
            }
            this.btnUpdateKyokumenHyoka.Enabled = false;//ボタン連打防止。

            //----------------------------------------
            // 1P は正の数がグッド、2P は負の数がグッド。
            //----------------------------------------
            int badScore = -100;//減点に使われる数字です。
            int goodScore = 0;//加点に使われる数字です。

            int badScore_temp = badScore;
            if (this.LearningForm.Kifu.CurNode.Value.ToKyokumenConst.KaisiPside == Playerside.P2)
            {
                badScore *= -1;//2Pは、負数の方が高得点です。
            }

            //
            // 合法手一覧
            //
            this.LearningForm.Kifu.CurNode.Foreach_ChildNodes((string key, Node<Starbeamable, KyokumenWrapper> node, ref bool toBreak) =>
            {
                // 本譜手はまだ計算しない。
                if (key == sfenSasiteStr)
                {
                    goto gt_NextLoop1;
                }

                Util_Learning.UpdateKyokumenHyoka(
                    node.Value.ToKyokumenConst,
                    this.LearningForm.Fv,
                    this.LearningForm.Tv,
                    this.LearningForm.Rv,
                    badScore
                    );//相手が有利になる点
                goodScore += -badScore;
            gt_NextLoop1:
                ;
            });

            //
            // 本譜手
            //
            if (this.LearningForm.Kifu.CurNode.HasChildNode(sfenSasiteStr))
            {
                Util_Learning.UpdateKyokumenHyoka(
                    this.LearningForm.Kifu.CurNode.GetChildNode(sfenSasiteStr).Value.ToKyokumenConst,
                    this.LearningForm.Fv,
                    this.LearningForm.Tv,
                    this.LearningForm.Rv,
                    goodScore);//自分が有利になる点
            }
            else
            {
                Debug.Fail("指し手[" + sfenSasiteStr + "]に対応する次ノードは作成されていませんでした。\n" + this.LearningForm.DumpToAllGohosyu(this.LearningForm.Kifu.CurNode.Value.ToKyokumenConst));
            }

            gt_EndMethod:
            ;
        }

        /// <summary>
        /// FVを0～999に矯正。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnFv999_999_Click(object sender, EventArgs e)
        {
            Util_Learning.Fv999_999_KK(this.LearningForm.Fv);
            Util_Learning.Fv999_999_KP(this.LearningForm.Fv);
            Util_Learning.Fv999_999_PP(this.LearningForm.Fv);
        }

        /// <summary>
        /// 二駒評価値を調べるボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSiraberuHyokatiNikoma_Click(object sender, EventArgs e)
        {
            KyHyokaMeisai_Koumoku meisaiKoumoku = this.LearningForm.Evaluate((KifuNode)this.LearningForm.Kifu.CurNode);

            this.txtNikomaHyokati.Text = meisaiKoumoku.Score.ToString() + "　" + meisaiKoumoku.Utiwake;
        }

        /// <summary>
        /// [指し手の順位下げ]ボタン。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSasiteRankDown_Click(object sender, EventArgs e)
        {
            // 評価値変化量
            int badScore = -100;

            //foreach (int selectedIndex in this.LstGohosyu.SelectedIndices)
            //{
            //    GohosyuListItem item = (GohosyuListItem)this.LstGohosyu.Items[selectedIndex];

            //----------------------------------------
            // 選択したノードを参考に、減点を行う。
            //----------------------------------------
            foreach (GohosyuListItem item in this.LstGohosyu.SelectedItems)
            {
                string sfenSasiteStr = item.Sfen;
                System.Console.WriteLine("sfenSasiteStr=" + sfenSasiteStr);

                if (this.LearningForm.Kifu.CurNode.HasChildNode(sfenSasiteStr))
                {
#if DEBUG
                    System.Console.WriteLine("----------------------------------------");
                    System.Console.WriteLine("FV 総合点（読込前）");
                    System.Console.WriteLine("    KK =" + this.LearningForm.Fv.GetTotal_KK());
                    System.Console.WriteLine("    KP =" + this.LearningForm.Fv.GetTotal_KP());
                    System.Console.WriteLine("    PP =" + this.LearningForm.Fv.GetTotal_PP());
                    System.Console.WriteLine("----------------------------------------");
#endif
                    Node<Starbeamable, KyokumenWrapper> nextNode = this.LearningForm.Kifu.CurNode.GetChildNode(sfenSasiteStr);
                    Util_Learning.UpdateKyokumenHyoka(
                        nextNode.Value.ToKyokumenConst,
                        this.LearningForm.Fv,
                        this.LearningForm.Tv,
                        this.LearningForm.Rv,
                        badScore
                        );//相手が有利になる点
#if DEBUG
                    System.Console.WriteLine("----------------------------------------");
                    System.Console.WriteLine("FV 総合点（読込後）");
                    System.Console.WriteLine("    KK =" + this.LearningForm.Fv.GetTotal_KK());
                    System.Console.WriteLine("    KP =" + this.LearningForm.Fv.GetTotal_KP());
                    System.Console.WriteLine("    PP =" + this.LearningForm.Fv.GetTotal_PP());
                    System.Console.WriteLine("----------------------------------------");
#endif
                }
            }

            //----------------------------------------
            // 点数を付け直すために、ノードを一旦、全削除
            //----------------------------------------
            this.LearningForm.Kifu.CurNode.Clear_ChildNodes();

            //----------------------------------------
            // ネクスト・ノードを再作成
            //----------------------------------------
            // TODO:本譜のネクスト・ノードは？
            this.LearningForm.Make_GohosyuList( this.LearningForm.Kifu.CurNode.Key, OwataMinister.LEARNER);

            // 現局面を表示
            this.LearningForm.ShowGohosyu(this, OwataMinister.LEARNER);
        }

        
    }
}
